/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


#line 726 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    STATES = 373,
    FILTERS = 374,
    RECEIVE = 375,
    ACTION = 376,
    WARN = 377,
    BLOCK = 378,
    DISABLE = 379,
    KEEP = 380,
    FILTERED = 381,
    PASSWORD = 382,
    FROM = 383,
    PASSIVE = 384,
    TO = 385,
    EVENTS = 386,
    PACKETS = 387,
    PROTOCOLS = 388,
    INTERFACES = 389,
    ALGORITHM = 390,
    KEYED = 391,
    HMAC = 392,
    MD5 = 393,
    SHA1 = 394,
    SHA256 = 395,
    SHA384 = 396,
    SHA512 = 397,
    PRIMARY = 398,
    STATS = 399,
    COUNT = 400,
    FOR = 401,
    COMMANDS = 402,
    PREEXPORT = 403,
    NOEXPORT = 404,
    GENERATE = 405,
    ROA = 406,
    LISTEN = 407,
    BGP = 408,
    V6ONLY = 409,
    DUAL = 410,
    ADDRESS = 411,
    PASSWORDS = 412,
    DESCRIPTION = 413,
    SORTED = 414,
    RELOAD = 415,
    IN = 416,
    OUT = 417,
    MRTDUMP = 418,
    MESSAGES = 419,
    RESTRICT = 420,
    MEMORY = 421,
    IGP_METRIC = 422,
    CLASS = 423,
    DSCP = 424,
    WAIT = 425,
    MAX = 426,
    FLUSH = 427,
    AS = 428,
    SHOW = 429,
    STATUS = 430,
    SUMMARY = 431,
    ROUTE = 432,
    SYMBOLS = 433,
    ADD = 434,
    DELETE = 435,
    DUMP = 436,
    RESOURCES = 437,
    SOCKETS = 438,
    NEIGHBORS = 439,
    ATTRIBUTES = 440,
    EVAL = 441,
    ECHO = 442,
    ENABLE = 443,
    FUNCTION = 444,
    PRINT = 445,
    PRINTN = 446,
    UNSET = 447,
    RETURN = 448,
    ACCEPT = 449,
    REJECT = 450,
    QUITBIRD = 451,
    INT = 452,
    BOOL = 453,
    IP = 454,
    PREFIX = 455,
    PAIR = 456,
    QUAD = 457,
    EC = 458,
    LC = 459,
    SET = 460,
    STRING = 461,
    BGPMASK = 462,
    BGPPATH = 463,
    CLIST = 464,
    ECLIST = 465,
    LCLIST = 466,
    IF = 467,
    THEN = 468,
    ELSE = 469,
    CASE = 470,
    TRUE = 471,
    FALSE = 472,
    RT = 473,
    RO = 474,
    UNKNOWN = 475,
    GENERIC = 476,
    GW = 477,
    NET = 478,
    MASK = 479,
    PROTO = 480,
    SOURCE = 481,
    SCOPE = 482,
    CAST = 483,
    DEST = 484,
    IFNAME = 485,
    IFINDEX = 486,
    LEN = 487,
    DEFINED = 488,
    CONTAINS = 489,
    RESET = 490,
    PREPEND = 491,
    FIRST = 492,
    LAST = 493,
    LAST_NONAGGREGATED = 494,
    MATCH = 495,
    ROA_CHECK = 496,
    EMPTY = 497,
    WHERE = 498,
    BFD = 499,
    MIN = 500,
    IDLE = 501,
    RX = 502,
    TX = 503,
    INTERVAL = 504,
    MULTIPLIER = 505,
    MULTIHOP = 506,
    NEIGHBOR = 507,
    DEV = 508,
    LOCAL = 509,
    AUTHENTICATION = 510,
    SIMPLE = 511,
    METICULOUS = 512,
    SESSIONS = 513,
    HOLD = 514,
    CONNECT = 515,
    RETRY = 516,
    KEEPALIVE = 517,
    STARTUP = 518,
    VIA = 519,
    NEXT = 520,
    HOP = 521,
    SELF = 522,
    DEFAULT = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    CEASE = 571,
    HIT = 572,
    ADMINISTRATIVE = 573,
    SHUTDOWN = 574,
    PEER = 575,
    CONFIGURATION = 576,
    CHANGE = 577,
    DECONFIGURED = 578,
    CONNECTION = 579,
    REJECTED = 580,
    COLLISION = 581,
    OF = 582,
    OSPF = 583,
    AREA = 584,
    OSPF_METRIC1 = 585,
    OSPF_METRIC2 = 586,
    OSPF_TAG = 587,
    OSPF_ROUTER_ID = 588,
    RFC1583COMPAT = 589,
    STUB = 590,
    TICK = 591,
    COST = 592,
    COST2 = 593,
    RETRANSMIT = 594,
    HELLO = 595,
    TRANSMIT = 596,
    PRIORITY = 597,
    DEAD = 598,
    TYPE = 599,
    BROADCAST = 600,
    BCAST = 601,
    NONBROADCAST = 602,
    NBMA = 603,
    POINTOPOINT = 604,
    PTP = 605,
    POINTOMULTIPOINT = 606,
    PTMP = 607,
    STRICT = 608,
    CRYPTOGRAPHIC = 609,
    ELIGIBLE = 610,
    POLL = 611,
    NETWORKS = 612,
    HIDDEN = 613,
    VIRTUAL = 614,
    ONLY = 615,
    BUFFER = 616,
    LARGE = 617,
    NORMAL = 618,
    STUBNET = 619,
    TAG = 620,
    EXTERNAL = 621,
    LSADB = 622,
    ECMP = 623,
    WEIGHT = 624,
    NSSA = 625,
    TRANSLATOR = 626,
    STABILITY = 627,
    GLOBAL = 628,
    LSID = 629,
    INSTANCE = 630,
    REAL = 631,
    NETMASK = 632,
    LENGTH = 633,
    LSA = 634,
    SUPPRESSION = 635,
    TOPOLOGY = 636,
    STATE = 637,
    PIPE = 638,
    MODE = 639,
    OPAQUE = 640,
    TRANSPARENT = 641,
    RADV = 642,
    RA = 643,
    MANAGED = 644,
    OTHER = 645,
    CONFIG = 646,
    LINGER = 647,
    MTU = 648,
    REACHABLE = 649,
    RETRANS = 650,
    TIMER = 651,
    CURRENT = 652,
    VALID = 653,
    PREFERRED = 654,
    MULT = 655,
    LIFETIME = 656,
    SKIP = 657,
    ONLINK = 658,
    AUTONOMOUS = 659,
    RDNSS = 660,
    DNSSL = 661,
    NS = 662,
    DOMAIN = 663,
    TRIGGER = 664,
    SENSITIVE = 665,
    LOW = 666,
    MEDIUM = 667,
    HIGH = 668,
    PROPAGATE = 669,
    RA_PREFERENCE = 670,
    RA_LIFETIME = 671,
    RIP = 672,
    INFINITY = 673,
    UPDATE = 674,
    GARBAGE = 675,
    MULTICAST = 676,
    VERSION = 677,
    SPLIT = 678,
    HORIZON = 679,
    POISON = 680,
    REVERSE = 681,
    ZERO = 682,
    PLAINTEXT = 683,
    RIP_METRIC = 684,
    RIP_TAG = 685,
    STATIC = 686,
    PROHIBIT = 687,
    MULTIPATH = 688,
    BLACKHOLE = 689,
    UNREACHABLE = 690,
    BABEL = 691,
    RXCOST = 692,
    WIRED = 693,
    WIRELESS = 694,
    BABEL_METRIC = 695,
    ENTRIES = 696
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 655 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1237 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1254 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  73
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3728

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  463
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  320
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1086
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2060

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   696

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     454,   455,    29,    27,   459,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   456,   453,
      23,    22,    24,   460,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   461,     2,   462,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   457,     2,   458,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   867,   867,   868,   871,   873,   881,   890,   891,   892,
     899,   900,   901,   909,   910,   911,   912,   913,   914,   920,
     921,   928,   929,   933,   940,   941,   945,   949,   956,   964,
     965,   972,   973,   977,   978,   984,   993,   994,   998,  1003,
    1004,  1008,  1009,  1013,  1014,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1032,  1033,  1043,  1044,  1045,  1046,
    1049,  1050,  1051,  1052,  1053,  1054,  1058,  1064,  1065,  1066,
    1067,  1075,  1078,  1085,  1088,  1091,  1094,  1098,  1099,  1103,
    1104,  1105,  1113,  1118,  1119,  1123,  1124,  1128,  1135,  1136,
    1137,  1149,  1154,  1158,  1172,  1173,  1187,  1188,  1192,  1193,
    1194,  1195,  1202,  1216,  1218,  1220,  1224,  1225,  1226,  1227,
    1232,  1238,  1239,  1243,  1251,  1255,  1257,  1263,  1264,  1271,
    1272,  1276,  1282,  1286,  1295,  1304,  1306,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,
    1326,  1327,  1328,  1329,  1333,  1334,  1335,  1336,  1337,  1341,
    1347,  1351,  1359,  1360,  1368,  1376,  1377,  1378,  1382,  1383,
    1387,  1392,  1393,  1397,  1399,  1407,  1411,  1412,  1418,  1425,
    1426,  1427,  1428,  1432,  1440,  1446,  1447,  1448,  1452,  1453,
    1457,  1458,  1459,  1460,  1461,  1462,  1468,  1469,  1470,  1474,
    1475,  1479,  1480,  1486,  1487,  1490,  1492,  1496,  1497,  1501,
    1521,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1529,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1548,
    1551,  1554,  1557,  1561,  1562,  1565,  1568,  1572,  1576,  1581,
    1587,  1594,  1599,  1604,  1609,  1613,  1617,  1621,  1630,  1638,
    1642,  1649,  1650,  1651,  1656,  1660,  1667,  1674,  1678,  1686,
    1687,  1688,  1693,  1697,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1711,  1716,  1724,  1731,  1738,  1746,  1748,  1750,  1752,
    1754,  1756,  1758,  1760,  1763,  1767,  1773,  1774,  1775,  1779,
    1780,  1786,  1788,  1790,  1792,  1794,  1796,  1800,  1804,  1807,
    1811,  1812,  1813,  1817,  1818,  1819,  1827,  1827,  1837,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1877,  1888,  1889,  1896,  1897,  1904,
    1913,  1917,  1921,  1942,  1943,  1947,  1959,  1959,  1975,  1976,
    1979,  1980,  1984,  1987,  1996,  2009,  2010,  2011,  2012,  2013,
    2017,  2025,  2026,  2027,  2028,  2029,  2033,  2036,  2037,  2038,
    2039,  2040,  2041,  2042,  2043,  2044,  2045,  2050,  2051,  2052,
    2053,  2057,  2058,  2059,  2063,  2064,  2065,  2066,  2067,  2068,
    2069,  2070,  2075,  2076,  2077,  2078,  2079,  2083,  2084,  2085,
    2086,  2087,  2091,  2092,  2096,  2097,  2101,  2108,  2109,  2110,
    2111,  2118,  2119,  2122,  2123,  2130,  2142,  2143,  2147,  2148,
    2152,  2153,  2154,  2155,  2156,  2157,  2161,  2162,  2163,  2167,
    2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,  2176,  2180,
    2181,  2182,  2183,  2193,  2197,  2219,  2231,  2232,  2233,  2234,
    2235,  2236,  2237,  2238,  2239,  2240,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2262,  2263,  2264,  2266,  2268,  2270,  2272,
    2273,  2274,  2275,  2276,  2277,  2287,  2288,  2289,  2290,  2291,
    2292,  2293,  2294,  2296,  2297,  2300,  2322,  2323,  2324,  2325,
    2326,  2327,  2331,  2334,  2335,  2336,  2344,  2350,  2358,  2359,
    2363,  2368,  2376,  2384,  2389,  2393,  2399,  2403,  2408,  2409,
    2410,  2417,  2418,  2419,  2420,  2421,  2427,  2439,  2440,  2441,
    2442,  2445,  2447,  2451,  2455,  2469,  2489,  2490,  2491,  2492,
    2493,  2494,  2495,  2496,  2500,  2501,  2502,  2503,  2504,  2505,
    2508,  2510,  2513,  2515,  2519,  2522,  2527,  2528,  2529,  2533,
    2534,  2538,  2539,  2542,  2561,  2567,  2592,  2594,  2595,  2600,
    2601,  2605,  2606,  2610,  2611,  2612,  2613,  2614,  2615,  2616,
    2617,  2618,  2622,  2623,  2624,  2625,  2626,  2627,  2633,  2634,
    2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,  2643,  2644,
    2645,  2646,  2647,  2648,  2649,  2650,  2651,  2652,  2653,  2654,
    2655,  2656,  2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,
    2665,  2666,  2667,  2668,  2669,  2670,  2671,  2672,  2678,  2679,
    2680,  2681,  2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,
    2690,  2691,  2692,  2693,  2704,  2714,  2715,  2719,  2720,  2721,
    2722,  2723,  2724,  2725,  2726,  2727,  2730,  2745,  2748,  2750,
    2754,  2755,  2756,  2757,  2758,  2759,  2760,  2761,  2762,  2763,
    2763,  2764,  2764,  2765,  2766,  2767,  2771,  2772,  2776,  2784,
    2786,  2790,  2791,  2792,  2796,  2797,  2800,  2802,  2805,  2806,
    2807,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,  2818,
    2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,
    2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,
    2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,
    2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,  2876,  2879,
    2881,  2884,  2886,  2895,  2897,  2898,  2901,  2903,  2907,  2908,
    2911,  2921,  2942,  2944,  2948,  2948,  2951,  2953,  2956,  2958,
    2962,  2967,  2970,  2973,  2978,  2981,  2986,  2989,  2993,  2997,
    3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,  3013,  3020,
    3021,  3022,  3027,  3028,  3034,  3044,  3045,  3046,  3047,  3047,
    3048,  3048,  3049,  3054,  3057,  3059,  3063,  3067,  3090,  3091,
    3092,  3093,  3094,  3095,  3096,  3097,  3098,  3099,  3104,  3108,
    3109,  3110,  3111,  3112,  3113,  3113,  3114,  3114,  3115,  3116,
    3120,  3121,  3122,  3125,  3163,  3165,  3168,  3170,  3174,  3177,
    3190,  3191,  3192,  3193,  3197,  3204,  3212,  3214,  3217,  3219,
    3223,  3227,  3237,  3242,  3243,  3244,  3248,  3260,  3262,  3266,
    3267,  3271,  3284,  3289,  3290,  3291,  3295,  3307,  3309,  3313,
    3314,  3319,  3320,  3324,  3325,  3332,  3345,  3346,  3347,  3348,
    3349,  3352,  3354,  3358,  3362,  3385,  3415,  3416,  3417,  3418,
    3419,  3420,  3421,  3425,  3426,  3427,  3428,  3429,  3430,  3431,
    3432,  3433,  3434,  3435,  3436,  3437,  3438,  3439,  3440,  3441,
    3442,  3446,  3447,  3448,  3449,  3452,  3454,  3457,  3459,  3463,
    3469,  3472,  3479,  3486,  3487,  3488,  3489,  3490,  3493,  3503,
    3512,  3516,  3522,  3523,  3527,  3532,  3538,  3541,  3546,  3547,
    3548,  3549,  3550,  3554,  3555,  3558,  3560,  3563,  3565,  3569,
    3575,  3582,  3583,  3586,  3588,  3592,  3596,  3609,  3632,  3633,
    3634,  3635,  3636,  3637,  3638,  3639,  3640,  3641,  3642,  3643,
    3646,  3648,  3651,  3653,  3658,  3663,  3666,  3669,  3676,  3676,
    3676,  3676,  3676,  3676,  3676,  3676,  3676,  3676,  3676,  3676,
    3676,  3676,  3676,  3676,  3677,  3677,  3677,  3677,  3677,  3677,
    3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,
    3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,
    3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,
    3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,  3677,
    3677,  3677,  3677,  3677,  3677,  3677,  3678,  3678,  3678,  3678,
    3678,  3678,  3678,  3678,  3678,  3678,  3678,  3679,  3679,  3679,
    3679,  3680,  3680,  3680,  3681,  3681,  3681,  3681,  3681,  3681,
    3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,
    3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,  3681,
    3681,  3681,  3681,  3681,  3681,  3682,  3682,  3683,  3684,  3685,
    3686,  3687,  3688,  3689,  3690,  3691,  3692,  3693,  3694,  3694,
    3694,  3694,  3694,  3694,  3694,  3694,  3694
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "OSPF",
  "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "LINGER",
  "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED",
  "MULT", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL",
  "NS", "DOMAIN", "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH",
  "PROPAGATE", "RA_PREFERENCE", "RA_LIFETIME", "RIP", "INFINITY", "UPDATE",
  "GARBAGE", "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON",
  "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "BABEL", "RXCOST",
  "WIRED", "WIRELESS", "BABEL_METRIC", "ENTRIES", "';'", "'('", "')'",
  "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept", "config",
  "conf_entries", "definition", "expr", "expr_us", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime", "text",
  "opttext", "text_or_none", "log_config", "syslog_name", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_mp_limit", "kern_item",
  "kif_proto_start", "kif_item", "kern_sys_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "gr_opts", "tab_sorted", "newtab",
  "roa_table_start", "roa_table_opts", "roa_table", "proto_start",
  "proto_name", "proto_item", "imexport", "limit_action", "limit_spec",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_list_nopx", "iface_patt_init",
  "iface_patt", "tos", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "password_algorithm", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "cnum", "pair_item", "ec_kind", "ec_item", "lc_item",
  "set_item", "switch_item", "set_items", "switch_items", "fprefix_s",
  "fprefix", "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag",
  "bgp_proto", "ospf_proto_start", "ospf_proto", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,    59,    40,    41,    58,   123,   125,    44,
      63,    91,    93
};
# endif

#define YYPACT_NINF -1567

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1567)))

#define YYTABLE_NINF -489

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      45,  1395,   147,   765,   771,   836,   226,   771,   771,   631,
     771,   321,   -59,  1568,   194,   228,  1608,  2082,   138,   771,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,   405,   636,   397,   796,   579,
     117,   442,   439, -1567, -1567,   542,   362,   421,   133,  2082,
     582, -1567, -1567, -1567, -1567, -1567, -1567,   202,   202, -1567,
   -1567, -1567, -1567,   171, -1567,  3008, -1567,   202,  3256, -1567,
   -1567, -1567,   202, -1567,   202,  2952,   202,  3013,   202,  3270,
     202, -1567,   202, -1567,   202,  3209,   202, -1567, -1567, -1567,
    2777,  1862, -1567, -1567, -1567,   149, -1567,   621,   649,   657,
     621,   612, -1567,   673,   673,   771,   771,   725,   221, -1567,
     693,   782,   210, -1567,   734,   785, -1567, -1567,   567,   261,
      74,   819,   -60,   688,   688,   843,   849,   851,   872,   884,
     890,   894,   900,    44, -1567, -1567, -1567,   830,   484, -1567,
     694,    30,    32,  2082, -1567,   529,   531,   536, -1567, -1567,
     544,   551,   584,  1231,   140, -1567, -1567, -1567, -1567, -1567,
    2483, -1567,  2983, -1567, -1567,  1458,  1030,   673,  1039, -1567,
   -1567,  1000, -1567, -1567,    -2,   273,   149,   340, -1567, -1567,
   -1567, -1567,   568,   623,   340,   340,   898,   934,   145, -1567,
    1081, -1567,   221,   654,  3464, -1567,   972,  1100,   666,   678,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567,   682,   149,   820,  1130,  1036,   340,   416, -1567,
     768,   651,   777,  1086,   777,   221, -1567,   715,   727,   726,
     730,    77,   867,  1112,   746,  1181,   922,   777,   416,  1133,
    1122,   105,  1044,   416,   177,   688,   204,  1137,   528,  1138,
     947,   945,   626,  1139,   942,   628,   929,   927,   416,   928,
     925,   923,   930,   -67,  1145,   919,   926,   416,   304,   416,
   -1567,   786,   781,   866,   310,   416,  1124,   340,   416,  1128,
   -1567, -1567,   800,   803, -1567,   812,  1171,   635, -1567,   817,
     814,   815,   818,   951,   688,  1190, -1567,   834,   330,   831,
     833,  1205,   416,  1223,   416,  1219,  1220,  1218,   340, -1567,
     858,   860,   861,  1234,   673, -1567,   874,   875, -1567, -1567,
     611,  1312,   612, -1567, -1567,  1313,   340,  1327, -1567,  1328,
    1340,  1342,  1343, -1567, -1567, -1567,   318,  1349,  1316,  1351,
   -1567, -1567,  1016,  1353, -1567,  1363,   804, -1567, -1567,  3451,
     706,   819, -1567,   819,   819, -1567,   480,   525,  1366,   819,
     819,  1368,   819,   819,   819, -1567, -1567,     4,  1191,  1195,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,    31, -1567,
      44,  2082,    44,    44,  1358, -1567,  1364,   976,  1357,   172,
    1350,    32,    32,  1356,  1347,  2082,  2082,  2082,  2082,  2082,
    1369, -1567, -1567,  1372, -1567,   935,    72, -1567, -1567, -1567,
   -1567,  1065, -1567,  1386, -1567, -1567, -1567, -1567,   407,    82,
   -1567,   461, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,  2082,  2082,
    2082,  2082,  2082,  2082,  2082,  2082,  2082,  2082,  2082,  2082,
    2082,  2082,   986, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567,   589, -1567, -1567,  1392,  1394,  2082,   777, -1567,
   -1567,  1458,   953, -1567, -1567, -1567, -1567, -1567, -1567,   340,
    2082, -1567, -1567, -1567, -1567,   340,   981,   990, -1567,   918,
   -1567, -1567,   340, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
    2082,   956,  3460, -1567,   426,   958, -1567,   950,  1393, -1567,
   -1567, -1567,  -114, -1567, -1567,   416, -1567, -1567,   310, -1567,
   -1567, -1567, -1567,    56,  2892, -1567,  1276,  2082, -1567, -1567,
      56, -1567, -1567,    56, -1567, -1567, -1567, -1567, -1567, -1567,
    1338,  1339,   416,   135, -1567,   964,    42,   965,   967,   340,
     180,  1125,   416,  1257,   688,   982, -1567,   985,  1403,    92,
     340,  1255,   340,  1367,  1370,   340,  1371,     0,   340,   340,
     416,  1377,   989,  1348,  1002,   416,  1004,   416,   465,   416,
    1130,   416,  1011,  1015,   416,   416,   416,  1018,  1285,   416,
    1029, -1567, -1567,   416, -1567, -1567,   416, -1567,  1405,   340,
   -1567, -1567, -1567,  1465,  1032,  1033, -1567, -1567, -1567, -1567,
     416, -1567,  1130, -1567, -1567,   991, -1567,   688, -1567,  1215,
   -1567, -1567, -1567,  1040, -1567,   340, -1567,   340, -1567,   416,
     416,   416, -1567, -1567, -1567, -1567,   340,   688, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567,   630, -1567, -1567,  1492,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,   632,
   -1567, -1567, -1567, -1567,  1494, -1567, -1567, -1567,  1479, -1567,
   -1567,  1484,   688, -1567, -1567,  1482,  1483, -1567,  2892, -1567,
   -1567, -1567, -1567,   688, -1567, -1567, -1567,  1495, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567,  1514,  1498,  1498,
    1096,   819,  1498,   819,  1498, -1567,  1498,  1498, -1567,  1498,
    1498,  1498,   340,   688, -1567,  1505,  1507,  1508, -1567, -1567,
     944, -1567, -1567, -1567, -1567,   179, -1567,  1070, -1567,  1274,
    1509, -1567, -1567, -1567, -1567,   216,   353,   554,  1149,   659,
      83, -1567,  2082, -1567,  2082,  1079,    24,  1083,  1256,   390,
     533, -1567, -1567, -1567,  1530,  1528, -1567,  3140,  3140,  3140,
    3630,  3630,  3140,  3140,  3140,  3140,  3140,   644,   644,  1347,
    1347, -1567,  1093, -1567, -1567, -1567, -1567, -1567,  1458, -1567,
   -1567,  2591, -1567,   655, -1567, -1567,  1296,  1532, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,  1097, -1567,  1101,  1810, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567,   142,  1102,  1103, -1567, -1567,   340,
   -1567, -1567,   688, -1567, -1567, -1567,  1976,  3460, -1567,   688,
   -1567,  1106, -1567,  1525, -1567,  1108, -1567,  1429, -1567, -1567,
   -1567, -1567,   416,  3464, -1567, -1567,  1408,   340,   340,  1115,
     340,  1117,  1119, -1567,   416,    51, -1567, -1567,  1120,  1121,
    1123,  1126,   416,  1131,   416,  1136, -1567, -1567,  1546, -1567,
     340,   340, -1567,  1143,   340,  1146,   340,   340,  1150,   340,
    1152,  1154,  1159,  1160,  1161,   340, -1567,   310, -1567,  1162,
   -1567,  1163,  1176,  1177,  1178,  1179,  1184,  1193, -1567, -1567,
    1196,  1201,  1203, -1567,   241,  1204, -1567, -1567, -1567,   340,
   -1567,  1021,  1206, -1567, -1567,  3158,  1216,  1207,  1210, -1567,
    1403, -1567,   688,  -107,  1215,  1421, -1567,  2007, -1567, -1567,
   -1567, -1567,  1521, -1567,     4, -1567, -1567, -1567,   611, -1567,
   -1567,   318, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567,  1580,  1588, -1567, -1567,   310, -1567, -1567,
     310,  1619, -1567,   310,  1498,  1663,  1498,  1664,  1669,  1670,
    1672,  1674,  1676, -1567, -1567,  1497,  1504,    44, -1567,  2082,
   -1567,  1661,  1662,  2082,  2082,  2082, -1567,  2082, -1567,  2082,
     689,   116,  1623,  2082,  1745,  2082, -1567, -1567,  2082, -1567,
   -1567,  1235,   830, -1567,  2082, -1567, -1567, -1567, -1567, -1567,
   -1567,  1108, -1567, -1567, -1567, -1567,  3460,  1222, -1567, -1567,
   -1567,  1240,  1244, -1567,  1513, -1567, -1567,  1035, -1567,   478,
   -1567, -1567, -1567, -1567,   688, -1567, -1567,  1247,  1242,  1249,
   -1567,  1250, -1567, -1567,  1251,   857, -1567,  1252, -1567, -1567,
   -1567, -1567,  1254, -1567,  1261, -1567, -1567,   209, -1567, -1567,
   -1567,  1262, -1567,  1263,  1264, -1567,  1266, -1567, -1567, -1567,
   -1567, -1567,  1273,  1283, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567,  1286, -1567, -1567, -1567,
     416,    63,   195, -1567,  1385,   688, -1567, -1567,   379, -1567,
    1287, -1567,  1352, -1567, -1567,   688, -1567, -1567,   688,  1665,
   -1567, -1567,  1288, -1567,   416,   340, -1567, -1567,  1289, -1567,
   -1567, -1567,  1403,   416,   340,  -107,    35, -1567,  1725, -1567,
   -1567,  1294,  2082, -1567, -1567, -1567,  2082,  2082,   416, -1567,
    2483,  1302,  1705, -1567, -1567, -1567, -1567, -1567,  1315,   340,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,  1763,
   -1567,  1767, -1567, -1567, -1567, -1567, -1567, -1567,  1756,  1764,
   -1567, -1567,  1750, -1567,  2039,  2201,  2233,  2259,   722,  2082,
   -1567,  2082,   148,     7,  3464,  1321,   406,     8,  1323,  1256,
    1769,  2289, -1567,  1331,   100, -1567,  3460, -1567,  1784,   688,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,  1354,
   -1567,    10, -1567, -1567,   340, -1567, -1567, -1567,  1462,  1740,
   -1567,   256,  1478,  1491,   733,   658, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567,   340,   340,   416,   340, -1567,  1359,   310, -1567, -1567,
    1360,  1373,   340, -1567, -1567,   340,  1384, -1567, -1567, -1567,
    1387, -1567,   103,    19, -1567,   416, -1567, -1567, -1567,  1746,
   -1567, -1567, -1567, -1567, -1567,  2082,   976,  2082, -1567,  2617,
    2806,   907,  1374,  1804,   214, -1567,  3464,  1383,  1375, -1567,
   -1567, -1567, -1567, -1567, -1567,   693,   693,  1801, -1567, -1567,
   -1567, -1567,  2082,  2338,  2366, -1567,  1816,  2082, -1567,  1778,
   -1567,  1817,  2082,  1841,  1898,  1926,  1391, -1567, -1567, -1567,
   -1567,  1679, -1567,  1108,  1354, -1567, -1567,  1834,   777,  1599,
    1415,  1680,  1541, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
     857,  1108,  1417, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567,  1419, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567,  1420,   340,  2643,  1423,
    2669,  2867, -1567,   924, -1567, -1567,  2082,  2082,   754,  1705,
   -1567,  1424,  1869,  1879, -1567,  2392, -1567, -1567,  1428,  1430,
     427,    25,  1431,   430,  1433,  1434,    26,  1435,    33, -1567,
    1873, -1567,   758, -1567, -1567, -1567,   688,  1622, -1567, -1567,
   -1567, -1567,  1352, -1567, -1567,    43,   -73,    49,  1332, -1567,
   -1567,   463, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567,  1436,  1222,  1667, -1567,    36,  2723,  2774,  1440,  1443,
    1445,  1446,  1448, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567,  1874,  2082, -1567, -1567, -1567,  1876,  2082, -1567,
    2082,  1895, -1567,  2082, -1567,  1453, -1567,   777,   416,  1452,
     863,  1651,   340,   340,   696, -1567, -1567, -1567,  1455,  1466,
   -1567,   416, -1567, -1567,  3193, -1567, -1567, -1567,   268,   416,
     340,   416, -1567,  1468, -1567,   340,   300,   340,   340,  1641,
     267, -1567, -1567,  1471,  3226, -1567,  1517,  1519,   416,   416,
     416, -1567,  1481,   205,   347,  2620, -1567,  1485,  1489,   924,
     114, -1567, -1567, -1567,  1065, -1567, -1567,  1933, -1567, -1567,
   -1567, -1567,   541, -1567, -1567,  2082,  2082,  2082,  2082, -1567,
     591, -1567,  1496,  1506,  1510,  1500,  1511,  1516,  1512, -1567,
   -1567, -1567,  1812,  1700,  1702,  1703, -1567, -1567, -1567,   988,
   -1567,  1824, -1567,   995, -1567, -1567,  1652,   340,  1520,   416,
    1592,   417,   373,  1656,   416,  1586,   416,   340,   340,   340,
    1697,   340,   270,  1499,  1596,  1627,   340,  1600,  1632, -1567,
   -1567,  1538, -1567,   340,  1542, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,   340,   340, -1567, -1567,  1601,
      61,    46,   -85,   -46,  1594,   416,  1597,  1925,  1595,  1726,
    1739,  1742, -1567,  1555,   340,   340, -1567, -1567, -1567, -1567,
     372,   688, -1567,  1556,   372,  1991, -1567,  1559,   340,  -139,
    1943,   340,   416,   688,   416,  1648,   429,   -71,  1708,  1643,
    -179,  1945,  1951,   272,  1593,  1603, -1567, -1567,  1576, -1567,
   -1567, -1567, -1567,  2418,   331,   114,   355,  2444,  2473,  2499,
    2529,   340,  1709,  1666,   445,  1773,   714,  1774,   340, -1567,
    1584, -1567, -1567, -1567,  2082, -1567,  2082, -1567,  1585,  1589,
     340,   340,   340, -1567, -1567,   996,   340,  2024,  2024,  1022,
     624,   690,  1587,   416, -1567, -1567, -1567,   160,   340,   340,
     340,   340, -1567, -1567, -1567, -1567,   315, -1567,  1668, -1567,
   -1567, -1567, -1567,   340, -1567,   340, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,   416,   416, -1567,   340,   416,
   -1567, -1567, -1567, -1567, -1567,  1794,   650,  1979,   340,  1980,
   -1567,   340,  1800,   650,   340,   340, -1567,   416,   340,   340,
    2001,   416,   103,   416,    19, -1567,  1650,  1650,   340, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,   416,
     416,   340, -1567, -1567, -1567, -1567,   340,   340,   340, -1567,
   -1567, -1567, -1567, -1567, -1567,   583,   340, -1567, -1567,   340,
     340,   416, -1567,   416,   416, -1567, -1567,  2082, -1567, -1567,
   -1567,  1621,  1625,  1630,  1633, -1567,   416,   340,   340,   340,
   -1567,   340, -1567, -1567,   340, -1567, -1567,  1620,  1617, -1567,
    1812, -1567, -1567, -1567, -1567, -1567,  1634, -1567,  1637,  1638,
     829,  1209,  1639,  2024,  2024,  2024,  2024, -1567, -1567,    89,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567,  1714, -1567,   416,
   -1567, -1567, -1567, -1567, -1567, -1567,   340, -1567, -1567, -1567,
   -1567,   340,  1650,   340, -1567,   340, -1567,  1650, -1567, -1567,
   -1567, -1567,   340, -1567, -1567, -1567, -1567,   416, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567,  1732, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,  2418, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567,  2082, -1567,   995,
     995,   995, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567,   995,  1653,  1654,  1655,  1658, -1567,  1730, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567,  1645, -1567, -1567, -1567, -1567,   995,   995,   995,   995,
   -1567,  1660,  2082, -1567, -1567, -1567, -1567, -1567,  1678, -1567
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,
    1014,  1015,     3,     1,     2,     0,     0,     0,     0,     0,
       0,     0,     0,   119,   120,     0,     0,     0,     0,   423,
       0,   948,   949,   950,   951,   952,   953,   121,   121,   954,
     955,   956,   957,   117,   958,     0,   960,   121,   125,   961,
     962,   963,   121,  1019,   121,   125,   121,   125,   121,   125,
     121,  1023,   121,  1024,   121,   125,   121,  1026,     5,   959,
     125,   125,   290,   292,   291,     0,    78,    77,     0,     0,
      77,    79,    76,    34,    34,     0,     0,     0,     0,   289,
     261,   294,     0,   245,     0,     0,   228,   253,     0,   224,
       0,   224,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   405,   409,   418,   415,   334,   425,   412,
       0,     0,   408,   423,   456,     0,     0,     0,   410,   411,
       0,     0,     0,   423,     0,   413,   414,   422,   454,   455,
       0,   453,     0,   277,   276,     0,   279,    34,     0,    30,
      29,    37,    40,    38,     0,    18,     0,     0,    59,    58,
      57,    56,     0,     0,     0,     0,     0,   111,     0,   296,
       0,   104,     0,     0,   298,   326,   122,     0,     0,     0,
     115,    82,    91,   168,   545,   506,   624,   758,   764,   845,
     892,   920,     0,     0,     0,     0,     0,     0,    18,   173,
       0,     0,     0,     0,     0,     0,  1018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
       0,     0,     0,    18,     0,   546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,    18,
    1020,     0,     0,     0,     0,    18,     0,     0,    18,     0,
    1021,   627,     0,     0,   635,     0,     0,     0,  1022,     0,
       0,     0,     0,     0,     0,     0,  1025,     0,     0,   917,
       0,     0,    18,     0,    18,     0,     0,     0,     0,  1016,
       0,     0,     0,     0,    34,  1017,     0,     0,   176,   175,
       0,     0,    79,    73,    74,     0,    80,     0,    33,     0,
       0,     0,     0,   284,   187,   186,     0,     0,     0,     0,
     293,   295,   294,     0,   225,     0,   249,   220,   219,     0,
       0,   224,   223,   224,   224,   749,   224,   224,     0,   224,
     224,     0,   224,   224,   224,    19,    20,     0,     0,     0,
     272,   268,   273,   269,   266,   267,   270,   271,   405,   425,
     405,   423,   405,   405,     0,   396,     0,   423,     0,     0,
       0,   408,   408,     0,   451,   423,   423,   423,   423,   423,
       0,   357,   358,     0,   360,     0,     0,   335,   338,   336,
     340,   423,   337,   375,   372,   373,   374,   382,     0,   387,
     391,     0,  1065,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,   426,  1064,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1067,  1070,  1069,  1066,  1068,  1071,
    1072,  1073,  1076,  1074,  1075,  1077,  1078,  1079,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,   457,   458,   274,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    43,   280,     0,     0,   423,     0,    39,
      41,     0,     0,     7,     9,    14,    16,    15,    17,     0,
     423,    13,    67,   152,   153,    60,     0,     0,    66,     0,
      69,    70,     0,   112,   113,    98,   100,   101,   102,   164,
     423,     0,   315,   114,     0,     0,    55,     0,     0,   123,
    1027,  1031,     0,   169,   128,    18,   151,   137,     0,   126,
     127,   154,   142,     0,   315,   143,     0,   423,   130,   141,
       0,   131,   136,     0,   139,   129,   170,   171,   511,   562,
       0,     0,    18,    18,   574,     0,     0,     0,     0,     0,
      18,     0,    18,     0,     0,     0,   575,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,    18,
       0,    18,     0,     0,    18,    18,    18,     0,     0,    18,
       0,   563,   625,    18,   636,   628,    18,   633,   630,     0,
     626,   638,   759,     0,     0,     0,   760,   774,   851,   893,
      18,   898,     0,   894,   909,     0,   908,     0,   912,     0,
     910,   911,   915,     0,   923,     0,    85,     0,    87,    18,
      18,    18,    95,  1029,  1030,  1028,     0,     0,  1033,  1032,
     181,   180,   182,   184,   185,   183,     0,   178,   287,     0,
      75,    81,    71,   283,   281,   285,   286,   191,   192,     0,
     189,   288,   262,   265,     0,   221,   226,   244,     0,   251,
     250,     0,     0,   227,   234,     0,     0,   242,   315,   236,
     235,   239,   240,     0,   241,   243,   229,     0,   233,   252,
     260,   254,   257,   258,   256,   259,   255,     0,    32,    32,
       0,   224,    32,   224,    32,   741,    32,    32,   919,    32,
      32,    32,     0,     0,    23,     0,     0,     0,   400,   402,
       0,   403,   404,   398,   386,   486,   489,     0,   465,     0,
       0,   466,   406,   407,   399,     0,     0,     0,     0,     0,
       0,   359,   423,   436,   423,     0,     0,     0,   346,     0,
       0,   416,   388,   389,     0,     0,   417,   448,   446,   444,
     441,   442,   443,   445,   447,   449,   450,   437,   438,   439,
     440,   459,     0,   460,   462,   463,   464,   278,     0,   275,
     282,     0,    36,     0,    35,    68,     0,     0,    62,    63,
      64,    65,    10,    11,    12,     0,   154,     0,     0,    96,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,     0,     0,   297,   319,     0,
     108,   109,     0,   103,   105,    54,     0,   315,   124,     0,
     118,     0,   138,   158,   161,   174,   150,   144,   133,   320,
     321,   140,    18,   322,   134,   132,   125,     0,     0,     0,
       0,     0,     0,   568,    18,    18,   605,   608,     0,     0,
       0,     0,    18,     0,    18,     0,   623,   576,     0,   546,
       0,     0,   566,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   570,     0,   571,     0,
     603,     0,     0,     0,     0,     0,     0,     0,   582,   583,
       0,     0,     0,   610,     0,     0,   606,   632,   629,     0,
     634,     0,     0,   762,   763,   125,   125,     0,     0,   905,
      21,   907,     0,   902,   906,   423,   897,   125,    94,    86,
      88,    89,    83,    92,    25,    24,    93,   177,     0,    72,
     188,     0,   222,   248,   247,   246,   231,   238,   232,   230,
     237,   544,    31,     0,     0,   748,   757,     0,   755,   752,
       0,     0,   750,     0,    32,     0,    32,     0,     0,     0,
       0,     0,     0,    26,    27,     0,     0,   405,   397,   423,
     475,     0,     0,   423,   423,   423,   452,   423,   473,   423,
       0,     0,   423,   423,   423,   423,   339,   334,   423,   376,
     383,     0,     0,   392,   423,    44,     6,    42,     8,    61,
     110,   165,    97,    99,   314,   313,   315,   423,   107,   106,
     324,   317,     0,   327,     0,   172,   159,     0,   154,     0,
     149,   135,   514,   514,     0,   513,   507,     0,     0,     0,
     622,     0,   618,   617,     0,     0,   549,     0,   607,   611,
     612,   613,     0,   601,     0,   591,    22,     0,   547,   548,
     564,     0,   572,     0,     0,   595,     0,   578,   577,   590,
     589,   584,     0,     0,   604,   587,   579,   580,   581,   609,
     620,   586,   585,   621,   588,   615,     0,   614,   631,   731,
      18,     0,    18,   649,     0,     0,   651,   641,    18,   637,
       0,   655,   732,   761,   777,     0,   768,   770,     0,     0,
     776,   765,     0,   854,    18,     0,   853,   846,     0,   895,
     896,   904,    21,    18,     0,   903,     0,   479,     0,   480,
     481,     0,   423,   477,   478,   476,   423,   423,    18,   918,
       0,     0,   423,   913,   916,   926,   925,   921,     0,     0,
      90,   179,   190,   743,   742,   756,   751,   753,   754,     0,
     744,     0,   746,   890,   891,   945,   946,   947,     0,     0,
     401,   487,     0,   467,     0,     0,     0,     0,     0,   423,
     419,   423,     0,     0,   346,     0,     0,     0,     0,     0,
       0,     0,   316,     0,   423,   330,     0,   323,     0,   155,
     156,   160,   162,   147,   145,   146,   148,   154,   508,   532,
     509,   536,   510,   512,     0,   596,   619,   598,     0,     0,
     553,     0,     0,     0,     0,     0,   551,   599,   600,   602,
     567,   565,   594,   593,   573,   592,   569,   616,   154,   654,
     642,     0,     0,    18,     0,   640,     0,     0,   658,   653,
     657,     0,     0,   647,   639,     0,   665,   154,   766,   809,
     818,   767,     0,     0,   772,    18,   775,   154,   850,   847,
     849,   852,   899,   901,   900,   423,   423,   423,   423,     0,
       0,     0,     0,     0,     0,   499,   482,   484,     0,   154,
     922,   924,    84,   745,   747,   261,   261,     0,   472,   470,
     471,   469,   423,     0,     0,   355,     0,   423,   353,   423,
     349,     0,   423,   347,   423,   423,     0,   461,   325,   331,
     318,     0,   157,   163,   532,   530,   515,     0,     0,   539,
       0,     0,     0,   557,   555,   556,   559,   558,   560,   550,
       0,   734,   738,   644,   645,   643,   646,   719,   679,   659,
     719,   648,   733,   666,   806,   816,   815,   822,   821,   829,
     769,   831,   832,   839,   771,   773,   887,     0,     0,     0,
       0,     0,   493,   423,   393,   914,   423,   423,     0,   423,
     498,   942,     0,     0,   468,     0,   420,   421,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   390,
       0,   515,     0,   535,   537,   538,     0,   541,   597,   561,
     554,   552,   732,   736,   740,     0,     0,     0,   668,   804,
     803,     0,   820,   827,   837,   885,   855,   848,   492,   424,
     496,     0,   423,   490,   332,     0,     0,     0,     0,     0,
       0,     0,     0,   485,   940,   927,   263,   264,   474,   370,
     354,   352,     0,   423,   350,   368,   348,     0,   423,   366,
     423,   364,   363,   423,   361,     0,   534,     0,    18,     0,
       0,     0,     0,     0,     0,   533,   523,   194,   198,     0,
     540,    18,   543,   735,     0,   650,   722,   720,   723,    18,
       0,    18,   656,     0,   652,     0,     0,     0,     0,     0,
       0,   664,   678,     0,     0,   808,     0,     0,    18,    18,
      18,   819,     0,   823,   833,     0,   889,     0,     0,   423,
     423,   341,   345,   343,   423,   500,   344,   380,   377,   378,
     379,   384,     0,   495,   494,   423,   423,   423,   423,   501,
     928,   944,     0,     0,     0,     0,     0,     0,     0,   116,
     199,   521,   195,     0,     0,     0,   516,   520,   524,     0,
     525,     0,   522,   200,   531,   542,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   739,
     718,     0,   724,     0,     0,   662,   663,   661,   660,   672,
     675,   676,   677,   670,   669,     0,     0,   673,   667,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
     794,   796,   807,     0,     0,     0,   810,   811,   812,   817,
       0,     0,   826,     0,     0,     0,   836,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   888,   880,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   684,   726,   716,     0,     0,     0,
       0,     0,   711,   705,   706,   707,    18,   717,     0,   700,
     680,   683,   681,     0,   698,     0,   685,   687,   688,   689,
     690,   691,   692,   693,   694,    18,    18,   682,     0,    18,
     737,   725,   721,   671,   674,     0,     0,     0,     0,     0,
     793,     0,     0,     0,     0,     0,   781,    18,     0,     0,
       0,    18,     0,    18,     0,   805,   843,   843,     0,   841,
     825,   824,   830,   828,   835,   834,   840,   838,   861,    18,
      18,     0,   856,   859,   860,   878,     0,     0,     0,   873,
     881,   884,   883,   882,   879,    18,     0,   858,   857,     0,
       0,    18,   862,    18,    18,   886,   342,   423,   381,   394,
     385,     0,     0,     0,     0,   929,    18,     0,     0,     0,
     937,     0,   933,   934,     0,   930,   941,     0,     0,   193,
     195,   517,   518,   519,   528,   529,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   701,     0,
     709,   708,   710,   166,   167,   712,   713,     0,   714,    18,
     697,   686,   696,   699,   702,   695,     0,   800,   801,   802,
     790,     0,   843,     0,   780,     0,   789,   843,   783,   782,
     784,   785,     0,   798,   795,   799,   797,    18,   813,   814,
     842,   877,   866,   868,   871,   874,   872,     0,   875,   870,
     867,   869,   863,   864,   865,     0,   505,   503,   504,   502,
     939,   935,   938,   936,   931,   932,   356,   423,   196,   200,
     200,   200,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   200,     0,     0,     0,     0,   704,   728,   727,
     715,   703,   779,   792,   788,   791,   778,   787,   786,   844,
     876,     0,   207,   205,   206,   208,   200,   200,   200,   200,
     729,     0,   423,   201,   202,   203,   204,   730,     0,   371
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1567, -1567, -1567, -1567,  -180,  -224,   188,  -277,  -899,  -152,
    -760, -1567, -1231,   -84,   309,    91, -1567, -1567, -1567, -1567,
    1544,  1212, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567,   862,  1753, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567,  -311, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567,  3076,   -95,  1857, -1567,   400,  -407, -1567,
   -1567, -1567, -1567,  1001,  -605,  -715, -1567, -1567, -1323, -1567,
   -1567, -1567, -1567,   183, -1567,  1092,  -142, -1567,  1090, -1173,
     219, -1566, -1567,  -982, -1567, -1567, -1567, -1567, -1567,  -132,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
    -191, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,   941,  1747, -1567, -1567, -1567,
   -1567,  -890,  1028,   838,  1548,  1376,  1733, -1567,  1224, -1567,
   -1567, -1443, -1567,   527,  -192,  1304,   392, -1066, -1456,  1954,
   -1434, -1413,  1308,   393, -1567, -1567,  -187,  1306, -1567, -1567,
   -1567, -1567,  -395,   766, -1567, -1567,  -994, -1567,  -168,   931,
     -17, -1567, -1567,   683,  1087,   789, -1005, -1567, -1567, -1567,
   -1567,  1034,   669, -1567, -1567, -1567,   748, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567,  1208, -1567, -1567,   738, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,   723, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567,   662, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567,   326, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567,   470,   451, -1567, -1567, -1567, -1567,   322,
     450, -1567, -1567, -1567, -1567,   323,   455, -1525, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567,  1166, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567,
   -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1567, -1061
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    92,   571,   580,   572,   407,   959,  1025,
    1026,   804,  1928,   213,  1043,   369,    93,   559,   214,   562,
     552,   553,    94,   222,   223,    95,    96,    20,    21,    22,
      23,    24,    25,   141,   367,    97,  1240,   350,    98,   356,
     351,    99,   591,   100,   594,   914,   101,   584,   102,   103,
     602,   104,   105,   238,   267,   618,  1120,   928,   607,   106,
     923,  1291,  1117,   924,  1413,  1414,   886,   887,  1802,   107,
     108,   611,   268,   361,   736,   737,   377,   749,   750,  1566,
    1778,  1567,  1568,  1792,  1932,    26,    27,    28,    29,   398,
      30,    31,    32,   389,   777,    33,   386,   762,    34,   390,
     379,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   206,   555,    48,    49,    50,    51,
      52,    53,    54,    55,    56,   135,   383,   109,   592,   110,
     904,   905,   906,  1112,   930,   931,   619,   917,   908,   111,
     597,  1283,  1284,  1523,   195,   453,  1617,   836,   454,   837,
     455,   456,   457,  1621,   458,  1622,   196,   460,   461,  1525,
     423,   197,   424,   433,   198,   199,   200,  1231,   201,   525,
    1274,  1232,  1377,  1378,   816,   817,  1285,   112,  1127,   936,
     113,  1297,  1493,  1569,  1652,  1492,  1416,  1298,  1300,  1419,
    1497,  1572,  1302,    57,   114,   649,  1137,  1315,  1316,   115,
     116,   117,   322,   323,   324,  1001,  1190,  1336,  1341,  1339,
    1340,  1506,  1583,  1191,  1508,  1593,  1192,  1681,  1505,  1577,
    1578,  1684,  1939,  2051,  2029,  1328,  1346,  1432,  1502,  1574,
    1504,  1329,    58,    59,    60,    61,    62,    63,    64,    65,
     790,   118,   119,   120,  1202,  1352,  1353,  1005,   121,  1347,
    1713,  1852,  1854,  1960,  1595,  1594,  1510,  1348,  1350,  1602,
    1512,  1511,  1446,  1351,  1449,  1513,  1723,  1862,  1603,  1450,
    1453,  1514,  1727,  1866,  1604,  1454,  1860,  1978,   122,  1208,
    1006,   123,  1357,  1606,  1748,  1884,  1605,  1516,  1358,    66,
      67,   124,   125,   338,  1013,  1014,   339,  1234,  1015,   713,
      68,   126,  1238,  1017,   127,  1379,  1631,  1770,  1630,  1535,
    1380,    69,    70,    71,   128,    72,   129,   130,   131,   526
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     202,   581,   452,   684,   233,   425,   925,   459,   648,   651,
    1233,   408,   409,  1039,  1397,  1402,  1273,  1275,  1277,  1278,
     311,  1230,   321,   808,   329,   809,  1111,   811,   812,   401,
     337,  1083,  1543,  1550,   802,   352,   357,   574,   807,  1451,
    1553,  1417,  1610,   560,   579,   579,   418,   431,   919,     1,
     419,  1611,  1612,  1613,  1087,   672,  1880,  1365,   429,   418,
     420,   405,   406,   419,   405,   406,   563,   405,   406,  1618,
     564,   563,   234,   420,  1843,   564,  1779,   609,  1881,  1608,
     528,   529,   530,   531,   532,   402,   565,   566,   567,   568,
     595,  1619,   926,   944,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   150,   647,   542,  -329,   405,   406,   842,
     843,  1211,  1620,  1230,  1579,  -329,  -329,  -329,  -329,  1216,
    -328,   405,   406,   625,   528,   529,   530,   531,   532,  -328,
    -328,  -328,  -328,  1216,   960,   403,   970,   687,   533,   534,
     535,   536,   537,   538,   539,   540,   541,    73,  1213,   542,
     563,  1217,   209,   210,   564,   447,   448,   449,   177,   450,
     585,  1104,   586,   587,   588,  1217,   434,  1752,   722,  1374,
     565,   566,   567,   568,   203,   563,   446,  1887,   622,   564,
     624,  1836,   701,   204,  1869,   358,   741,   528,   529,   530,
     531,   532,   563,   637,   359,   563,   564,  1841,   226,   564,
     819,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     563,   940,   542,   384,   564,   565,   566,   567,   568,   399,
    1218,   236,   405,   406,   528,   529,   530,   531,   532,   142,
     565,   566,   567,   568,  1218,   370,  1467,   776,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1468,   673,   542,
     425,   960,   425,  1888,   425,   425,   563,   374,   630,   787,
     564,   788,   789,   986,   792,   794,   375,   796,   797,   400,
     799,   800,   801,  1214,  1418,  1580,   961,   232,   971,  1409,
     392,  1101,   563,   430,   589,   563,   564,   563,   563,   564,
    1230,   564,   564,   641,  1882,  1008,  1581,   922,   556,  1870,
    1618,  1219,  1220,  1221,  1222,  1223,  1224,  1225,   565,   566,
     567,   568,  1899,  1362,  1842,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1619,  1226,   149,   585,  1227,   586,   587,   588,
     563,  1479,  1979,  1481,   564,  1592,  1483,  1226,  1486,  1488,
    1227,   237,   569,  1620,   920,   875,  1611,  1612,  1613,  1087,
     565,   566,   567,   568,  1779,   563,   163,  1290,  1105,   564,
     631,   528,   529,   530,   531,   532,  1844,   955,  1883,   945,
    1611,  1612,  1613,  1087,  1461,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   393,  1582,   542,   563,   650,   579,
     164,   564,   404,   961,   563,   877,  1111,   385,   564,   573,
    1521,  1680,   885,   642,   810,   447,   448,   449,  1087,   450,
     815,  1331,  1332,  1879,   565,   566,   567,   568,   825,   826,
     827,   828,   829,  1696,   208,   820,  1815,  1690,  1010,   643,
    1011,   563,  1747,   927,   838,   564,   604,  2034,   949,   950,
     927,  1910,  2037,   927,  1333,   727,   610,   747,   230,  1839,
    1024,   565,   566,   567,   568,   561,   394,   941,  1524,   948,
     803,   227,  1398,  1403,  1837,   215,   638,  1404,   909,  1230,
     963,   645,   965,  1838,   872,   968,  1452,  1633,   972,   973,
    1544,  1551,  1635,  1084,  1636,   421,   666,  1638,  1554,  1366,
    1614,   422,   432,   748,  1615,   677,  1024,   680,   421,   392,
    1803,  1575,  1423,   685,   422,   570,   688,  1584,  1135,  1000,
     570,   847,   848,   849,   850,   851,   852,   853,   854,   855,
     856,   857,   858,   859,   860,   791,  1064,   833,  1230,  1412,
     716,   834,   718,  1940,  1941,  1018,   704,  1019,  1078,   844,
     871,   216,  1079,  1334,   392,   962,  1023,  2027,   447,   448,
     449,  1087,   450,   876,  -329,   217,   228,  1929,  -329,  1293,
    1447,   229,   528,   529,   530,   531,   532,  1691,  -328,   678,
     793,  1270,  -328,   888,  1947,  1271,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   231,  1424,   542,   575,   570,
     679,   910,   911,   912,   451,   205,  1798,  1799,   563,   590,
     933,   235,   564,  1395,  1524,   705,   360,  1396,  1798,  1799,
    1035,  1294,  1295,  1296,   570,  1230,  1230,  1720,   565,   566,
     567,   568,  1063,  1721,  1798,  1799,   576,   577,   240,   224,
     646,   570,  1444,  1761,   570,  1109,   706,  1682,  1069,   395,
    1804,   136,  1456,  1891,  1683,   707,   225,   452,   452,   570,
     132,   133,   363,   396,   397,   209,   210,  1762,   459,  1054,
     364,  1056,  1320,  1722,  1471,  1692,  1163,   528,   529,   530,
     531,   532,  1260,   540,   541,  1073,   134,   542,   376,   366,
     211,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     730,   212,   542,   368,  1175,   570,   612,   528,   529,   530,
     531,   532,  2023,  2024,  2025,  2026,   405,   406,  1917,   779,
    1918,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     620,   570,   542,  1431,   570,   780,   570,   570,   373,  1108,
     528,   529,   530,   531,   532,  1212,  1245,   387,  1805,  1246,
     731,   732,  1248,   982,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   733,   734,   542,   735,  1128,  1129,  1724,
    1131,  1230,  1342,  1933,   590,  1934,  1725,  1114,    74,   570,
    1800,   983,   984,   708,   709,   710,   711,   614,   615,   378,
    1148,  1149,  1877,  1858,  1151,  1897,  1153,  1154,   388,  1156,
     132,   133,   781,   921,   570,  1162,   209,   210,  1908,    75,
     653,   380,   381,   145,   146,  1726,  1801,   757,    76,  1614,
     654,    77,  1074,   612,  1176,  1080,   134,  1081,  1878,  1178,
     939,   942,    78,  1648,   782,   783,   570,   382,   951,  1935,
     953,  1936,   784,   570,  1909,    79,   391,   613,   392,   218,
    1024,  1126,  1987,  1649,  1088,    80,   410,  1301,   974,  1763,
    1764,    81,   411,   979,   412,   981,   136,   985,   219,   987,
     426,  1400,   990,   991,   992,  1401,   840,   995,   785,   841,
     570,   997,  1596,  1597,   998,   413,  1598,  1599,  1600,   913,
    1528,    82,  1541,    83,    84,  1546,  1542,   414,  1007,  1547,
     758,    85,   137,   415,   614,   615,  1557,   416,  1558,   425,
     138,   139,   140,   417,   616,   617,   786,  1020,  1021,  1022,
    1201,  1207,   658,   659,   220,   528,   529,   530,   531,   532,
     845,  1601,  1237,   846,   662,   663,  1559,    86,    87,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   427,    88,
     542,  2041,  1765,  1216,  1529,  1530,  1766,   428,   143,   144,
     147,   148,   528,   529,   530,   531,   532,   882,   883,   884,
     207,   759,    89,  1650,  1651,    90,   533,   534,   535,   536,
     537,   538,   539,   540,   541,  1217,   760,   542,  2012,  2013,
    2014,  2015,  2016,   435,   221,   436,  2058,   451,   761,   173,
     437,   174,   175,   176,   177,   178,   179,  1755,   438,   362,
    1756,  1531,   365,   180,   181,   439,   182,  1532,   183,   405,
     406,  1009,  1024,  1075,  1560,  1561,   670,   671,  1562,  1563,
     934,  1767,   617,   935,  1564,  1360,  1438,  2042,  2043,  2044,
    1308,   694,   695,  1338,  1364,   380,   381,   570,   440,  1768,
    2045,   878,   879,  1349,  1218,   554,  1354,   867,   868,  1769,
     880,   881,   815,   405,   406,  1289,  1264,  1265,  1266,  1382,
    1267,   557,  1268,   558,  2053,  2054,  2055,  2056,  1309,  1427,
    1428,  1279,  1957,  1958,  1959,  1448,   578,  1281,   173,   582,
     174,   175,   176,   177,   178,   179,   371,   372,  1027,  1028,
    1030,  1031,   180,   181,   835,   182,   184,   183,  1044,  1045,
     593,  1055,   185,  1057,   583,  1058,  1059,   596,  1060,  1061,
    1062,   598,  1786,  1097,   868,  1046,  1429,  1430,  1077,   599,
    1121,  1643,  1644,   600,  1420,  1219,  1220,  1221,  1222,  1223,
    1224,  1225,  1134,  1136,  1787,   601,  1788,  1783,  1784,   603,
    1142,  1789,  1144,   605,  1179,  1924,  1925,  1226,  1269,   606,
    1227,  1433,  1434,   608,  1436,   623,  1790,   528,   529,   530,
     531,   532,  1441,  1912,  1913,  1442,   186,   187,   626,  1930,
    1931,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     627,  1392,   542,   628,  1310,   184,  1311,   629,  1312,  1313,
     632,   185,  1314,   633,  1472,  1473,   861,   822,   823,   634,
    1791,   635,   639,   188,   189,  1369,   636,   640,  1180,  1370,
    1371,   644,  1047,   652,   655,  1376,  1565,   656,    91,  1570,
     190,   862,   657,   191,   661,   664,   660,   665,   192,   863,
     668,   667,   674,   669,   864,   865,   866,   675,   682,   681,
     686,  1216,   676,   683,   173,   689,   174,   175,   176,   177,
     178,   179,  1393,   690,  1394,   186,   187,   693,   180,   181,
     691,   182,   253,   183,   528,   529,   530,   531,   532,   692,
     696,   697,   698,  1217,   700,   699,   702,  1517,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   703,   712,   542,
     714,   715,   188,   189,   441,   442,   443,   444,   719,   717,
    1181,   720,   255,   721,   528,   529,   530,   531,   532,   190,
     726,   723,   191,   724,   725,   738,   740,   192,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   728,   729,   542,
     742,   743,   256,  1616,  1495,   752,   257,   258,  1646,  1203,
     260,   261,  1218,   744,   262,   745,   746,   263,  1458,   815,
    1460,   184,   751,  1576,   753,  1576,   755,   185,  2017,  2018,
    2019,  2020,  2021,  1249,  1464,  1251,   756,  1182,  1330,   795,
    1335,   798,   813,   805,  1048,  1475,  1343,   806,   821,   814,
     542,  1522,   579,  1647,   818,   264,   824,   831,   830,  1183,
     265,  1184,  1359,   839,   832,   869,  1185,   870,  1186,  1068,
    1686,  1363,  1187,  1188,   916,  1689,   874,  1693,  1694,   889,
    1697,   915,   918,   932,   937,   938,  1372,   943,   946,  1049,
     947,   186,   187,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
     193,  -488,   954,   952,   958,   956,  1050,   194,   957,   964,
    1216,     4,   976,   966,  1448,  1226,   967,   969,  1227,  1526,
    1527,  1051,  1376,   975,   253,   978,  1874,   980,   188,   189,
     441,   442,   443,   444,   988,   977,     5,     6,   989,   994,
    1557,   993,  1217,  1640,   999,   190,     7,  1794,   191,  1189,
    1052,  1053,   996,   192,  1002,  1003,  1004,  1810,  1811,  1812,
    1012,  1814,  1816,  1016,   255,  1029,  1827,  1032,  1033,  1034,
    1559,  1036,  1037,  1831,   543,   544,   545,   546,   547,   548,
     549,   550,   551,  1585,  1040,  1833,  1834,  1041,  1042,   193,
    1065,  1435,  1066,  1067,   256,  1070,   194,  1071,   257,   258,
       8,  1122,   260,   261,  1856,  1857,   262,  1072,  1082,   263,
    1859,  1218,  1085,  1455,  1859,  1091,  1092,  1094,  1868,  1349,
    1100,  1872,  1099,  1116,  1102,  1106,  1921,  1922,  1923,  1115,
    1107,  1119,  1616,  1892,  1616,  1146,     9,  1118,  1130,    10,
    1132,    11,  1133,  1138,  1139,  1448,  1140,   264,    12,  1141,
      13,  1905,   265,  1243,  1143,    14,    15,    16,  1915,  1145,
    1239,  1244,    17,    18,    19,  1204,  1150,  1753,  1586,  1152,
     579,   579,   579,  1155,  1076,  1157,  1926,  1158,  1757,  1758,
    1759,  1760,  1159,  1160,  1161,  1164,  1165,  1942,  1943,  1944,
    1945,  1946,  1219,  1220,  1221,  1222,  1223,  1224,  1225,  1166,
    1167,  1168,  1169,  1950,  1247,  1951,   173,  1170,   174,   175,
     176,   177,   178,   179,  1226,  1205,  1171,  1227,  1954,  1172,
     180,   181,  1272,   182,  1173,   183,  1174,  1177,  1962,  1193,
    1209,  1964,  2028,  1210,  1967,  1968,  1250,  1252,  1970,  1971,
    1123,  1124,  1253,  1254,  1206,  1255,  1228,  1256,  1980,  1257,
    -328,  1258,  1587,  1588,  1589,   193,  1590,   165,  1259,  1262,
    1263,  1983,   194,  1286,  1280,  1288,  1984,  1985,  1986,  1287,
    1303,  1304,  1305,  1306,  1307,  1317,  1989,  1318,  1337,  1990,
    1991,  1086,   151,   152,  1319,  1321,  1322,  1323,   173,  1324,
     174,   175,   176,   177,   178,   179,  1325,  2001,  2002,  2003,
     153,  2004,   180,   181,  2005,   182,  1326,   183,  1345,  1327,
    1344,  1356,  1361,   184,  1355,   154,  1641,  1367,  1368,   185,
     166,  1098,   167,   168,   155,  1375,   156,   157,   173,  1655,
     174,   175,   176,   177,   178,   179,  1383,  1685,  1381,  1687,
    1384,  1385,   180,   181,  1276,   182,  2032,   183,  1387,  1386,
    1399,  2033,  1405,  2035,  1406,  2036,  1716,  1717,  1718,  1408,
    1591,   173,  2038,   174,   175,   176,   177,   178,   179,  1411,
    1421,   169,   170,   171,   172,   180,   181,  1480,   182,  1422,
     183,  1415,  1425,   186,   187,  1457,  1437,  1439,   528,   529,
     530,   531,   532,   158,  1426,   184,  1466,  1465,  1470,  1474,
    1440,   185,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1443,  1469,   542,  1445,  1478,  1482,  1796,  1484,  1489,
     188,   189,  1807,  1494,  1809,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1490,  1496,   184,  1125,   190,  1498,  1500,
     191,   185,  1536,  1499,  1503,   192,  1509,  1515,  1519,  1229,
    1995,  1534,  1537,  1539,  1571,  1540,  1545,  1548,  1555,  1549,
    1552,  1607,  1609,  1846,  1625,   186,   187,  1626,   184,  1627,
    1628,  1629,  1637,  1632,   185,  1634,  1639,   159,   253,  1642,
    1645,   173,  1653,   174,   175,   176,   177,   178,   179,  1654,
    1873,  1688,  1875,  1695,  1698,   180,   181,  1485,   182,  1714,
     183,  1715,   188,   189,  1719,   186,   187,   353,  1749,   173,
    1754,   174,   175,   176,   177,   178,   179,  1750,   255,   190,
    1557,  1771,   191,   180,   181,  1487,   182,   192,   183,  1774,
    1780,  1772,  1781,  1782,  1797,  1773,  1775,  1777,   186,   187,
    1776,  1785,   188,   189,  1806,  1793,  1808,  1795,   256,  1813,
    1828,  1938,   257,   258,  1825,  1826,   260,   261,  1829,   190,
     262,  1830,   191,   263,  1948,  1832,   160,   192,  1845,  1847,
    1835,  1848,  1849,  1850,  1851,   188,   189,  1853,  1855,  1863,
     161,  1451,  1867,  1952,  1953,   162,   354,  1955,   184,  1871,
    1876,  1889,   190,  1886,   185,   191,  1885,  1890,  1893,  1895,
     192,   264,  1906,  1911,  1914,  1969,   265,  1916,  1907,  1973,
    1894,  1975,  1920,  1919,  1927,  1937,   184,   528,   529,   530,
     531,   532,   185,   253,  1956,  1961,  1963,  1981,  1982,  1949,
    1965,   533,   534,   535,   536,   537,   538,   539,   540,   541,
    1972,  1977,   542,  1988,  1996,  2006,  2007,   193,  1997,  1992,
    1095,  1993,  1994,  1998,   194,  2030,  1999,  2009,   186,   187,
    2010,  2011,  2022,   255,  2000,   173,  2050,   174,   175,   176,
     177,   178,   179,  2040,  2052,   873,  2046,  2047,  2048,   180,
     181,  2049,   182,  2057,   183,   739,   186,   187,   621,  1292,
    1241,  1242,   778,   256,  1410,   188,   189,   257,   258,   754,
    1235,   260,   261,  2059,  1282,   262,  1751,  2031,   263,  2008,
     907,  1113,   190,  1089,  1038,   191,  1898,   445,  1090,  1900,
     192,  1093,  1533,   188,   189,  1459,  1261,  1299,  -483,   193,
    1556,  1373,  1491,  1507,  1573,  2039,   194,  1147,  1501,  1966,
     190,  1840,  1861,   191,  1974,  1865,   264,  1976,   192,  1864,
    1215,   265,     0,     0,   890,   891,   892,   893,   894,   895,
     896,   897,     0,   898,   899,   900,   901,   902,   903,   193,
       0,     0,   184,     0,     0,     0,   194,     0,   185,   528,
     529,   530,   531,   532,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   193,     0,   542,     0,     0,     0,     0,   194,
       0,   528,   529,   530,   531,   532,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,     0,  1103,   542,   528,   529,   530,
     531,   532,   186,   187,     0,     0,     0,     0,     0,     0,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
       0,     0,   542,     0,     0,     0,     0,   528,   529,   530,
     531,   532,     0,     0,     0,     0,     0,     0,     0,   188,
     189,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     355,     0,   542,     0,     0,     0,   190,     0,     0,   191,
       0,     0,     0,     0,   192,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   528,   529,   530,   531,
     532,     0,   193,     0,     0,     0,     0,     0,     0,   194,
     533,   534,   535,   536,   537,   538,   539,   540,   541,     0,
       0,   542,     0,     0,   528,   529,   530,   531,   532,     0,
     193,     0,     0,     0,     0,     0,     0,   194,   533,   534,
     535,   536,   537,   538,   539,   540,   541,     0,     0,   542,
     528,   529,   530,   531,   532,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   533,   534,   535,   536,   537,   538,
     539,   540,   541,     0,     0,   542,   528,   529,   530,   531,
     532,  1110,     0,     0,     0,     0,     0,     0,     0,     0,
     533,   534,   535,   536,   537,   538,   539,   540,   541,     0,
       0,   542,   528,   529,   530,   531,   532,     0,     0,     0,
       0,     0,     0,     0,     0,  1236,   533,   534,   535,   536,
     537,   538,   539,   540,   541,     0,     0,   542,     0,     0,
       0,   528,   529,   530,   531,   532,     0,     0,   462,     0,
       0,     0,     0,     0,  1388,   533,   534,   535,   536,   537,
     538,   539,   540,   541,     0,     0,   542,   528,   529,   530,
     531,   532,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
       0,     0,   542,     0,     0,     0,   193,   528,   529,   530,
     531,   532,     0,   194,     0,     0,     0,     0,     0,     0,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
       0,     0,   542,     0,     0,   463,   464,     0,     0,     0,
       0,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   528,
     529,   530,   531,   532,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   493,     0,   542,   528,   529,   530,   531,   532,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   533,
     534,   535,   536,   537,   538,   539,   540,   541,     0,     0,
     542,   528,   529,   530,   531,   532,  1389,     0,     0,     0,
       0,   494,  1728,     0,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,     0,     0,   542,   528,   529,   530,
     531,   532,     0,     0,     0,     0,  1729,  1730,  1390,     0,
       0,   533,   534,   535,   536,   537,   538,   539,   540,   541,
       0,     0,   542,     0,     0,     0,     0,  1731,     0,     0,
       0,     0,     0,     0,  1391,     0,   495,   496,     0,   497,
     498,   499,   500,   501,   502,   503,     0,     0,     0,     0,
       0,   528,   529,   530,   531,   532,     0,     0,     0,     0,
       0,     0,     0,     0,  1407,   533,   534,   535,   536,   537,
     538,   539,   540,   541,     0,     0,   542,     0,  1557,     0,
    1732,     0,     0,     0,     0,     0,     0,     0,   504,   505,
     506,   507,   508,   509,   510,   511,   512,     0,     0,     0,
       0,     0,   528,   529,   530,   531,   532,  1733,  1559,     0,
       0,     0,     0,  1476,   513,   514,   533,   534,   535,   536,
     537,   538,   539,   540,   541,     0,     0,   542,     0,   515,
       0,     0,     0,     0,   528,   529,   530,   531,   532,     0,
       0,  1477,     0,   253,   516,   517,   518,   519,   533,   534,
     535,   536,   537,   538,   539,   540,   541,     0,     0,   542,
       0,     0,     0,     0,     0,     0,     0,  1538,     0,     0,
     341,   342,   343,     0,   344,   345,     0,   346,     0,     0,
       0,   347,     0,   255,   348,     0,     0,     0,     0,     0,
       0,     0,   462,  1896,     0,  1734,     0,     0,  1735,  1736,
       0,     0,     0,     0,     0,     0,  1737,     0,     0,     0,
       0,     0,     0,   256,     0,     0,     0,   257,   258,  1901,
       0,   260,   261,     0,     0,   262,     0,     0,   263,   520,
     521,   929,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   522,   523,     0,     0,     0,  1902,     0,
       0,     0,     0,     0,   524,     0,     0,  1738,     0,     0,
       0,     0,     0,     0,     0,     0,   264,     0,     0,   463,
     464,   265,     0,     0,  1903,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,     0,  1904,     0,   527,     0,     0,     0,
       0,   528,   529,   530,   531,   532,     0,     0,   253,  1739,
       0,     0,     0,   271,     0,   533,   534,   535,   536,   537,
     538,   539,   540,   541,     0,  1740,   542,     0,   272,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1463,     0,   273,     0,     0,     0,     0,     0,   255,     0,
       0,     0,     0,     0,  1096,   494,     0,     0,     0,     0,
    1741,  1742,     0,  1743,  1744,     0,  1745,     0,     0,   253,
       0,     0,     0,     0,     0,     0,     0,     0,   256,     0,
    1462,     0,   257,   258,   274,   275,   260,   261,  1746,     0,
     262,   241,     0,   263,     0,     0,   242,   276,     0,     0,
     277,     0,   278,     0,     0,     0,  1518,   313,     0,   255,
     890,   891,   892,   893,   894,   895,   896,   897,     0,   898,
     899,   900,   901,   902,   903,     0,     0,     0,     0,     0,
       0,   264,  1520,     0,     0,     0,   265,     0,     0,   256,
     243,     0,     0,   257,   258,     0,     0,   260,   261,     0,
     279,   262,   280,     0,   263,     0,     0,     0,  -489,  -489,
    -489,   281,   504,   505,   506,   507,   508,   509,   510,   511,
     512,     0,  -489,  -489,  -489,  -489,  -489,   538,   539,   540,
     541,     0,   244,   542,   239,     0,  1623,     0,   513,   514,
       0,     0,   264,   252,     0,     0,     0,   265,   269,   282,
     270,     0,   312,   515,   325,     0,   330,     0,   331,     0,
     332,     0,   340,     0,   253,     0,     0,   283,   516,   517,
     518,   519,     0,     0,   284,   285,     0,   286,     0,     0,
       0,     0,   287,   288,     0,   289,   290,  1624,   291,     0,
       0,   292,   293,   294,     0,   349,     0,     0,     0,     0,
       0,     0,     0,     0,   255,     0,   295,   296,     0,     0,
       0,   297,     0,   298,   299,   253,   300,     0,     0,  1656,
       0,   301,     0,   245,     0,   302,   303,     0,   304,   305,
       0,   306,   307,   308,   256,   333,     0,   309,   257,   258,
       0,  1194,   260,   261,     0,     0,   262,     0,     0,   263,
       0,     0,     0,   520,   521,   255,     0,     0,     0,     0,
       0,     0,   253,     0,     0,     0,     0,   522,   523,     0,
       0,     0,     0,     0,     0,     0,   253,     0,   524,     0,
       0,     0,   254,     0,     0,   256,     0,   264,     0,   257,
     258,  1557,   265,   260,   261,     0,     0,   262,     0,     0,
     263,     0,   255,     0,     0,     0,     0,   246,     0,     0,
       0,     0,     0,   314,     0,     0,   255,     0,   315,   316,
     317,  1559,     0,     0,     0,     0,     0,     0,     0,  1195,
       0,     0,   256,     0,  1657,     0,   257,   258,   264,   259,
     260,   261,     0,   265,   262,     0,   256,   263,  1658,     0,
     257,   258,   318,     0,   260,   261,     0,   334,   262,   319,
       0,   263,   247,     0,     0,     0,   248,     0,  1699,     0,
     310,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   264,     0,     0,     0,     0,
     265,     0,     0,     0,     0,     0,   249,  1701,     0,   264,
       0,     0,     0,     0,   265,     0,     0,     0,  1659,     0,
     250,  1660,  1661,     0,   763,   251,     0,     0,     0,  1662,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   405,
     406,   320,   528,   529,   530,   531,   532,     0,     0,     0,
       0,     0,  1702,     0,     0,     0,   533,   534,   535,   536,
     537,   538,   539,   540,   541,     0,   764,   542,     0,     0,
       0,     0,     0,     0,     0,  1703,     0,     0,     0,     0,
    1663,     0,     0,  1664,     0,     0,  1665,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   765,     0,  1666,
       0,  1667,     0,  1668,  1669,  1670,  1671,  1672,  1673,  1704,
       0,     0,     0,     0,  1674,     0,     0,  1675,     0,     0,
    1676,     0,     0,     0,     0,     0,     0,     0,     0,   766,
       0,     0,  1677,     0,  1196,  1197,   767,   768,  1198,     0,
    1678,     0,     0,  1199,     0,     0,     0,     0,   769,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   326,     0,     0,     0,   770,   771,   772,   773,     0,
     774,   775,     0,     0,     0,     0,  1200,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1705,  1706,     0,     0,
       0,  1707,  1708,     0,  1709,     0,     0,     0,   528,   529,
     530,     0,  1710,  1711,     0,     0,     0,     0,     0,     0,
       0,  1679,   533,   534,   535,   536,   537,   538,   539,   540,
     541,     0,     0,   542,     0,   327,     0,   336,   890,   891,
     892,   893,   894,   895,   896,   897,     0,   898,   899,   900,
     901,   902,   903,     0,  1712,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   617,     0,     0,     0,     0,
       0,     0,     0,     0,   266,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   328
};

static const yytype_int16 yycheck[] =
{
      17,   225,   194,   314,    88,   173,   611,   194,   285,   286,
    1015,   163,   164,   773,     7,     7,  1082,  1083,  1084,  1085,
     115,  1015,   117,   418,   119,   420,   916,   422,   423,   161,
     125,     7,     7,     7,    30,   130,   131,   217,     7,    20,
       7,    31,     6,    45,   224,   225,    15,    15,   162,     4,
      19,    15,    16,    17,    18,   122,   127,    22,    28,    15,
      29,    18,    19,    19,    18,    19,    15,    18,    19,  1525,
      19,    15,    89,    29,   120,    19,  1642,   257,   149,  1522,
       8,     9,    10,    11,    12,   145,    35,    36,    37,    38,
     232,  1525,    36,    51,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   162,   284,    33,     6,    18,    19,    27,
      28,  1010,  1525,  1107,   187,    15,    16,    17,    18,    19,
       6,    18,    19,   265,     8,     9,    10,    11,    12,    15,
      16,    17,    18,    19,    42,   195,   136,   317,    22,    23,
      24,    25,    26,    27,    28,    29,    30,     0,   255,    33,
      15,    51,    19,    20,    19,    15,    16,    17,    18,    19,
      15,    19,    17,    18,    19,    51,   183,  1610,   348,  1230,
      35,    36,    37,    38,    36,    15,   193,   356,   262,    19,
     264,   120,   334,    45,   323,    36,   366,     8,     9,    10,
      11,    12,    15,   277,    45,    15,    19,   282,    81,    19,
      28,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      15,    76,    33,     3,    19,    35,    36,    37,    38,   145,
     120,    19,    18,    19,     8,     9,    10,    11,    12,     3,
      35,    36,    37,    38,   120,   144,    22,   389,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    33,   315,    33,
     418,    42,   420,   432,   422,   423,    15,    36,   181,   391,
      19,   393,   394,   670,   396,   397,    45,   399,   400,   195,
     402,   403,   404,   380,   264,   348,   184,   144,   278,  1284,
      19,   886,    15,   253,   139,    15,    19,    15,    15,    19,
    1284,    19,    19,   188,   365,   702,   369,   608,   207,   438,
    1756,   201,   202,   203,   204,   205,   206,   207,    35,    36,
      37,    38,  1755,  1212,   399,   201,   202,   203,   204,   205,
     206,   207,  1756,   223,     3,    15,   226,    17,    18,    19,
      15,  1397,  1857,  1399,    19,  1508,  1402,   223,  1404,  1405,
     226,   139,    69,  1756,   458,   569,    15,    16,    17,    18,
      35,    36,    37,    38,  1920,    15,   162,  1117,   216,    19,
     283,     8,     9,    10,    11,    12,   412,   644,   439,   327,
      15,    16,    17,    18,  1368,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   123,   458,    33,    15,   184,   569,
     162,    19,   452,   184,    15,   575,  1286,   187,    19,   216,
    1461,  1574,   582,   298,   421,    15,    16,    17,    18,    19,
     427,   348,   349,  1736,    35,    36,    37,    38,   435,   436,
     437,   438,   439,   156,    19,   253,   156,   127,   705,   324,
     707,    15,  1605,   613,   451,    19,   253,  1962,   258,   259,
     620,  1764,  1967,   623,   381,   354,   258,   129,    86,   403,
     727,    35,    36,    37,    38,   457,   195,   322,  1463,   639,
     456,    19,   455,   455,   403,    68,   278,   459,    42,  1463,
     650,   283,   652,   412,   558,   655,   457,  1543,   658,   659,
     455,   455,  1548,   459,  1550,   454,   298,  1553,   455,   454,
     454,   460,   460,   175,   458,   307,   773,   309,   454,    19,
     127,   458,   246,   315,   460,   454,   318,   458,   457,   689,
     454,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,    45,   803,   455,  1522,  1289,
     342,   459,   344,   373,   374,   715,   206,   717,   455,   457,
     557,   144,   459,   348,    19,   453,   726,   458,    15,    16,
      17,    18,    19,   570,   454,   158,   117,  1788,   458,    81,
     457,    19,     8,     9,    10,    11,    12,   267,   454,   265,
      45,   455,   458,   590,   259,   459,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   164,   330,    33,    20,   454,
     286,   165,   166,   167,   454,   457,   179,   180,    15,   454,
     617,    19,    19,   455,  1609,   275,   457,   459,   179,   180,
     762,   133,   134,   135,   454,  1609,  1610,   412,    35,    36,
      37,    38,   802,   418,   179,   180,    58,    59,   457,    50,
     453,   454,  1347,    42,   454,   912,   306,   369,   459,   378,
     267,    20,  1357,   371,   376,   315,    67,   839,   840,   454,
      19,    20,     3,   392,   393,    19,    20,    66,   845,   791,
       3,   793,   453,   458,  1379,   365,   977,     8,     9,    10,
      11,    12,  1067,    29,    30,   459,    45,    33,   457,    67,
      44,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      79,    55,    33,    20,   453,   454,    45,     8,     9,    10,
      11,    12,  1933,  1934,  1935,  1936,    18,    19,  1774,     3,
    1776,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      69,   454,    33,  1328,   454,    19,   454,   454,     3,   909,
       8,     9,    10,    11,    12,  1012,  1047,     3,   365,  1050,
     129,   130,  1053,   278,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   142,   143,    33,   145,   937,   938,   412,
     940,  1755,   383,   139,   454,   141,   419,   919,     3,   454,
     353,   306,   307,   443,   444,   445,   446,   126,   127,    86,
     960,   961,   353,   411,   964,   454,   966,   967,     3,   969,
      19,    20,    86,   605,   454,   975,    19,    20,   353,    34,
     272,    19,    20,   172,   173,   458,   389,     3,    43,   454,
     282,    46,   459,    45,   994,   832,    45,   834,   389,   999,
     632,   633,    57,   127,   118,   119,   454,    45,   640,   139,
     642,   141,   126,   454,   389,    70,   269,    69,    19,    43,
    1117,   936,   259,   147,   454,    80,     3,  1124,   660,   258,
     259,    86,     3,   665,     3,   667,    20,   669,    62,   671,
      30,   455,   674,   675,   676,   459,   459,   679,   162,   462,
     454,   683,   409,   410,   686,     3,   413,   414,   415,   453,
     126,   116,   455,   118,   119,   455,   459,     3,   700,   459,
      86,   126,    56,     3,   126,   127,   138,     3,   140,  1067,
      64,    65,    66,     3,   136,   254,   200,   719,   720,   721,
    1005,  1006,   286,   287,   118,     8,     9,    10,    11,    12,
     459,   458,  1017,   462,   296,   297,   168,   162,   163,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   454,   174,
      33,  2007,   351,    19,   190,   191,   355,   253,     7,     8,
       9,    10,     8,     9,    10,    11,    12,    39,    40,    41,
      19,   157,   197,   267,   268,   200,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    51,   172,    33,   149,   150,
     151,   152,   153,   454,   188,   454,  2052,   454,   184,    13,
     454,    15,    16,    17,    18,    19,    20,   456,   454,   137,
     459,   247,   140,    27,    28,   454,    30,   253,    32,    18,
      19,    20,  1289,   459,   256,   257,    86,    87,   260,   261,
     620,   430,   254,   623,   266,  1205,  1337,  2009,  2010,  2011,
     173,   396,   397,  1185,  1214,    19,    20,   454,   454,   448,
    2022,    60,    61,  1195,   120,    15,  1198,   458,   459,   458,
      60,    61,  1069,    18,    19,    20,  1073,  1074,  1075,  1239,
    1077,    22,  1079,    63,  2046,  2047,  2048,  2049,   211,   336,
     337,  1088,   422,   423,   424,  1352,   453,  1094,    13,   181,
      15,    16,    17,    18,    19,    20,   145,   146,   458,   459,
     458,   459,    27,    28,    29,    30,   120,    32,   789,     3,
      19,   792,   126,   794,   170,   796,   797,   453,   799,   800,
     801,   139,   117,   458,   459,    19,   458,   459,   459,    19,
     932,   258,   259,   457,  1304,   201,   202,   203,   204,   205,
     206,   207,   944,   945,   139,   457,   141,   149,   150,   457,
     952,   146,   954,   323,   123,   149,   150,   223,   459,    19,
     226,  1331,  1332,   117,  1334,    69,   161,     8,     9,    10,
      11,    12,  1342,   449,   450,  1345,   190,   191,   453,   147,
     148,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     453,   459,    33,   457,   327,   120,   329,   457,   331,   332,
     323,   126,   335,    81,  1385,  1386,   210,   431,   432,   453,
     205,    20,    69,   227,   228,  1222,   284,    85,   187,  1226,
    1227,   167,   116,    76,    76,  1232,   458,   270,   453,  1496,
     244,   235,   277,   247,   282,   296,    87,   300,   252,   243,
     305,   303,    87,   310,   248,   249,   250,   318,   457,   453,
     116,    19,   316,   377,    13,   117,    15,    16,    17,    18,
      19,    20,  1269,   453,  1271,   190,   191,    86,    27,    28,
     457,    30,    46,    32,     8,     9,    10,    11,    12,   457,
     453,   457,   457,    51,   323,   457,    86,  1457,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   453,   457,    33,
     457,    86,   227,   228,   229,   230,   231,   232,    79,    76,
     279,    81,    86,    85,     8,     9,    10,    11,    12,   244,
      76,   453,   247,   453,   453,     3,     3,   252,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   453,   453,    33,
       3,     3,   116,  1525,  1418,    19,   120,   121,  1562,   123,
     124,   125,   120,     3,   128,     3,     3,   131,  1365,  1366,
    1367,   120,     3,  1505,     3,  1507,     3,   126,   149,   150,
     151,   152,   153,  1054,   457,  1056,     3,   346,  1180,     3,
    1182,     3,    14,   182,   278,  1392,  1188,   182,    28,    15,
      33,   457,  1562,  1563,    27,   169,    30,    15,    19,   368,
     174,   370,  1204,     7,   459,     3,   375,     3,   377,   455,
    1580,  1213,   381,   382,   454,  1585,   453,  1587,  1588,   453,
    1590,   453,    19,   137,    76,    76,  1228,   453,   453,   323,
     453,   190,   191,   201,   202,   203,   204,   205,   206,   207,
     454,   455,   175,   308,    31,   453,   340,   461,   453,   184,
      19,    46,   453,    76,  1721,   223,    76,    76,   226,  1466,
    1467,   355,  1469,    76,    46,   453,  1733,   453,   227,   228,
     229,   230,   231,   232,   453,   117,    71,    72,   453,   184,
     138,   453,    51,  1557,    69,   244,    81,  1657,   247,   458,
     384,   385,   453,   252,    19,   453,   453,  1667,  1668,  1669,
     275,  1671,  1672,   453,    86,     3,  1676,     3,    19,    15,
     168,    19,    19,  1683,    46,    47,    48,    49,    50,    51,
      52,    53,    54,   181,    19,  1695,  1696,     3,    20,   454,
      15,  1333,    15,    15,   116,   455,   461,   253,   120,   121,
     135,   123,   124,   125,  1714,  1715,   128,    28,   459,   131,
    1720,   120,   459,  1355,  1724,    15,    18,   454,  1728,  1701,
     453,  1731,    20,    28,   453,   453,  1780,  1781,  1782,   453,
     457,   132,  1754,  1743,  1756,    19,   171,   459,   453,   174,
     453,   176,   453,   453,   453,  1852,   453,   169,   183,   453,
     185,  1761,   174,     3,   453,   190,   191,   192,  1768,   453,
      69,     3,   197,   198,   199,   379,   453,  1614,   266,   453,
    1780,  1781,  1782,   453,   455,   453,  1786,   453,  1625,  1626,
    1627,  1628,   453,   453,   453,   453,   453,  1797,  1798,  1799,
    1800,  1801,   201,   202,   203,   204,   205,   206,   207,   453,
     453,   453,   453,  1813,    15,  1815,    13,   453,    15,    16,
      17,    18,    19,    20,   223,   429,   453,   226,  1828,   453,
      27,    28,    29,    30,   453,    32,   453,   453,  1838,   453,
     453,  1841,  1939,   453,  1844,  1845,     3,     3,  1848,  1849,
     262,   263,     3,     3,   458,     3,   255,     3,  1858,     3,
     458,   184,   350,   351,   352,   454,   354,    79,   184,    28,
      28,  1871,   461,   453,   459,   182,  1876,  1877,  1878,   455,
     453,   459,   453,   453,   453,   453,  1886,   453,   323,  1889,
    1890,   455,   144,   145,   453,   453,   453,   453,    13,   453,
      15,    16,    17,    18,    19,    20,   453,  1907,  1908,  1909,
     162,  1911,    27,    28,  1914,    30,   453,    32,   386,   453,
     453,   453,   453,   120,    79,   177,  1558,    22,   454,   126,
     142,   455,   144,   145,   186,   453,   188,   189,    13,  1571,
      15,    16,    17,    18,    19,    20,     3,  1579,   453,  1581,
       3,    15,    27,    28,    29,    30,  1956,    32,    28,    15,
     459,  1961,   459,  1963,    15,  1965,  1598,  1599,  1600,   458,
     458,    13,  1972,    15,    16,    17,    18,    19,    20,    15,
     338,   193,   194,   195,   196,    27,    28,    29,    30,    69,
      32,   457,   334,   190,   191,    69,   457,   457,     8,     9,
      10,    11,    12,   255,   333,   120,    22,   453,   453,    28,
     457,   126,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   457,   459,    33,   457,    29,    29,  1659,     7,   458,
     227,   228,  1664,    19,  1666,   356,   357,   358,   359,   360,
     361,   362,   363,   184,   265,   120,   458,   244,   453,   328,
     247,   126,     3,   193,   457,   252,   457,   457,   455,   458,
    1897,   457,     3,   455,   262,   455,   455,   454,    15,   455,
     455,   455,   225,  1705,   454,   190,   191,   454,   120,   454,
     454,   453,     7,    29,   126,    29,   453,   339,    46,   457,
     259,    13,   457,    15,    16,    17,    18,    19,    20,   453,
    1732,   453,  1734,   282,   453,    27,    28,    29,    30,   412,
      32,   412,   227,   228,   453,   190,   191,    75,   453,    13,
       7,    15,    16,    17,    18,    19,    20,   458,    86,   244,
     138,   455,   247,    27,    28,    29,    30,   252,    32,   459,
     260,   455,   260,   260,   372,   455,   455,   455,   190,   191,
     454,   147,   227,   228,   318,   323,   390,   457,   116,   282,
     380,  1793,   120,   121,   388,   358,   124,   125,   356,   244,
     128,   453,   247,   131,  1806,   453,   428,   252,   404,   402,
     399,    76,   407,   277,   265,   227,   228,   265,   453,   453,
     442,    20,   453,  1825,  1826,   447,   154,  1829,   120,    76,
     372,    76,   244,   380,   126,   247,   318,    76,   435,   453,
     252,   169,   323,   260,   260,  1847,   174,   453,   372,  1851,
     437,  1853,   453,   458,    20,   458,   120,     8,     9,    10,
      11,    12,   126,    46,   260,    76,    76,  1869,  1870,   391,
     260,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      69,   421,    33,  1885,   453,   455,   459,   454,   453,  1891,
     868,  1893,  1894,   453,   461,   371,   453,   453,   190,   191,
     453,   453,   453,    86,  1906,    13,   366,    15,    16,    17,
      18,    19,    20,   371,   459,   561,   453,   453,   453,    27,
      28,   453,    30,   453,    32,   362,   190,   191,   261,  1118,
    1028,  1031,   389,   116,  1286,   227,   228,   120,   121,   382,
     123,   124,   125,   455,  1106,   128,  1609,  1949,   131,  1920,
     592,   917,   244,   839,   768,   247,  1754,   193,   840,  1756,
     252,   845,  1469,   227,   228,  1366,  1069,  1123,   453,   454,
    1491,  1230,  1414,  1440,  1502,  1977,   461,   959,  1430,  1843,
     244,  1701,  1721,   247,  1852,  1725,   169,  1854,   252,  1724,
    1014,   174,    -1,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,   218,   219,   220,   221,   222,   454,
      -1,    -1,   120,    -1,    -1,    -1,   461,    -1,   126,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   454,    -1,    33,    -1,    -1,    -1,    -1,   461,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   455,    33,     8,     9,    10,
      11,    12,   190,   191,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,
     228,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     458,    -1,    33,    -1,    -1,    -1,   244,    -1,    -1,   247,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,    -1,   454,    -1,    -1,    -1,    -1,    -1,    -1,   461,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,     8,     9,    10,    11,    12,    -1,
     454,    -1,    -1,    -1,    -1,    -1,    -1,   461,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,   455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   458,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,     5,    -1,
      -1,    -1,    -1,    -1,   455,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,   454,     8,     9,    10,
      11,    12,    -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    82,    83,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   139,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,   455,    -1,    -1,    -1,
      -1,   178,    42,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    66,    67,   455,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,   455,    -1,   233,   234,    -1,   236,
     237,   238,   239,   240,   241,   242,    -1,    -1,    -1,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   455,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,   138,    -1,
     140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,   288,   289,   290,   291,   292,   293,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,   167,   168,    -1,
      -1,    -1,    -1,   455,   311,   312,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,   326,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,   455,    -1,    46,   341,   342,   343,   344,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,
      73,    74,    75,    -1,    77,    78,    -1,    80,    -1,    -1,
      -1,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     5,   455,    -1,   255,    -1,    -1,   258,   259,
      -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,   120,   121,   455,
      -1,   124,   125,    -1,    -1,   128,    -1,    -1,   131,   426,
     427,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   440,   441,    -1,    -1,    -1,   455,    -1,
      -1,    -1,    -1,    -1,   451,    -1,    -1,   317,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    82,
      83,   174,    -1,    -1,   455,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,   455,    -1,     3,    -1,    -1,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    46,   379,
      -1,    -1,    -1,    51,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   395,    33,    -1,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,    -1,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,   453,   178,    -1,    -1,    -1,    -1,
     430,   431,    -1,   433,   434,    -1,   436,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,
     453,    -1,   120,   121,   122,   123,   124,   125,   458,    -1,
     128,    73,    -1,   131,    -1,    -1,    78,   135,    -1,    -1,
     138,    -1,   140,    -1,    -1,    -1,   453,    84,    -1,    86,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,   169,   453,    -1,    -1,    -1,   174,    -1,    -1,   116,
     122,    -1,    -1,   120,   121,    -1,    -1,   124,   125,    -1,
     188,   128,   190,    -1,   131,    -1,    -1,    -1,     8,     9,
      10,   199,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,   164,    33,    98,    -1,   453,    -1,   311,   312,
      -1,    -1,   169,   107,    -1,    -1,    -1,   174,   112,   237,
     114,    -1,   116,   326,   118,    -1,   120,    -1,   122,    -1,
     124,    -1,   126,    -1,    46,    -1,    -1,   255,   341,   342,
     343,   344,    -1,    -1,   262,   263,    -1,   265,    -1,    -1,
      -1,    -1,   270,   271,    -1,   273,   274,   453,   276,    -1,
      -1,   279,   280,   281,    -1,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,   294,   295,    -1,    -1,
      -1,   299,    -1,   301,   302,    46,   304,    -1,    -1,    66,
      -1,   309,    -1,   255,    -1,   313,   314,    -1,   316,   317,
      -1,   319,   320,   321,   116,    66,    -1,   325,   120,   121,
      -1,   123,   124,   125,    -1,    -1,   128,    -1,    -1,   131,
      -1,    -1,    -1,   426,   427,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,   440,   441,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,   451,    -1,
      -1,    -1,    66,    -1,    -1,   116,    -1,   169,    -1,   120,
     121,   138,   174,   124,   125,    -1,    -1,   128,    -1,    -1,
     131,    -1,    86,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,    -1,    -1,   340,    -1,    -1,    86,    -1,   345,   346,
     347,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,
      -1,    -1,   116,    -1,   181,    -1,   120,   121,   169,   123,
     124,   125,    -1,   174,   128,    -1,   116,   131,   195,    -1,
     120,   121,   379,    -1,   124,   125,    -1,   188,   128,   386,
      -1,   131,   394,    -1,    -1,    -1,   398,    -1,   182,    -1,
     458,    -1,    -1,    -1,   188,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,   428,   211,    -1,   169,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,   255,    -1,
     442,   258,   259,    -1,     3,   447,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      19,   458,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,   256,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    45,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,    -1,
     317,    -1,    -1,   320,    -1,    -1,   323,    -1,    -1,    -1,
      -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,   346,
      -1,   348,    -1,   350,   351,   352,   353,   354,   355,   323,
      -1,    -1,    -1,    -1,   361,    -1,    -1,   364,    -1,    -1,
     367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,
      -1,    -1,   379,    -1,   416,   417,   125,   126,   420,    -1,
     387,    -1,    -1,   425,    -1,    -1,    -1,    -1,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   331,    -1,    -1,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   400,   401,    -1,    -1,
      -1,   405,   406,    -1,   408,    -1,    -1,    -1,     8,     9,
      10,    -1,   416,   417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   458,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,   395,    -1,   458,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,   218,   219,
     220,   221,   222,    -1,   458,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   458,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   464,   465,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     490,   491,   492,   493,   494,   495,   548,   549,   550,   551,
     553,   554,   555,   558,   561,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   656,   695,   696,
     697,   698,   699,   700,   701,   702,   752,   753,   763,   774,
     775,   776,   778,     0,     3,    34,    43,    46,    57,    70,
      80,    86,   116,   118,   119,   126,   162,   163,   174,   197,
     200,   453,   466,   479,   485,   488,   489,   498,   501,   504,
     506,   509,   511,   512,   514,   515,   522,   532,   533,   590,
     592,   602,   640,   643,   657,   662,   663,   664,   704,   705,
     706,   711,   741,   744,   754,   755,   764,   767,   777,   779,
     780,   781,    19,    20,    45,   588,    20,    56,    64,    65,
      66,   496,     3,   588,   588,   172,   173,   588,   588,     3,
     162,   144,   145,   162,   177,   186,   188,   189,   255,   339,
     428,   442,   447,   162,   162,    79,   142,   144,   145,   193,
     194,   195,   196,    13,    15,    16,    17,    18,    19,    20,
      27,    28,    30,    32,   120,   126,   190,   191,   227,   228,
     244,   247,   252,   454,   461,   607,   619,   624,   627,   628,
     629,   631,   633,    36,    45,   457,   577,   588,    19,    19,
      20,    44,    55,   476,   481,    68,   144,   158,    43,    62,
     118,   188,   486,   487,    50,    67,    81,    19,   117,    19,
      86,   164,   144,   476,   633,    19,    19,   139,   516,   516,
     457,    73,    78,   122,   164,   255,   339,   394,   398,   428,
     442,   447,   516,    46,    66,    86,   116,   120,   121,   123,
     124,   125,   128,   131,   169,   174,   458,   517,   535,   516,
     516,    51,    66,    80,   122,   123,   135,   138,   140,   188,
     190,   199,   237,   255,   262,   263,   265,   270,   271,   273,
     274,   276,   279,   280,   281,   294,   295,   299,   301,   302,
     304,   309,   313,   314,   316,   317,   319,   320,   321,   325,
     458,   517,   516,    84,   340,   345,   346,   347,   379,   386,
     458,   517,   665,   666,   667,   516,   331,   395,   458,   517,
     516,   516,   516,    66,   188,   313,   458,   517,   756,   759,
     516,    73,    74,    75,    77,    78,    80,    84,    87,   458,
     500,   503,   517,    75,   154,   458,   502,   517,    36,    45,
     457,   536,   496,     3,     3,   496,    67,   497,    20,   478,
     478,   588,   588,     3,    36,    45,   457,   539,    86,   563,
      19,    20,    45,   589,     3,   187,   559,     3,     3,   556,
     562,   269,    19,   123,   195,   378,   392,   393,   552,   145,
     195,   552,   145,   195,   452,    18,    19,   470,   472,   472,
       3,     3,     3,     3,     3,     3,     3,     3,    15,    19,
      29,   454,   460,   623,   625,   631,    30,   454,   253,    28,
     253,    15,   460,   626,   633,   454,   454,   454,   454,   454,
     454,   229,   230,   231,   232,   612,   633,    15,    16,    17,
      19,   454,   607,   608,   611,   613,   614,   615,   617,   619,
     620,   621,     5,    82,    83,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   139,   178,   233,   234,   236,   237,   238,
     239,   240,   241,   242,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   311,   312,   326,   341,   342,   343,   344,
     426,   427,   440,   441,   451,   632,   782,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    33,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   483,   484,    15,   578,   478,    22,    63,   480,
      45,   457,   482,    15,    19,    35,    36,    37,    38,    69,
     454,   467,   469,   536,   467,    20,    58,    59,   453,   467,
     468,   468,   181,   170,   510,    15,    17,    18,    19,   139,
     454,   505,   591,    19,   507,   539,   453,   603,   139,    19,
     457,   457,   513,   457,   536,   323,    19,   521,   117,   467,
     469,   534,    45,    69,   126,   127,   136,   254,   518,   599,
      69,   518,   476,    69,   476,   539,   453,   453,   457,   457,
     181,   283,   323,    81,   453,    20,   284,   476,   469,    69,
      85,   188,   298,   324,   167,   469,   453,   467,   470,   658,
     184,   470,    76,   272,   282,    76,   270,   277,   286,   287,
      87,   282,   296,   297,   296,   300,   469,   303,   305,   310,
      86,    87,   122,   315,    87,   318,   316,   469,   265,   286,
     469,   453,   457,   377,   505,   469,   116,   467,   469,   117,
     453,   457,   457,    86,   396,   397,   453,   457,   457,   457,
     323,   472,    86,   453,   206,   275,   306,   315,   443,   444,
     445,   446,   457,   762,   457,    86,   469,    76,   469,    79,
      81,    85,   467,   453,   453,   453,    76,   478,   453,   453,
      79,   129,   130,   142,   143,   145,   537,   538,     3,   497,
       3,   467,     3,     3,     3,     3,     3,   129,   175,   540,
     541,     3,    19,     3,   589,     3,     3,     3,    86,   157,
     172,   184,   560,     3,    45,    86,   118,   125,   126,   137,
     154,   155,   156,   157,   159,   160,   472,   557,   599,     3,
      19,    86,   118,   119,   126,   162,   200,   552,   552,   552,
     703,    45,   552,    45,   552,     3,   552,   552,     3,   552,
     552,   552,    30,   456,   474,   182,   182,     7,   625,   625,
     633,   625,   625,    14,    15,   633,   637,   638,    27,    28,
     253,    28,   626,   626,    30,   633,   633,   633,   633,   633,
      19,    15,   459,   455,   459,    29,   610,   612,   633,     7,
     459,   462,    27,    28,   457,   459,   462,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     633,   210,   235,   243,   248,   249,   250,   458,   459,     3,
       3,   633,   476,   483,   453,   468,   633,   467,    60,    61,
      60,    61,    39,    40,    41,   467,   529,   530,   633,   453,
     208,   209,   210,   211,   212,   213,   214,   215,   217,   218,
     219,   220,   221,   222,   593,   594,   595,   597,   601,    42,
     165,   166,   167,   453,   508,   453,   454,   600,    19,   162,
     458,   469,   505,   523,   526,   527,    36,   467,   520,    19,
     597,   598,   137,   633,   520,   520,   642,    76,    76,   469,
      76,   322,   469,   453,    51,   327,   453,   453,   467,   258,
     259,   469,   308,   469,   175,   470,   453,   453,    31,   471,
      42,   184,   453,   467,   184,   467,    76,    76,   467,    76,
     136,   278,   467,   467,   469,    76,   453,   117,   453,   469,
     453,   469,   278,   306,   307,   469,   521,   469,   453,   453,
     469,   469,   469,   453,   184,   469,   453,   469,   469,    69,
     467,   668,    19,   453,   453,   710,   743,   469,   521,    20,
     470,   470,   275,   757,   758,   761,   453,   766,   467,   467,
     469,   469,   469,   467,   470,   472,   473,   458,   459,     3,
     458,   459,     3,    19,    15,   472,    19,    19,   598,   473,
      19,     3,    20,   477,   477,     3,    19,   116,   278,   323,
     340,   355,   384,   385,   552,   477,   552,   477,   477,   477,
     477,   477,   477,   467,   470,    15,    15,    15,   455,   459,
     455,   253,    28,   459,   459,   459,   455,   459,   455,   459,
     633,   633,   459,     7,   459,   459,   455,    18,   454,   608,
     615,    15,    18,   620,   454,   484,   453,   458,   455,    20,
     453,   527,   453,   455,    19,   216,   453,   457,   467,   470,
     455,   594,   596,   601,   472,   453,    28,   525,   459,   132,
     519,   469,   123,   262,   263,   458,   517,   641,   467,   467,
     453,   467,   453,   453,   469,   457,   469,   659,   453,   453,
     453,   453,   469,   453,   469,   453,    19,   658,   467,   467,
     453,   467,   453,   467,   467,   453,   467,   453,   453,   453,
     453,   453,   467,   505,   453,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   467,   453,   467,   123,
     187,   279,   346,   368,   370,   375,   377,   381,   382,   458,
     669,   676,   679,   453,   123,   211,   416,   417,   420,   425,
     458,   517,   707,   123,   379,   429,   458,   517,   742,   453,
     453,   471,   470,   255,   380,   757,    19,    51,   120,   201,
     202,   203,   204,   205,   206,   207,   223,   226,   255,   458,
     629,   630,   634,   639,   760,   123,   458,   517,   765,    69,
     499,   538,   541,     3,     3,   505,   505,    15,   505,   477,
       3,   477,     3,     3,     3,     3,     3,     3,   184,   184,
     625,   637,    28,    28,   633,   633,   633,   633,   633,   459,
     455,   459,    29,   610,   633,   610,    29,   610,   610,   633,
     459,   633,   595,   604,   605,   639,   453,   455,   182,    20,
     473,   524,   526,    81,   133,   134,   135,   644,   650,   644,
     651,   470,   655,   453,   459,   453,   453,   453,   173,   211,
     327,   329,   331,   332,   335,   660,   661,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   688,   694,
     469,   348,   349,   381,   348,   469,   670,   323,   472,   672,
     673,   671,   383,   469,   453,   386,   689,   712,   720,   472,
     721,   726,   708,   709,   472,    79,   453,   745,   751,   469,
     467,   453,   471,   469,   467,    22,   454,    22,   454,   633,
     633,   633,   469,   632,   782,   453,   633,   635,   636,   768,
     773,   453,   467,     3,     3,    15,    15,    28,   455,   455,
     455,   455,   459,   633,   633,   455,   459,     7,   455,   459,
     455,   459,     7,   455,   459,   459,    15,   455,   458,   639,
     596,    15,   473,   527,   528,   457,   649,    31,   264,   652,
     467,   338,    69,   246,   330,   334,   333,   336,   337,   458,
     459,   527,   690,   467,   467,   469,   467,   457,   505,   457,
     457,   467,   467,   457,   528,   457,   725,   457,   470,   727,
     732,    20,   457,   733,   738,   469,   528,    69,   633,   638,
     633,   629,   453,   224,   457,   453,    22,    22,    33,   459,
     453,   528,   563,   563,    28,   633,   455,   455,    29,   610,
      29,   610,    29,   610,     7,    29,   610,    29,   610,   458,
     184,   649,   648,   645,    19,   476,   265,   653,   453,   193,
     328,   661,   691,   457,   693,   681,   674,   681,   677,   457,
     719,   724,   723,   728,   734,   457,   750,   467,   453,   455,
     453,   782,   457,   606,   639,   622,   633,   633,   126,   190,
     191,   247,   253,   636,   457,   772,     3,     3,   455,   455,
     455,   455,   459,     7,   455,   455,   455,   459,   454,   455,
       7,   455,   455,     7,   455,    15,   645,   138,   140,   168,
     256,   257,   260,   261,   266,   458,   542,   544,   545,   646,
     470,   262,   654,   689,   692,   458,   472,   682,   683,   187,
     348,   369,   458,   675,   458,   181,   266,   350,   351,   352,
     354,   458,   542,   678,   718,   717,   409,   410,   413,   414,
     415,   458,   722,   731,   737,   749,   746,   455,   604,   225,
       6,    15,    16,    17,   454,   458,   607,   609,   611,   613,
     614,   616,   618,   453,   453,   454,   454,   454,   454,   453,
     771,   769,    29,   610,    29,   610,   610,     7,   610,   453,
     476,   469,   457,   258,   259,   259,   468,   467,   127,   147,
     267,   268,   647,   457,   453,   469,    66,   181,   195,   255,
     258,   259,   266,   317,   320,   323,   346,   348,   350,   351,
     352,   353,   354,   355,   361,   364,   367,   379,   387,   458,
     542,   680,   369,   376,   684,   469,   467,   469,   453,   467,
     127,   267,   365,   467,   467,   282,   156,   467,   453,   182,
     188,   211,   256,   279,   323,   400,   401,   405,   406,   408,
     416,   417,   458,   713,   412,   412,   469,   469,   469,   453,
     412,   418,   458,   729,   412,   419,   458,   735,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   379,
     395,   430,   431,   433,   434,   436,   458,   542,   747,   453,
     458,   606,   604,   633,     7,   456,   459,   633,   633,   633,
     633,    42,    66,   258,   259,   351,   355,   430,   448,   458,
     770,   455,   455,   455,   459,   455,   454,   455,   543,   544,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   546,   323,   467,   457,   469,   372,   179,   180,
     353,   389,   531,   127,   267,   365,   318,   469,   390,   469,
     467,   467,   467,   282,   467,   156,   467,   356,   357,   358,
     359,   360,   361,   362,   363,   388,   358,   467,   380,   356,
     453,   467,   453,   467,   467,   399,   120,   403,   412,   403,
     726,   282,   399,   120,   412,   404,   469,   402,    76,   407,
     277,   265,   714,   265,   715,   453,   467,   467,   411,   467,
     739,   727,   730,   453,   739,   733,   736,   453,   467,   323,
     438,    76,   467,   469,   470,   469,   372,   353,   389,   531,
     127,   149,   365,   439,   748,   318,   380,   356,   432,    76,
      76,   371,   467,   435,   437,   453,   455,   454,   609,   604,
     616,   455,   455,   455,   455,   467,   323,   372,   353,   389,
     531,   260,   449,   450,   260,   467,   453,   610,   610,   458,
     453,   468,   468,   468,   149,   150,   467,    20,   475,   475,
     147,   148,   547,   139,   141,   139,   141,   458,   469,   685,
     373,   374,   467,   467,   467,   467,   467,   259,   469,   391,
     467,   467,   469,   469,   467,   469,   260,   422,   423,   424,
     716,    76,   467,    76,   467,   260,   716,   467,   467,   469,
     467,   467,    69,   469,   732,   469,   738,   421,   740,   740,
     467,   469,   469,   467,   467,   467,   467,   259,   469,   467,
     467,   467,   469,   469,   469,   633,   453,   453,   453,   453,
     469,   467,   467,   467,   467,   467,   455,   459,   543,   453,
     453,   453,   149,   150,   151,   152,   153,   149,   150,   151,
     152,   153,   453,   475,   475,   475,   475,   458,   470,   687,
     371,   469,   467,   467,   740,   467,   467,   740,   467,   469,
     371,   610,   546,   546,   546,   546,   453,   453,   453,   453,
     366,   686,   459,   546,   546,   546,   546,   453,   610,   455
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   463,   464,   464,   465,   465,   466,   467,   467,   467,
     468,   468,   468,   469,   469,   469,   469,   469,   469,   470,
     470,   471,   471,   472,   473,   473,   474,   474,   475,   476,
     476,   477,   477,   478,   478,   479,   480,   480,   481,   481,
     481,   482,   482,   483,   483,   484,   484,   484,   484,   484,
     484,   484,   484,   484,   485,   485,   486,   486,   486,   486,
     487,   487,   487,   487,   487,   487,   488,   489,   489,   489,
     489,   490,   491,   492,   493,   494,   495,   496,   496,   497,
     497,   497,   498,   499,   499,   500,   500,   500,   500,   500,
     500,   501,   502,   502,   503,   503,   504,   504,   505,   505,
     505,   505,   505,   506,   507,   507,   508,   508,   508,   508,
     509,   510,   510,   511,   512,   513,   513,   514,   514,   515,
     515,   516,   516,   516,   516,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     518,   518,   518,   518,   519,   519,   519,   519,   519,   520,
     520,   521,   522,   522,   523,   524,   524,   524,   525,   525,
     526,   527,   527,   528,   529,   530,   531,   531,   532,   533,
     533,   533,   533,   534,   535,   536,   536,   536,   537,   537,
     538,   538,   538,   538,   538,   538,   539,   539,   539,   540,
     540,   541,   541,   542,   542,   543,   543,   544,   544,   545,
     546,   546,   546,   546,   546,   546,   546,   546,   546,   547,
     547,   547,   547,   547,   547,   547,   547,   547,   547,   548,
     549,   550,   551,   552,   552,   553,   554,   555,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   557,   557,   557,   558,   559,   559,   559,   559,   560,
     560,   560,   561,   562,   562,   562,   562,   562,   562,   562,
     562,   563,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   577,   577,   578,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   588,   588,   589,   589,   589,   591,   590,   592,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   594,   595,   595,   596,   596,   597,
     598,   598,   599,   600,   600,   601,   603,   602,   604,   604,
     605,   605,   606,   606,   607,   608,   608,   608,   608,   608,
     608,   609,   609,   609,   609,   609,   610,   611,   611,   611,
     611,   611,   611,   611,   611,   611,   611,   612,   612,   612,
     612,   613,   613,   613,   614,   614,   614,   614,   614,   614,
     614,   614,   615,   615,   615,   615,   615,   616,   616,   616,
     616,   616,   617,   617,   618,   618,   619,   620,   620,   620,
     620,   621,   621,   622,   622,   622,   623,   623,   624,   624,
     625,   625,   625,   625,   625,   625,   626,   626,   626,   627,
     627,   627,   627,   627,   627,   627,   627,   627,   627,   628,
     628,   628,   628,   629,   630,   631,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   634,   634,   634,   634,
     634,   634,   635,   636,   636,   636,   637,   637,   638,   638,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   640,   641,   641,   641,
     641,   642,   642,   643,   644,   645,   646,   646,   646,   646,
     646,   646,   646,   646,   647,   647,   647,   647,   647,   647,
     648,   648,   649,   649,   650,   651,   652,   652,   652,   653,
     653,   654,   654,   655,   656,   657,   658,   658,   658,   659,
     659,   660,   660,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   662,   662,   662,   662,   662,   662,
     662,   662,   662,   662,   663,   664,   664,   665,   665,   665,
     665,   665,   665,   665,   665,   665,   666,   667,   668,   668,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   670,
     669,   671,   669,   669,   669,   669,   672,   672,   673,   674,
     674,   675,   675,   675,   676,   676,   677,   677,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   679,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   681,
     681,   682,   683,   684,   684,   684,   685,   685,   686,   686,
     687,   688,   689,   689,   691,   690,   692,   692,   693,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     703,   703,   703,   703,   703,   703,   703,   703,   704,   705,
     705,   705,   705,   705,   706,   707,   707,   707,   708,   707,
     709,   707,   707,   707,   710,   710,   711,   712,   713,   713,
     713,   713,   713,   713,   713,   713,   713,   713,   713,   713,
     713,   713,   713,   713,   714,   713,   715,   713,   713,   713,
     716,   716,   716,   717,   718,   718,   719,   719,   720,   721,
     722,   722,   722,   722,   722,   723,   724,   724,   725,   725,
     726,   727,   728,   729,   729,   729,   730,   731,   731,   732,
     732,   733,   734,   735,   735,   735,   736,   737,   737,   738,
     738,   739,   739,   740,   740,   741,   742,   742,   742,   742,
     742,   743,   743,   744,   745,   746,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   747,   747,   747,   747,   747,   747,   747,   747,   747,
     747,   748,   748,   748,   748,   749,   749,   750,   750,   751,
     752,   753,   754,   755,   755,   755,   755,   755,   756,   757,
     757,   757,   758,   758,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   760,   760,   761,   761,   762,   762,   763,
     764,   765,   765,   766,   766,   767,   768,   769,   770,   770,
     770,   770,   770,   770,   770,   770,   770,   770,   770,   770,
     771,   771,   772,   772,   773,   774,   775,   776,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   779,   779,   779,   779,
     779,   779,   779,   779,   779,   779,   779,   780,   780,   780,
     780,   781,   781,   781,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     5,     4,     2,     3,     3,     1,     2,     3,
       2,     4,     3,     2,     3,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     3,     4,     2,     2,     1,     0,
       2,     3,     1,     0,     1,     2,     0,     2,     0,     1,
       3,     0,     0,     2,     0,     3,     0,     3,     0,     3,
       3,     4,     6,     6,     6,     7,     6,     7,     5,     0,
       2,     3,     2,     3,     3,     2,     3,     2,     2,     3,
       3,     5,     4,     4,     2,     1,     2,     2,     0,     3,
       0,     3,     2,     3,     0,     3,     5,     0,     4,     4,
       3,     2,     3,     3,     3,     3,     4,     4,     4,     3,
       3,     4,     4,     2,     0,     3,     0,     3,     3,     3,
       1,     1,     1,     0,     0,     3,     0,     3,     4,     1,
       2,     2,     2,     4,     4,     0,     0,     3,     0,     3,
       3,     1,     0,     0,     2,     2,     0,     0,     3,     1,
       5,     1,     0,     0,     2,     2,     0,     0,     3,     1,
       5,     1,     2,     0,     2,     2,     1,     2,     4,     2,
       2,     0,     3,     5,     0,     0,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     4,     3,     2,     2,
       1,     1,     1,     1,     1,     0,     3,     0,     3,     4,
       6,     6,     2,     3,     3,     5,     5,     4,     2,     3,
       3,     3,     1,     2,     4,     3,     3,     3,     2,     2,
       2,     2,     2,     1,     3,     0,     2,     0,     3,     4,
       2,     1,     2,     0,     3,     5,     0,     0,     0,     2,
       2,     3,     3,     2,     2,     3,     3,     2,     3,     3,
       0,     3,     0,     3,     4,     6,     6,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     2,     1,
       2,     2,     2,     1,     1,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 867 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 881 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 891 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 901 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 909 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 910 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 911 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 914 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 921 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 929 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 933 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 941 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 945 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 949 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 956 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 965 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 973 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 984 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 998 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 1003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 1009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 1021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 1022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 1024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 1025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1032 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1033 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1049 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1050 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1051 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1052 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4672 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1054 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4678 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1064 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4684 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1065 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1067 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1076 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1079 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1086 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1089 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1092 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1095 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4738 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1098 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4768 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4780 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1123 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1124 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1135 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1136 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1137 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1149 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1154 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1158 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1172 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1187 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1188 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1195 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1202 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1224 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1225 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1226 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1227 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1232 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1238 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1239 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1243 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1257 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 5001 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1276 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 5012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1282 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 5021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1295 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 5056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 5062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1311 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 5068 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1312 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 5074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1313 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 5080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1314 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 5086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1315 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 5092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1316 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 5098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1317 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 5104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1318 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 5110 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1319 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); }
#line 5116 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1320 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 5122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 5128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1322 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 5134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1326 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 5140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 5146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1329 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 5152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 5158 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1334 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 5164 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 5170 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1336 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 5176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 5182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1341 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 5193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1347 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 5199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 5208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1359 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 5214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1360 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1368 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1376 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1377 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1378 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1382 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 5254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1383 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 5260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1397 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 5266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1399 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1411 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1418 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1428 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1432 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1446 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1447 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1448 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1453 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1457 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1458 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1459 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1461 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1462 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1468 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1469 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1470 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1479 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1480 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1501 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1521 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1523 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1524 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1525 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1526 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1527 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1528 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1529 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1533 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 5491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1534 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 5497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1535 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 5503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 5509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1537 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 5515 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1538 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1539 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5527 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1541 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1542 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1549 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1552 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1555 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1558 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1562 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1566 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1569 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1581 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1587 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1594 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1599 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1604 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1613 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1617 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1621 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1638 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1642 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1649 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1650 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1651 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1657 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1660 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1667 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1674 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1678 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1686 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1687 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1688 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1694 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1697 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1700 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1701 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1702 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1703 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1704 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1705 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1706 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1711 "cf-parse.y" /* yacc.c:1646  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1716 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1725 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1732 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1739 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1747 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1749 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1751 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1753 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1755 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1757 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1759 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1761 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1764 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1773 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1775 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1779 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 6003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1780 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 6012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1787 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1789 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1791 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1793 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 6036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1795 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 6042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1797 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 6048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1801 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 6054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1805 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 6060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1808 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 6066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1813 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1819 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1827 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1828 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 6119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1837 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 6125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1841 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 6131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1842 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 6137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 6143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 6149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 6155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1846 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 6161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 6167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 6173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 6179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 6185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 6191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 6197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1853 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 6203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 6209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1855 "cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1877 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 6252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1896 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1897 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1904 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1942 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 6331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1959 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1975 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1984 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6411 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6417 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6423 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2013 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2050 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2058 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2087 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2097 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2101 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2109 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2111 "cf-parse.y" /* yacc.c:1646  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2122 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2123 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2130 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2147 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2148 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2152 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2153 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2154 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2155 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2156 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2161 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2162 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2163 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2169 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2170 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2171 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2172 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2173 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2174 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2175 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2180 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2181 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2182 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2183 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2197 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2219 "cf-parse.y" /* yacc.c:1646  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 6961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 6967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 6973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 6979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2235 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2238 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2239 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 7015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2244 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2245 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2254 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2256 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2257 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2258 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2259 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 7111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2260 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 7117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2264 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2268 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 7153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 7159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2276 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2277 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 7195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 7201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2289 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 7207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2290 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 7213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2291 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2292 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2293 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2294 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2300 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2322 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 7279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2323 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 7285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2324 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 7291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2325 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 7297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2326 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 7303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2327 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 7309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2331 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2334 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2335 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2336 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2344 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2350 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2359 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2368 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2389 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2399 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2403 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2417 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2418 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2419 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2420 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2421 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2428 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2469 "cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2489 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2490 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2491 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2492 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2494 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2495 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2496 "cf-parse.y" /* yacc.c:1646  */
    {}
#line 7611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2500 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2505 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2523 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2527 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2528 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2529 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2533 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2534 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2538 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2539 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2543 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2562 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2567 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
#line 7749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2606 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 7785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 7791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 7797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 7803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 7809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 7815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 7821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 7827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 7833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2624 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2625 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2643 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2645 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2646 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2647 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2648 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2649 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2656 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 8000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 8006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2658 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 8012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 8018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 8024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2661 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 8030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 8036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 8042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 8048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2665 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 8054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 8060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2667 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 8066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2668 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 8072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 8078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 8084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2671 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 8090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2672 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 8101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2678 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2679 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2680 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 8119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2681 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 8125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 8131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2683 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 8137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 8143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 8149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2686 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 8155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2687 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 8161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 8167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 8173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2690 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 8179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 8185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 8191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2704 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 8209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2720 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 8215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2721 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2723 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2724 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2725 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2726 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2730 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2745 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 8275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2754 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2755 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 8287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2756 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 8293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2757 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2758 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2759 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2760 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2761 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 8323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2762 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 8329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2763 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 8335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2764 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 8341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2776 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2790 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2791 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2792 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2807 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2809 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2810 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2811 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2813 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2814 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2815 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2838 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2839 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2840 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2841 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2842 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2843 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2844 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2845 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2846 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2847 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2848 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2849 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2850 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2851 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2852 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2854 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2855 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2856 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2857 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2858 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2859 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2860 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2861 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2863 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2864 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2865 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2866 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2867 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2868 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2869 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2875 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2876 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2887 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2897 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2898 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2908 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2912 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2921 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2944 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2948 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2962 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2968 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2971 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2974 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2979 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2982 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2987 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2990 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2994 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2997 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3006 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3007 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3013 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3022 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3027 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3028 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3035 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 8926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3046 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 8932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3047 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3047 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 8944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3048 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3048 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 8956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3049 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 8966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3054 "cf-parse.y" /* yacc.c:1646  */
    { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 8972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3067 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = -1;
  RADV_IFACE->route_linger_time = -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 8998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3090 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 9004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3091 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 9010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3092 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 9016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3093 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 9022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3094 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 9028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3095 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 9034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3096 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 9040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3097 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 9046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3098 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 9052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3099 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3104 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3108 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 9077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3109 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 9083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 9089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3111 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 9095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3112 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 9101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3113 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3113 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 9113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3114 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3114 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 9125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3115 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 9131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3116 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 9137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 9143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3121 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 9149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3122 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 9155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3125 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 9196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3178 "cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 9211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3190 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 9217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3191 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 9223 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3192 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 9229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3193 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3197 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3204 "cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 9259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3237 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3244 "cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 9286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3248 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 9302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3272 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 9317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3284 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3291 "cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 9332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3295 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 9348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3319 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 9354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3320 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 9360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3324 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = -1; }
#line 9366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3325 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 9372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3333 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 9387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3346 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 9393 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3347 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 9399 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3348 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 9405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3362 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 9431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3385 "cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 9464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3415 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 9470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3416 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 9476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3417 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 9482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3418 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 9488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3419 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 9494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3420 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3421 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 9509 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3425 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 9515 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3426 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 9521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3427 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 9527 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3428 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 9533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3429 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 9539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3430 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 9545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3431 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 9551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3432 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3433 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 9563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3434 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3435 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 9575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3436 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 9581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3437 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 9587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3438 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 9593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3439 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 9599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3440 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3441 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 9611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3442 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 9617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3446 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 9623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3447 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 9629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3448 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3449 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3470 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3473 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3479 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 9662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3488 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 9668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3489 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3490 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 9680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3493 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3503 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3512 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3516 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3522 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 9729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3523 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3527 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3532 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3538 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3541 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3546 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3547 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3548 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3549 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3550 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3554 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 9809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3555 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3570 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3576 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
}
#line 9830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3596 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 9845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3609 "cf-parse.y" /* yacc.c:1646  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
#line 9871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3633 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3634 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 9883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3635 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
#line 9889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3636 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->update_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
#line 9895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3637 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 9901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3638 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 9907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3639 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 9913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3640 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3641 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 9925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3642 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 9931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 3643 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 9937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3664 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 9943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3667 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 9949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3670 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 9955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 3678 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 9961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 3678 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 9967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 9997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 10003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 10009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 10015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 10021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 10027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 10033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 10039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 10045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 10051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 10057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 10063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 10069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 10075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 10081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 10087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 10093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 10099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 10105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 10111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 10117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 10123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 10129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 10135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 10141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 3681 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 10147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 3682 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 10153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 3682 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 10159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 3683 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 10165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 3684 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 10171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 3685 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 10177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 3686 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 10183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 3687 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 10189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 3688 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 10195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 3689 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 10201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 3690 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 10207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 3691 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 10213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 3692 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 10219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 3693 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 10225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 10231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 10237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 10243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 10249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 10255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 10261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 10267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 10273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 10279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
#line 10285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 10289 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3696 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

