/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


#line 697 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    STATES = 373,
    FILTERS = 374,
    RECEIVE = 375,
    ACTION = 376,
    WARN = 377,
    BLOCK = 378,
    DISABLE = 379,
    KEEP = 380,
    FILTERED = 381,
    PASSWORD = 382,
    FROM = 383,
    PASSIVE = 384,
    TO = 385,
    EVENTS = 386,
    PACKETS = 387,
    PROTOCOLS = 388,
    INTERFACES = 389,
    ALGORITHM = 390,
    KEYED = 391,
    HMAC = 392,
    MD5 = 393,
    SHA1 = 394,
    SHA256 = 395,
    SHA384 = 396,
    SHA512 = 397,
    PRIMARY = 398,
    STATS = 399,
    COUNT = 400,
    FOR = 401,
    COMMANDS = 402,
    PREEXPORT = 403,
    NOEXPORT = 404,
    GENERATE = 405,
    ROA = 406,
    LISTEN = 407,
    BGP = 408,
    V6ONLY = 409,
    DUAL = 410,
    ADDRESS = 411,
    PASSWORDS = 412,
    DESCRIPTION = 413,
    SORTED = 414,
    RELOAD = 415,
    IN = 416,
    OUT = 417,
    MRTDUMP = 418,
    MESSAGES = 419,
    RESTRICT = 420,
    MEMORY = 421,
    IGP_METRIC = 422,
    CLASS = 423,
    DSCP = 424,
    WAIT = 425,
    MAX = 426,
    FLUSH = 427,
    AS = 428,
    SHOW = 429,
    STATUS = 430,
    SUMMARY = 431,
    ROUTE = 432,
    SYMBOLS = 433,
    ADD = 434,
    DELETE = 435,
    DUMP = 436,
    RESOURCES = 437,
    SOCKETS = 438,
    NEIGHBORS = 439,
    ATTRIBUTES = 440,
    EVAL = 441,
    ECHO = 442,
    ENABLE = 443,
    FUNCTION = 444,
    PRINT = 445,
    PRINTN = 446,
    UNSET = 447,
    RETURN = 448,
    ACCEPT = 449,
    REJECT = 450,
    QUITBIRD = 451,
    INT = 452,
    BOOL = 453,
    IP = 454,
    PREFIX = 455,
    PAIR = 456,
    QUAD = 457,
    EC = 458,
    LC = 459,
    SET = 460,
    STRING = 461,
    BGPMASK = 462,
    BGPPATH = 463,
    CLIST = 464,
    ECLIST = 465,
    LCLIST = 466,
    IF = 467,
    THEN = 468,
    ELSE = 469,
    CASE = 470,
    TRUE = 471,
    FALSE = 472,
    RT = 473,
    RO = 474,
    UNKNOWN = 475,
    GENERIC = 476,
    GW = 477,
    NET = 478,
    MASK = 479,
    PROTO = 480,
    SOURCE = 481,
    SCOPE = 482,
    CAST = 483,
    DEST = 484,
    IFNAME = 485,
    IFINDEX = 486,
    LEN = 487,
    DEFINED = 488,
    CONTAINS = 489,
    RESET = 490,
    PREPEND = 491,
    FIRST = 492,
    LAST = 493,
    LAST_NONAGGREGATED = 494,
    MATCH = 495,
    ROA_CHECK = 496,
    EMPTY = 497,
    WHERE = 498,
    BFD = 499,
    MIN = 500,
    IDLE = 501,
    RX = 502,
    TX = 503,
    INTERVAL = 504,
    MULTIPLIER = 505,
    MULTIHOP = 506,
    NEIGHBOR = 507,
    DEV = 508,
    LOCAL = 509,
    AUTHENTICATION = 510,
    SIMPLE = 511,
    METICULOUS = 512,
    SESSIONS = 513,
    HOLD = 514,
    CONNECT = 515,
    RETRY = 516,
    KEEPALIVE = 517,
    STARTUP = 518,
    VIA = 519,
    NEXT = 520,
    HOP = 521,
    SELF = 522,
    DEFAULT = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    CEASE = 571,
    HIT = 572,
    ADMINISTRATIVE = 573,
    SHUTDOWN = 574,
    PEER = 575,
    CONFIGURATION = 576,
    CHANGE = 577,
    DECONFIGURED = 578,
    CONNECTION = 579,
    REJECTED = 580,
    COLLISION = 581,
    OF = 582,
    OSPF = 583,
    AREA = 584,
    OSPF_METRIC1 = 585,
    OSPF_METRIC2 = 586,
    OSPF_TAG = 587,
    OSPF_ROUTER_ID = 588,
    RFC1583COMPAT = 589,
    STUB = 590,
    TICK = 591,
    COST = 592,
    COST2 = 593,
    RETRANSMIT = 594,
    HELLO = 595,
    TRANSMIT = 596,
    PRIORITY = 597,
    DEAD = 598,
    TYPE = 599,
    BROADCAST = 600,
    BCAST = 601,
    NONBROADCAST = 602,
    NBMA = 603,
    POINTOPOINT = 604,
    PTP = 605,
    POINTOMULTIPOINT = 606,
    PTMP = 607,
    STRICT = 608,
    CRYPTOGRAPHIC = 609,
    ELIGIBLE = 610,
    POLL = 611,
    NETWORKS = 612,
    HIDDEN = 613,
    VIRTUAL = 614,
    ONLY = 615,
    BUFFER = 616,
    LARGE = 617,
    NORMAL = 618,
    STUBNET = 619,
    TAG = 620,
    EXTERNAL = 621,
    LSADB = 622,
    ECMP = 623,
    WEIGHT = 624,
    NSSA = 625,
    TRANSLATOR = 626,
    STABILITY = 627,
    GLOBAL = 628,
    LSID = 629,
    INSTANCE = 630,
    REAL = 631,
    NETMASK = 632,
    LENGTH = 633,
    LSA = 634,
    SUPPRESSION = 635,
    TOPOLOGY = 636,
    STATE = 637,
    PIPE = 638,
    MODE = 639,
    OPAQUE = 640,
    TRANSPARENT = 641,
    RIP = 642,
    INFINITY = 643,
    UPDATE = 644,
    GARBAGE = 645,
    MULTICAST = 646,
    VERSION = 647,
    SPLIT = 648,
    HORIZON = 649,
    POISON = 650,
    REVERSE = 651,
    ZERO = 652,
    PLAINTEXT = 653,
    RIP_METRIC = 654,
    RIP_TAG = 655,
    STATIC = 656,
    PROHIBIT = 657,
    MULTIPATH = 658,
    BLACKHOLE = 659,
    UNREACHABLE = 660
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 626 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1172 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1189 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  70
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3635

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  427
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  272
/* YYNRULES -- Number of rules.  */
#define YYNRULES  969
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1846

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   660

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     418,   419,    29,    27,   423,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   420,   417,
      23,    22,    24,   424,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   425,     2,   426,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   421,     2,   422,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   826,   826,   827,   830,   832,   840,   849,   850,   851,
     858,   859,   860,   868,   869,   870,   871,   872,   873,   879,
     880,   887,   888,   892,   899,   900,   904,   908,   915,   923,
     924,   931,   932,   936,   937,   943,   952,   953,   957,   962,
     963,   967,   968,   972,   973,   977,   978,   979,   980,   981,
     982,   983,   984,   985,   991,   992,  1002,  1003,  1004,  1005,
    1008,  1009,  1010,  1011,  1012,  1013,  1017,  1023,  1024,  1025,
    1026,  1034,  1037,  1044,  1047,  1050,  1053,  1057,  1058,  1062,
    1063,  1064,  1072,  1077,  1078,  1082,  1083,  1087,  1094,  1095,
    1096,  1108,  1113,  1117,  1131,  1132,  1146,  1147,  1151,  1152,
    1153,  1154,  1161,  1175,  1177,  1179,  1183,  1184,  1185,  1186,
    1191,  1197,  1198,  1202,  1210,  1214,  1216,  1222,  1223,  1230,
    1231,  1235,  1241,  1245,  1254,  1263,  1265,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,  1281,
    1285,  1286,  1287,  1288,  1292,  1293,  1294,  1295,  1296,  1300,
    1306,  1310,  1318,  1319,  1327,  1335,  1336,  1337,  1341,  1342,
    1346,  1351,  1352,  1356,  1358,  1366,  1370,  1371,  1377,  1384,
    1385,  1386,  1387,  1391,  1399,  1405,  1406,  1407,  1411,  1412,
    1416,  1417,  1418,  1419,  1420,  1421,  1427,  1428,  1429,  1433,
    1434,  1438,  1439,  1445,  1446,  1449,  1451,  1455,  1456,  1460,
    1480,  1481,  1482,  1483,  1484,  1485,  1486,  1487,  1488,  1492,
    1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,  1501,  1507,
    1510,  1513,  1516,  1520,  1521,  1524,  1527,  1531,  1535,  1540,
    1546,  1553,  1558,  1563,  1568,  1572,  1576,  1580,  1589,  1597,
    1601,  1608,  1609,  1610,  1615,  1619,  1626,  1633,  1637,  1645,
    1646,  1647,  1652,  1656,  1659,  1660,  1661,  1662,  1663,  1664,
    1665,  1670,  1675,  1683,  1690,  1697,  1705,  1707,  1709,  1711,
    1713,  1715,  1717,  1719,  1722,  1726,  1732,  1733,  1734,  1738,
    1739,  1745,  1747,  1749,  1751,  1753,  1755,  1759,  1763,  1766,
    1770,  1771,  1772,  1776,  1777,  1778,  1786,  1786,  1796,  1800,
    1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,
    1811,  1812,  1813,  1814,  1836,  1847,  1848,  1855,  1856,  1863,
    1872,  1876,  1880,  1901,  1902,  1906,  1918,  1918,  1934,  1935,
    1938,  1939,  1943,  1946,  1955,  1968,  1969,  1970,  1971,  1972,
    1976,  1984,  1985,  1986,  1987,  1988,  1992,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2009,  2010,  2011,
    2012,  2016,  2017,  2018,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2034,  2035,  2036,  2037,  2038,  2042,  2043,  2044,
    2045,  2046,  2050,  2051,  2055,  2056,  2060,  2067,  2068,  2069,
    2070,  2077,  2078,  2081,  2082,  2089,  2101,  2102,  2106,  2107,
    2111,  2112,  2113,  2114,  2115,  2116,  2120,  2121,  2122,  2126,
    2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2139,
    2140,  2141,  2142,  2152,  2156,  2178,  2190,  2191,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2199,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,  2219,  2221,  2222,  2223,  2225,  2227,  2229,  2231,
    2232,  2233,  2234,  2235,  2236,  2246,  2247,  2248,  2249,  2250,
    2251,  2252,  2253,  2255,  2256,  2259,  2281,  2282,  2283,  2284,
    2285,  2286,  2290,  2293,  2294,  2295,  2303,  2309,  2317,  2318,
    2322,  2327,  2335,  2343,  2348,  2352,  2358,  2362,  2367,  2368,
    2369,  2376,  2377,  2378,  2379,  2380,  2386,  2398,  2399,  2400,
    2401,  2404,  2406,  2410,  2414,  2428,  2448,  2449,  2450,  2451,
    2452,  2453,  2454,  2455,  2459,  2460,  2461,  2462,  2463,  2464,
    2467,  2469,  2472,  2474,  2478,  2481,  2486,  2487,  2488,  2492,
    2493,  2497,  2498,  2501,  2520,  2526,  2551,  2553,  2554,  2559,
    2560,  2564,  2565,  2569,  2570,  2571,  2572,  2573,  2574,  2575,
    2576,  2577,  2581,  2582,  2583,  2584,  2585,  2586,  2592,  2593,
    2594,  2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,  2603,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2613,
    2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,  2623,
    2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2637,  2638,
    2639,  2640,  2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,
    2649,  2650,  2651,  2652,  2663,  2673,  2674,  2678,  2679,  2680,
    2681,  2682,  2683,  2684,  2685,  2686,  2689,  2704,  2707,  2709,
    2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,
    2722,  2723,  2723,  2724,  2725,  2726,  2730,  2731,  2735,  2743,
    2745,  2749,  2750,  2751,  2755,  2756,  2759,  2761,  2764,  2765,
    2766,  2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  2777,
    2797,  2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,  2806,
    2807,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,
    2817,  2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,  2826,
    2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,  2838,
    2840,  2843,  2845,  2854,  2856,  2857,  2860,  2862,  2866,  2867,
    2870,  2880,  2901,  2903,  2907,  2907,  2910,  2912,  2915,  2917,
    2921,  2926,  2929,  2932,  2937,  2940,  2945,  2948,  2952,  2956,
    2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,  2972,  2979,
    2980,  2981,  2986,  2987,  2993,  3006,  3007,  3008,  3009,  3010,
    3013,  3015,  3019,  3023,  3046,  3076,  3077,  3078,  3079,  3080,
    3081,  3082,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,
    3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,
    3107,  3108,  3109,  3110,  3113,  3115,  3118,  3120,  3124,  3130,
    3133,  3140,  3147,  3148,  3149,  3150,  3151,  3154,  3164,  3173,
    3177,  3183,  3184,  3188,  3193,  3199,  3202,  3207,  3208,  3209,
    3210,  3211,  3215,  3216,  3219,  3221,  3224,  3226,  3230,  3237,
    3237,  3237,  3237,  3237,  3237,  3237,  3237,  3237,  3237,  3237,
    3237,  3237,  3237,  3237,  3237,  3238,  3238,  3238,  3238,  3238,
    3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,
    3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,
    3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,
    3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,  3238,
    3238,  3238,  3238,  3238,  3239,  3239,  3239,  3239,  3239,  3239,
    3239,  3239,  3239,  3240,  3240,  3240,  3240,  3241,  3241,  3241,
    3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,
    3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,
    3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,  3242,
    3242,  3243,  3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,
    3251,  3252,  3253,  3254,  3255,  3255,  3255,  3255,  3255,  3255
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "OSPF",
  "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "TYPE", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN",
  "VIRTUAL", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE",
  "TRANSPARENT", "RIP", "INFINITY", "UPDATE", "GARBAGE", "MULTICAST",
  "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE",
  "UNREACHABLE", "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'",
  "'['", "']'", "$accept", "config", "conf_entries", "definition", "expr",
  "expr_us", "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text", "opttext", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,    59,    40,    41,
      58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1440

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1440)))

#define YYTABLE_NINF -489

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      89,  3297,   110,   888,   446,   521,   142,   446,   446,   639,
     446,   185,   121,  2534,   237,   258,   804,  1851,    58,   446,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,   350,   882,   363,   686,   315,   313,   409,   321,
   -1440, -1440,   449,   386,   326,   232,  1851,   495, -1440, -1440,
   -1440, -1440, -1440, -1440,   245,   245, -1440, -1440, -1440, -1440,
     128, -1440,  1079, -1440,   245,  3197, -1440, -1440, -1440,   245,
   -1440,   245,  2977,   245,  2670,   245,  3091,   245, -1440,   245,
    1514, -1440, -1440,  2611,  3213, -1440, -1440, -1440,    62, -1440,
     578,   551,   612,   578,   541, -1440,   630,   630,   446,   446,
     626,   283, -1440,   556,   593,   168, -1440,   658,   675, -1440,
   -1440,   420,   188,   -25,   689,   220,   220,   715,   732,   734,
     759,   768,   785,   795,   800,    43, -1440, -1440, -1440,   703,
     388, -1440,   561,    90,    -2,  1851, -1440,   398,   407,   435,
   -1440, -1440,   451,   459,   467,  1339,   135, -1440, -1440, -1440,
   -1440, -1440,  2524, -1440,  2933, -1440, -1440,  1485,   890,   630,
     805, -1440, -1440,   852, -1440, -1440,     0,   299,    62,    18,
   -1440, -1440, -1440, -1440,   661,   500,    18,    18,   754,   774,
     158, -1440,   928, -1440,   283,   545,  3506, -1440,   830,   931,
     554,   558, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,   575,    62,   667,   986,   896,    18,   373, -1440,
     845,   724,   812,   939,   812,   283, -1440,   599,   606,   614,
     636,   -52,   710,   999,   610,  1082,   780,   812,   373,  1036,
    1022,   301,   948,   373,   269,   220,   201,  1040,    88,  1041,
     855,   849,   457,  1042,   846,   453,   834,   831,   373,   833,
     828,   824,   769,   -74,  1050,   821,   825,   373,  -138,   373,
   -1440,   725,   719,   772,   174,   373,  1034,    18,   373,  1038,
   -1440, -1440,   739,   746, -1440,   749,  1065,   475, -1440,   763,
     750,   755,   858,   220,  1096, -1440,   766,   394,   764,  1098,
     373,  1110,   373,  1116,  1108,  1112,    18, -1440,   781,   782,
     783,  1127,   630, -1440,   788,   801, -1440, -1440,  1045,  1214,
     541, -1440, -1440,  1221,    18,  1232, -1440,  1237,  1238,  1239,
    1241, -1440, -1440, -1440,   211,  1242,  1187,  1244, -1440, -1440,
     893,  1245, -1440,  1247,   615, -1440, -1440,  3344,  1246,   689,
   -1440,   689,   689, -1440,    37,    86,  1248,   689,   689,  1249,
   -1440, -1440,    10,  1071,  1072, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440,    31, -1440,    43,  1851,    43,    43,  1254,
   -1440,  1240,  1076,  1231,   100,  1233,    -2,    -2,  1229,  1230,
    1851,  1851,  1851,  1851,  1851,  1243, -1440, -1440,  1255, -1440,
     848,   114, -1440, -1440, -1440, -1440,   891, -1440,  1265, -1440,
   -1440, -1440, -1440,   302,    63, -1440,   347, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1851,  1851,  1063, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440,   466, -1440, -1440,  1272,  1273,  1851,
     812, -1440, -1440,  1485,   863, -1440, -1440, -1440, -1440, -1440,
   -1440,    18,  1851, -1440, -1440, -1440, -1440,    18,   872,   933,
   -1440,   655, -1440, -1440,    18, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,  1851,   865,  3358, -1440,   207,   866, -1440,   867,
    1268, -1440, -1440, -1440,   -84, -1440, -1440,   373, -1440, -1440,
     174, -1440, -1440, -1440, -1440,    44,  1951, -1440,  1147,  1851,
   -1440, -1440,    44, -1440, -1440,    44, -1440, -1440, -1440, -1440,
   -1440, -1440,  1212,  1213,   373,   272, -1440,   876,     4,   880,
     883,    18,   314,   993,   373,  1132,   220,   885, -1440,   897,
    1288,    69,    18,  1140,    18,  1257,  1259,    18,  1260,   -93,
      18,    18,   373,  1262,   908,  1222,   913,   373,   914,   373,
     468,   373,   986,   373,   925,   926,   373,   373,   373,   929,
    1161,   373,   936, -1440, -1440,   373, -1440, -1440,   373, -1440,
    1279,    18, -1440, -1440, -1440,  1331,   943,   944, -1440, -1440,
   -1440,   373, -1440,   986, -1440, -1440,   946, -1440,   220, -1440,
    1088, -1440, -1440, -1440,   951,    18, -1440,    18, -1440,   373,
     373,   373, -1440, -1440, -1440, -1440,    18,   220, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440,   603, -1440, -1440,  1367,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,   622,
   -1440, -1440, -1440, -1440,  1371, -1440, -1440, -1440,  1356, -1440,
   -1440,  1361,   220, -1440, -1440,  1358,  1359, -1440,  1951, -1440,
   -1440, -1440, -1440,   220, -1440, -1440, -1440,  1360, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1381,  1365,  1365,
     854,   689,  1365,   689,  1365, -1440,  1365,  1365, -1440,    18,
     220, -1440,  1377,  1379,  1391, -1440, -1440,  1044, -1440, -1440,
   -1440, -1440,   200, -1440,   967, -1440,  1143,  1382, -1440, -1440,
   -1440, -1440,   501,   534,   730,  1136,   756,   113, -1440,  1851,
   -1440,  1851,   984,    29,   988,  1203,   147,   198, -1440, -1440,
   -1440,  1394,  1398, -1440,  3012,  3012,  3012,  3532,  3532,  3012,
    3012,  3012,  3012,  3012,   673,   673,  1230,  1230, -1440,  1001,
   -1440, -1440, -1440, -1440, -1440,  1485, -1440, -1440,  2426, -1440,
     625, -1440, -1440,  1789,  1400, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,  1004, -1440,  1005,  1898, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440,    38,  1006,  1003, -1440, -1440,    18, -1440, -1440,   220,
   -1440, -1440, -1440,  2865,  3358, -1440,   220, -1440,  1008, -1440,
    1407, -1440,  1013, -1440,  1294, -1440, -1440, -1440, -1440,   373,
    3506, -1440, -1440,  2702,    18,    18,  1020,    18,  1021,  1026,
   -1440,   373,    64, -1440, -1440,  1027,  1028,  1030,  1031,   373,
    1037,   373,  1039, -1440, -1440,  1436, -1440,    18,    18, -1440,
    1043,    18,  1047,    18,    18,  1049,    18,  1051,  1052,  1053,
    1057,  1059,    18, -1440,   174, -1440,  1061, -1440,  1062,  1064,
    1067,  1068,  1069,  1070,  1073, -1440, -1440,  1080,  1083,  1085,
   -1440,   275,  1086, -1440, -1440, -1440,    18, -1440,   940,  1092,
   -1440, -1440,  3024,  1093,  1095, -1440,  1288, -1440,   220,  -123,
    1088,   835, -1440, -1440, -1440, -1440, -1440,  1388, -1440,    10,
   -1440, -1440, -1440,  1045, -1440, -1440,   211, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1455,  1458,
   -1440, -1440,   174, -1440, -1440,   174,  1447, -1440,   174,  1365,
    1464,  1365,  1477,  1486,  1490, -1440, -1440,  1304,  1312,    43,
   -1440,  1851, -1440,  1471,  1487,  1851,  1851,  1851, -1440,  1851,
   -1440,  1851,   811,   172,  1385,  1851,  1579,  1851, -1440, -1440,
    1851, -1440, -1440,  1090,   703, -1440,  1851, -1440, -1440, -1440,
   -1440, -1440, -1440,  1013, -1440, -1440, -1440, -1440,  3358,  1227,
   -1440, -1440, -1440,  1097,  1099, -1440,  1334, -1440, -1440,   983,
   -1440,   493, -1440, -1440, -1440, -1440,   220, -1440, -1440,  1100,
    1102,  1109, -1440,  1111, -1440, -1440,  1123,   657, -1440,  1125,
   -1440, -1440, -1440, -1440,  1126, -1440,  1128, -1440, -1440,   161,
   -1440, -1440, -1440,  1130, -1440,  1135,  1137, -1440,  1139, -1440,
   -1440, -1440, -1440, -1440,  1141,  1142, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1144, -1440,
   -1440, -1440,   373,  -214,   343, -1440,  1204,   220, -1440, -1440,
     533, -1440,  1145, -1440,  1158, -1440, -1440,   373,    18, -1440,
   -1440,  1146, -1440, -1440, -1440,  1288,   373,    18,  -123,    55,
   -1440,  1531, -1440, -1440,  1154,  1851, -1440, -1440, -1440,  1851,
    1851,   373, -1440,  2524,  1148,  1648, -1440, -1440,    18, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1554, -1440,
    1561, -1440, -1440, -1440,  1558,  1559, -1440, -1440,  1549, -1440,
    2021,  2059,  2096,  2125,   837,  1851, -1440,  1851,   160,    27,
    3506,  1155,   170,    20,  1156,  1203,  1566,  2166, -1440,  1160,
      70, -1440,  3358, -1440,  1569,   220, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440,  1164, -1440,    61, -1440, -1440,
      18, -1440, -1440, -1440,  1250,  1518, -1440,  -151,  1256,  1269,
     723,   653, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440,    18,    18,   373,
      18, -1440,  1168,   174, -1440, -1440,  1172,  1180,    18, -1440,
   -1440,    18,  1182, -1440, -1440,  1535, -1440, -1440, -1440, -1440,
   -1440,  1851,  1076,  1851, -1440,  2457,  2879,   870,  1193,  1592,
     518, -1440,  3506,  1195,  1206, -1440, -1440, -1440,   556,   556,
    1593, -1440, -1440, -1440, -1440,  1851,  2192,  2232, -1440,  1596,
    1851, -1440,  1714, -1440,  1597,  1851,  1620,  1762,  1828,  1211,
   -1440, -1440, -1440, -1440,  1444, -1440,  1013,  1164, -1440, -1440,
    1617,   812,  1375,  1224,  1453,  1320, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440,   657,  1013,  1251, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1252,    18,  2483,
    1258,  2509,  2894, -1440,  1777, -1440, -1440,  1851,  1851,   605,
    1648, -1440,  1656,  1657, -1440,  2262, -1440, -1440,  1263,  1266,
     191,    32,  1267,   303,  1253,  1274,    34,  1275,    40, -1440,
    1654, -1440,   379, -1440, -1440, -1440,   220,  1408, -1440, -1440,
   -1440, -1440,  1158, -1440, -1440,    47,   261,    49,   609, -1440,
   -1440, -1440, -1440, -1440, -1440,  1277,  1227,  1449, -1440,    36,
    2537,  2564,  1261,  1280,  1282,  1283,  1264, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440,  1655,  1851, -1440, -1440, -1440,  1658,
    1851, -1440,  1851,  1685, -1440,  1851, -1440,  1286, -1440,   812,
     373,  1276,   820,  1445,    18,    18,    59, -1440, -1440, -1440,
    1290,  1296, -1440,   373, -1440, -1440,  3087, -1440, -1440, -1440,
      94,   373,    18,   373, -1440,  1297, -1440,    18,    -8,    18,
      18,  1430,   231, -1440, -1440,  1298,  2515, -1440,  1299,  1301,
    1777,    98, -1440, -1440, -1440,   891, -1440, -1440,  1711, -1440,
   -1440, -1440, -1440,   377, -1440, -1440,  1851,  1851,  1851,  1851,
   -1440,  1300,  1302,  1306,  1303,  1309,  1317,  1319, -1440, -1440,
   -1440,  1582,  1476,  1479,  1480, -1440, -1440, -1440,   934, -1440,
    1598, -1440,   516, -1440, -1440,  1425,    18,  1328,   373,  1378,
     -23,    77,  1433,   373,  1366,   373,    18,    18,    18,  1473,
      18,   270,  1295,  1370,  1401,    18,  1380,  1405, -1440, -1440,
    1346, -1440,    18,  1350, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440,    18,    18, -1440, -1440,    18,  -262,
    1695,    18,   373,   220,   373,  1404,   222,     6,  1454,  1393,
      11,  1707,  1708,   297,  1383,  1386, -1440, -1440,  1368, -1440,
   -1440, -1440, -1440,  2296,   219,    98,   264,  2322,  2348,  2374,
    2400, -1440, -1440, -1440,  1851, -1440,  1851, -1440,  1364,  1387,
      18,    18,    18, -1440, -1440,   937,    18,  1767,  1767,   950,
     339,   481,  1373,   373, -1440, -1440, -1440,   228,    18,    18,
      18,    18, -1440, -1440, -1440, -1440,   569, -1440,  1411, -1440,
   -1440, -1440, -1440,    18, -1440,    18, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440,   373,   373, -1440,    18,   373,
   -1440, -1440, -1440, -1440, -1440, -1440,   373,   373,    18, -1440,
   -1440, -1440, -1440,    18,    18,    18, -1440, -1440, -1440, -1440,
   -1440, -1440,   628,    18, -1440, -1440,    18,    18,   373, -1440,
     373,   373, -1440, -1440,  1851, -1440, -1440, -1440,  1392,  1403,
    1412,  1413,  1389,  1402, -1440,  1582, -1440, -1440, -1440, -1440,
   -1440,  1415, -1440,  1416,  1418,   789,   869,  1419,  1767,  1767,
    1767,  1767, -1440, -1440,    52, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,  1434, -1440,   373, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440,  1450, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440,  2296, -1440, -1440, -1440, -1440,
   -1440,  1851, -1440,   516,   516,   516, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440,   516,  1420,  1432,  1435,
    1437, -1440,  1484, -1440, -1440, -1440, -1440,  1428, -1440, -1440,
   -1440, -1440,   516,   516,   516,   516, -1440,  1442,  1851, -1440,
   -1440, -1440, -1440, -1440,  1423, -1440
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,     3,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     119,   120,     0,     0,     0,     0,   423,     0,   839,   840,
     841,   842,   843,   844,   121,   121,   845,   846,   847,   848,
     117,   849,     0,   851,   121,   125,   852,   853,   854,   121,
     907,   121,   125,   121,   125,   121,   125,   121,   911,   121,
     125,     5,   850,   125,   125,   290,   292,   291,     0,    78,
      77,     0,     0,    77,    79,    76,    34,    34,     0,     0,
       0,     0,   289,   261,   294,     0,   245,     0,     0,   228,
     253,     0,   224,     0,   224,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   405,   409,   418,   415,   334,
     425,   412,     0,     0,   408,   423,   456,     0,     0,     0,
     410,   411,     0,     0,     0,   423,     0,   413,   414,   422,
     454,   455,     0,   453,     0,   277,   276,     0,   279,    34,
       0,    30,    29,    37,    40,    38,     0,    18,     0,     0,
      59,    58,    57,    56,     0,     0,     0,     0,     0,   111,
       0,   296,     0,   104,     0,     0,   298,   326,   122,     0,
       0,     0,   115,    82,    91,   168,   545,   506,   624,   758,
     764,   811,     0,     0,     0,     0,     0,     0,    18,   173,
       0,     0,     0,     0,     0,     0,   906,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
       0,     0,     0,    18,     0,   546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,    18,
     908,     0,     0,     0,     0,    18,     0,     0,    18,     0,
     909,   627,     0,     0,   635,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,   912,     0,     0,   836,     0,
      18,     0,    18,     0,     0,     0,     0,   904,     0,     0,
       0,     0,    34,   905,     0,     0,   176,   175,     0,     0,
      79,    73,    74,     0,    80,     0,    33,     0,     0,     0,
       0,   284,   187,   186,     0,     0,     0,     0,   293,   295,
     294,     0,   225,     0,   249,   220,   219,     0,     0,   224,
     223,   224,   224,   749,   224,   224,     0,   224,   224,     0,
      19,    20,     0,     0,     0,   272,   268,   273,   269,   266,
     267,   270,   271,   405,   425,   405,   423,   405,   405,     0,
     396,     0,   423,     0,     0,     0,   408,   408,     0,   451,
     423,   423,   423,   423,   423,     0,   357,   358,     0,   360,
       0,     0,   335,   338,   336,   340,   423,   337,   375,   372,
     373,   374,   382,     0,   387,   391,     0,   951,   920,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   946,   947,   948,   949,   426,   950,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   953,
     956,   955,   952,   954,   957,   958,   959,   962,   960,   961,
     963,   964,   965,   966,   967,   968,   969,   457,   458,   274,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,     0,    45,    46,    47,    48,    49,
      50,    51,    52,    53,     0,    43,   280,     0,     0,   423,
       0,    39,    41,     0,     0,     7,     9,    14,    16,    15,
      17,     0,   423,    13,    67,   152,   153,    60,     0,     0,
      66,     0,    69,    70,     0,   112,   113,    98,   100,   101,
     102,   164,   423,     0,   315,   114,     0,     0,    55,     0,
       0,   123,   913,   917,     0,   169,   128,    18,   151,   137,
       0,   126,   127,   154,   142,     0,   315,   143,     0,   423,
     130,   141,     0,   131,   136,     0,   139,   129,   170,   171,
     511,   562,     0,     0,    18,    18,   574,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,   575,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,    18,     0,    18,
       0,    18,     0,    18,     0,     0,    18,    18,    18,     0,
       0,    18,     0,   563,   625,    18,   636,   628,    18,   633,
     630,     0,   626,   638,   759,     0,     0,     0,   760,   770,
     812,    18,   817,     0,   813,   828,     0,   827,     0,   831,
       0,   829,   830,   834,     0,     0,    85,     0,    87,    18,
      18,    18,    95,   915,   916,   914,     0,     0,   919,   918,
     181,   180,   182,   184,   185,   183,     0,   178,   287,     0,
      75,    81,    71,   283,   281,   285,   286,   191,   192,     0,
     189,   288,   262,   265,     0,   221,   226,   244,     0,   251,
     250,     0,     0,   227,   234,     0,     0,   242,   315,   236,
     235,   239,   240,     0,   241,   243,   229,     0,   233,   252,
     260,   254,   257,   258,   256,   259,   255,     0,    32,    32,
       0,   224,    32,   224,    32,   741,    32,    32,   838,     0,
       0,    23,     0,     0,     0,   400,   402,     0,   403,   404,
     398,   386,   486,   489,     0,   465,     0,     0,   466,   406,
     407,   399,     0,     0,     0,     0,     0,     0,   359,   423,
     436,   423,     0,     0,     0,   346,     0,     0,   416,   388,
     389,     0,     0,   417,   448,   446,   444,   441,   442,   443,
     445,   447,   449,   450,   437,   438,   439,   440,   459,     0,
     460,   462,   463,   464,   278,     0,   275,   282,     0,    36,
       0,    35,    68,     0,     0,    62,    63,    64,    65,    10,
      11,    12,     0,   154,     0,     0,    96,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   297,   319,     0,   108,   109,     0,
     103,   105,    54,     0,   315,   124,     0,   118,     0,   138,
     158,   161,   174,   150,   144,   133,   320,   321,   140,    18,
     322,   134,   132,   125,     0,     0,     0,     0,     0,     0,
     568,    18,    18,   605,   608,     0,     0,     0,     0,    18,
       0,    18,     0,   623,   576,     0,   546,     0,     0,   566,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   570,     0,   571,     0,   603,     0,     0,
       0,     0,     0,     0,     0,   582,   583,     0,     0,     0,
     610,     0,     0,   606,   632,   629,     0,   634,     0,     0,
     762,   763,   125,     0,     0,   824,    21,   826,     0,   821,
     825,   423,   816,    94,    86,    88,    89,    83,    92,    25,
      24,    93,   177,     0,    72,   188,     0,   222,   248,   247,
     246,   231,   238,   232,   230,   237,   544,    31,     0,     0,
     748,   757,     0,   755,   752,     0,     0,   750,     0,    32,
       0,    32,     0,     0,     0,    26,    27,     0,     0,   405,
     397,   423,   475,     0,     0,   423,   423,   423,   452,   423,
     473,   423,     0,     0,   423,   423,   423,   423,   339,   334,
     423,   376,   383,     0,     0,   392,   423,    44,     6,    42,
       8,    61,   110,   165,    97,    99,   314,   313,   315,   423,
     107,   106,   324,   317,     0,   327,     0,   172,   159,     0,
     154,     0,   149,   135,   514,   514,     0,   513,   507,     0,
       0,     0,   622,     0,   618,   617,     0,     0,   549,     0,
     607,   611,   612,   613,     0,   601,     0,   591,    22,     0,
     547,   548,   564,     0,   572,     0,     0,   595,     0,   578,
     577,   590,   589,   584,     0,     0,   604,   587,   579,   580,
     581,   609,   620,   586,   585,   621,   588,   615,     0,   614,
     631,   731,    18,     0,    18,   649,     0,     0,   651,   641,
      18,   637,     0,   655,   732,   761,   773,    18,     0,   772,
     765,     0,   814,   815,   823,    21,    18,     0,   822,     0,
     479,     0,   480,   481,     0,   423,   477,   478,   476,   423,
     423,    18,   837,     0,     0,   423,   832,   835,     0,    90,
     179,   190,   743,   742,   756,   751,   753,   754,     0,   744,
       0,   746,   809,   810,     0,     0,   401,   487,     0,   467,
       0,     0,     0,     0,     0,   423,   419,   423,     0,     0,
     346,     0,     0,     0,     0,     0,     0,     0,   316,     0,
     423,   330,     0,   323,     0,   155,   156,   160,   162,   147,
     145,   146,   148,   154,   508,   532,   509,   536,   510,   512,
       0,   596,   619,   598,     0,     0,   553,     0,     0,     0,
       0,     0,   551,   599,   600,   602,   567,   565,   594,   593,
     573,   592,   569,   616,   154,   654,   642,     0,     0,    18,
       0,   640,     0,     0,   658,   653,   657,     0,     0,   647,
     639,     0,   665,   154,   769,   766,   768,   771,   818,   820,
     819,   423,   423,   423,   423,     0,     0,     0,     0,     0,
       0,   499,   482,   484,     0,    84,   745,   747,   261,   261,
       0,   472,   470,   471,   469,   423,     0,     0,   355,     0,
     423,   353,   423,   349,     0,   423,   347,   423,   423,     0,
     461,   325,   331,   318,     0,   157,   163,   532,   530,   515,
       0,     0,   539,     0,     0,     0,   557,   555,   556,   559,
     558,   560,   550,     0,   734,   738,   644,   645,   643,   646,
     719,   679,   659,   719,   648,   733,   666,   806,     0,     0,
       0,     0,     0,   493,   423,   393,   833,   423,   423,     0,
     423,   498,     0,     0,   468,     0,   420,   421,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   390,
       0,   515,     0,   535,   537,   538,     0,   541,   597,   561,
     554,   552,   732,   736,   740,     0,     0,     0,   668,   804,
     774,   767,   492,   424,   496,     0,   423,   490,   332,     0,
       0,     0,     0,     0,     0,     0,     0,   485,   263,   264,
     474,   370,   354,   352,     0,   423,   350,   368,   348,     0,
     423,   366,   423,   364,   363,   423,   361,     0,   534,     0,
      18,     0,     0,     0,     0,     0,     0,   533,   523,   194,
     198,     0,   540,    18,   543,   735,     0,   650,   722,   720,
     723,    18,     0,    18,   656,     0,   652,     0,     0,     0,
       0,     0,     0,   664,   678,     0,     0,   808,     0,     0,
     423,   423,   341,   345,   343,   423,   500,   344,   380,   377,
     378,   379,   384,     0,   495,   494,   423,   423,   423,   423,
     501,     0,     0,     0,     0,     0,     0,     0,   116,   199,
     521,   195,     0,     0,     0,   516,   520,   524,     0,   525,
       0,   522,   200,   531,   542,     0,     0,     0,    18,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   739,   718,
       0,   724,     0,     0,   662,   663,   661,   660,   672,   675,
     676,   677,   670,   669,     0,     0,   673,   667,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   807,   799,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   684,   726,   716,     0,     0,     0,
       0,     0,   711,   705,   706,   707,    18,   717,     0,   700,
     680,   683,   681,     0,   698,     0,   685,   687,   688,   689,
     690,   691,   692,   693,   694,    18,    18,   682,     0,    18,
     737,   725,   721,   671,   674,   780,    18,    18,     0,   775,
     778,   779,   797,     0,     0,     0,   792,   800,   803,   802,
     801,   798,    18,     0,   777,   776,     0,     0,    18,   781,
      18,    18,   805,   342,   423,   381,   394,   385,     0,     0,
       0,     0,     0,     0,   193,   195,   517,   518,   519,   528,
     529,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   701,     0,   709,   708,   710,   166,   167,
     712,   713,     0,   714,    18,   697,   686,   696,   699,   702,
     695,   796,   785,   787,   790,   793,   791,     0,   794,   789,
     786,   788,   782,   783,   784,     0,   505,   503,   504,   502,
     356,   423,   196,   200,   200,   200,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   200,     0,     0,     0,
       0,   704,   728,   727,   715,   703,   795,     0,   207,   205,
     206,   208,   200,   200,   200,   200,   729,     0,   423,   201,
     202,   203,   204,   730,     0,   371
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1440, -1440, -1440, -1440,    39,  -210,  -224,  -272,  -877,  -145,
    -730, -1440,  -649,   -80,  -102,    22, -1440, -1440, -1440, -1440,
    1281,  1016, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440,   672,  1503, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440,  -298, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440,  1278,   -98,  1611, -1440,   224,  -522, -1440,
   -1440, -1440, -1440,   773,  -585,   562, -1440, -1440,   256, -1440,
   -1440, -1440, -1440,   153, -1440,   871,   263, -1440,   874, -1099,
     132, -1439, -1440,  -612, -1440, -1440, -1440, -1440, -1440,  -119,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
    -228, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440,   704,  1515, -1440, -1440, -1440,
   -1440,  -865,   806,   631,  1313,  1138,  1512, -1440,   996, -1440,
   -1440, -1179, -1440,   371,  -185,  1077,   260, -1025, -1375,  1713,
   -1289, -1280,  1084,   266, -1440, -1440,  -174,  1074, -1440, -1440,
   -1440, -1440,  -388,   697, -1440, -1440,  -982, -1440,  -163,   706,
     -17, -1440, -1440,   503,   873,   600,  -970, -1440, -1440, -1440,
   -1440,   816,   492, -1440, -1440, -1440,   559, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440,   979, -1440, -1440,   544, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,   535, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440,   487, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,   942,
   -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440, -1440,
   -1440, -1097
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    89,   553,   562,   554,   392,   936,  1000,
    1001,   781,  1753,   205,  1018,   357,    90,   541,   206,   544,
     534,   535,    91,   214,   215,    92,    93,    20,    21,    22,
      23,    24,    25,   134,   355,    94,  1199,   338,    95,   344,
     339,    96,   573,    97,   576,   891,    98,   566,    99,   100,
     584,   101,   102,   230,   257,   600,  1092,   905,   589,   103,
     900,  1247,  1089,   901,  1356,  1357,   863,   864,  1672,   104,
     105,   593,   258,   349,   716,   717,   365,   729,   730,  1488,
    1648,  1489,  1490,  1662,  1757,    26,    27,    28,    29,   386,
      30,    31,    32,   377,   757,    33,   374,   742,    34,   378,
     367,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   198,   537,    48,    49,    50,    51,
      52,    53,    54,    55,    56,   128,   371,   106,   574,   107,
     881,   882,   883,  1084,   907,   908,   601,   894,   885,   108,
     579,  1239,  1240,  1447,   187,   438,  1528,   813,   439,   814,
     440,   441,   442,  1532,   443,  1533,   188,   445,   446,  1449,
     408,   189,   409,   418,   190,   191,   192,  1194,   193,   507,
    1230,  1195,  1323,  1324,   793,   794,  1241,   109,  1099,   913,
     110,  1253,  1423,  1491,  1561,  1422,  1359,  1254,  1256,  1362,
    1427,  1494,  1258,    57,   111,   631,  1109,  1271,  1272,   112,
     113,   114,   312,   313,   314,   978,  1162,  1292,  1297,  1295,
    1296,  1436,  1505,  1163,  1438,  1515,  1164,  1590,  1435,  1499,
    1500,  1593,  1764,  1837,  1823,  1284,  1302,  1375,  1432,  1496,
    1434,  1285,    58,    59,    60,    61,    62,    63,    64,    65,
     770,   115,   116,   117,  1171,   982,   118,  1303,  1517,  1628,
    1721,  1516,  1440,  1304,    66,    67,   119,   120,   327,   989,
     990,   328,  1197,   991,   694,    68,   121,    69,   122,   123,
     124,   508
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     194,   437,   410,   630,   633,   225,   666,   563,   902,  1193,
     393,   394,   444,   416,   301,   785,   311,   786,   319,   788,
     789,  1196,   326,  1014,   592,   340,   345,  1345,  1083,  1229,
    1231,  1233,  1234,   545,  1340,   389,  1055,   546,   784,  1465,
     779,  1472,  1521,   947,   620,   542,   403,  1475,   654,   627,
     404,  1522,  1523,  1524,  1059,   921,   380,  1076,   403,   545,
     405,  1706,   404,   546,   648,   390,   391,   390,   391,   226,
     390,   391,   405,   659,  1529,   662,  -329,  1311,   896,   545,
     903,   667,   771,   546,   670,  -329,  -329,  -329,  -329,  1179,
     819,   820,  1360,     1,   195,  1366,  1320,  1193,   346,   547,
     548,   549,   550,   196,  -328,   380,   696,   347,   698,  1174,
      70,   937,  1649,  -328,  -328,  -328,  -328,  1179,   414,  1599,
     387,  1180,   510,   511,   512,   513,   514,   660,   796,   612,
     963,   773,  1176,  1717,  1287,  1288,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   135,  1707,   524,   661,  1180,
     432,   433,   434,   169,   435,  1718,  1668,  1669,   419,   358,
    1530,   984,   432,   433,   434,  1059,   435,  1289,   431,  1531,
     388,   372,   604,   567,   606,   568,   569,   570,   682,  1367,
     510,   511,   512,   513,   514,   948,  1557,   619,   142,   567,
    1181,   568,   569,   570,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   937,  1673,   524,  1558,   380,   510,   511,
     512,   513,   514,   432,   433,   434,  1059,   435,  1181,   390,
     391,   538,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   613,   756,   524,  1522,  1523,  1524,  1059,   390,   391,
     410,   655,   410,   545,   410,   410,   545,   546,   556,   886,
     546,   201,   202,   938,  1077,   561,   561,  1177,  1193,  1600,
     767,  1529,   768,   769,   228,   772,   774,  1519,   776,   777,
    1352,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1073,  1522,
    1523,  1524,  1059,   143,   545,   545,   591,   545,   546,   546,
     545,   546,   899,  1189,   546,  1445,  1190,   571,  1308,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1649,   547,   548,   549,
     550,   381,   545,   629,   545,  1409,   546,  1411,   546,   362,
    1413,  1189,  1416,  1418,  1190,  1361,  1559,  1560,   363,   545,
    1670,   922,  1392,   546,   547,   548,   549,   550,   897,  1514,
     727,   852,  1632,   415,  1674,   938,   669,  1530,   917,   547,
     548,   549,   550,   797,   932,   373,  1531,  1601,   545,  1246,
     635,   555,   546,   898,   707,   216,  1671,  1724,   551,   200,
     636,  1719,   887,   888,   889,   702,   224,  1083,   547,   548,
     549,   550,   217,   382,   229,   632,   728,  1605,   545,   787,
     916,   919,   546,   721,   218,   792,   586,  1589,   928,   155,
     930,  1668,  1669,   802,   803,   804,   805,   806,   547,   548,
     549,   550,  1193,  1725,   986,  1720,   987,  1627,   951,   815,
     156,   543,   417,   956,  1448,   958,  1685,   962,   219,   964,
     780,   207,   967,   968,   969,   999,   552,   972,   220,  1346,
    1542,   974,  1675,  1347,   975,  1544,  1341,  1545,  1501,   406,
    1547,  1466,  1056,  1473,  1525,   407,  1736,   983,  1526,  1476,
     849,   406,   552,  1591,  1193,   125,   126,   407,   221,  1497,
    1592,  1506,   222,  1312,  1821,   995,   996,   997,  1758,   197,
    1759,   999,   552,   348,   821,  1107,   939,   577,  -329,   623,
     223,   127,  -329,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   208,  1036,   510,
     511,   512,   513,   514,   227,  1355,  -328,  1479,   607,  1480,
    -328,   209,   848,   515,   516,   517,   518,   519,   520,   521,
     522,   523,  1050,   810,   524,   853,  1051,   811,  1193,  1193,
    1398,   129,   510,   511,   512,   513,   514,  1481,   545,   232,
    1448,  1399,   546,   436,   351,   865,   515,   516,   517,   518,
     519,   520,   521,   522,   523,  1060,   383,   524,   547,   548,
     549,   550,   926,   927,  1249,  1714,   572,   130,  1276,  1338,
     384,   385,   910,  1339,   545,   131,   132,   133,   546,  1343,
     561,  1226,   572,  1344,   918,  1227,   854,  1010,   129,   624,
     685,  1765,  1766,   862,   547,   548,   549,   550,   354,  1502,
    1463,  1715,   368,   369,  1464,   352,   436,  1081,   737,  1742,
    1760,  1743,  1761,  1041,   890,   625,  1250,  1251,  1252,   361,
    1503,   437,   437,  1656,   904,  1482,  1483,  1734,   370,  1484,
    1485,   904,   366,   545,   904,  1486,   552,   546,   444,   552,
     356,  1216,  1029,  1193,  1031,  1657,  1135,  1658,   125,   126,
     925,   375,  1659,   547,   548,   549,   550,  1019,  1728,   686,
    1030,   940,  1032,   942,  1033,  1034,   945,  1660,   376,   949,
     950,   557,  1525,  1504,   127,  1093,   628,   552,   552,   379,
     552,  1290,  1147,   552,   859,   860,   861,  1106,  1108,  1374,
     687,   738,   522,   523,   364,  1114,   524,  1116,   380,   688,
     977,   136,   137,   140,   141,   552,  1175,   552,   395,   558,
     559,  1661,  1468,   199,  1204,   817,  1469,  1205,   818,   210,
    1207,  1452,   552,   411,   993,   396,   994,   397,   510,   511,
     512,   513,   514,   640,   641,   998,   959,  1479,   211,   644,
     645,  1086,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   552,   398,   524,   510,   511,   512,   513,   514,   594,
     822,   399,   739,   823,   960,   961,  1827,  1481,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   740,   400,   524,
    1507,   552,  1052,   602,  1053,  1453,  1454,  1635,   401,   741,
    1636,  1487,   350,   402,   212,   353,   412,   689,   690,   691,
     692,   138,   139,  1844,   413,  1098,   420,   999,  1035,   510,
     511,   512,   513,   514,  1257,   421,   911,   539,  1772,   912,
    1264,   201,   202,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   359,   360,   524,   510,   511,   512,   513,   514,
     596,   597,  1455,   422,  1179,   652,   653,  1020,  1456,   515,
     516,   517,   518,   519,   520,   521,   522,   523,  1265,   423,
     524,   676,   677,  1021,   213,  1508,   410,   424,   510,   511,
     512,   513,   514,   157,  1170,   425,  1180,  1787,   844,   845,
     594,    71,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   201,   202,   524,   165,   536,   166,   167,   168,   169,
     170,   171,   368,   369,   595,   540,  1298,   560,   172,   173,
     812,   174,    72,   175,  1045,  1080,   203,  1208,  1286,  1210,
    1291,    73,   855,   856,    74,   564,  1299,   204,  1806,  1807,
    1808,  1809,  1810,  1305,   565,    75,   158,   575,   159,   160,
     581,   552,  1309,  1100,  1101,  1181,  1103,  1046,    76,  1509,
    1510,  1511,   578,  1512,   390,   391,   985,  1318,    77,   580,
    1022,   596,   597,   999,    78,   582,  1120,  1121,   599,   583,
    1123,   598,  1125,  1126,  1266,  1128,  1267,   552,  1268,  1269,
     587,  1134,  1270,   857,   858,  1381,   585,   161,   162,   163,
     164,   390,   391,  1245,    79,   588,    80,    81,   605,  1754,
    1148,   176,  1294,   590,    82,  1150,   608,   177,  1811,  1812,
    1813,  1814,  1815,   609,   792,  1002,  1003,   616,  1220,  1221,
    1222,  1513,  1223,   614,  1224,   610,  1182,  1183,  1184,  1185,
    1186,  1187,  1188,  1235,  1005,  1006,   552,  1069,   845,  1237,
      83,    84,   510,   511,   512,   513,   514,   611,  1189,  1370,
    1371,  1190,    85,  1151,   618,  1378,   515,   516,   517,   518,
     519,   520,   521,   522,   523,  1372,  1373,   524,  1552,  1553,
     615,   178,   179,  1653,  1654,    86,  1749,  1750,    87,   165,
    1191,   166,   167,   168,   169,   170,   171,  1755,  1756,   599,
    1402,  1403,   617,   172,   173,   621,   174,   622,   175,  1817,
    1818,  1819,  1820,   799,   800,   626,   634,   637,   180,   181,
     426,   427,   428,   429,   710,   638,   639,  1152,   643,   642,
     646,   647,  1023,   650,   651,   182,   649,   656,   183,   657,
     664,   658,   663,   184,   510,   511,   512,   513,   514,   665,
     668,   675,   233,  1047,  1492,   671,   672,   234,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   673,  1315,   524,
     674,   679,  1316,  1317,   711,   712,   680,  1024,  1322,  1049,
     678,   681,   683,   684,   695,   693,   697,   713,   714,   700,
     715,  1828,  1829,  1830,  1025,   699,   176,   701,   703,   704,
     705,   235,   177,   706,  1831,   708,   732,  1306,  1336,  1026,
    1337,   510,   511,   512,   513,   514,  1310,   718,   709,  1153,
    1839,  1840,  1841,  1842,   720,   515,   516,   517,   518,   519,
     520,   521,   522,   523,  1225,   722,   524,  1325,  1027,  1028,
     723,   724,   725,   236,   726,   731,  1179,   733,   735,   759,
     736,   775,   778,   782,   783,   791,  1550,  1192,   795,   801,
    1335,   798,   807,   524,  1527,   760,   178,   179,   790,  1564,
     808,   809,   816,   838,  1555,   846,   847,  1594,  1180,  1596,
     851,  1425,   866,   892,   909,   893,  1154,   895,   914,   915,
    1498,  1395,  1498,   920,  1389,   792,  1391,   923,   839,  1363,
     924,   929,   933,   180,   181,    88,   840,   931,  1155,   185,
    1156,   841,   842,   843,   934,  1157,   186,  1158,  1405,   935,
     182,  1159,  1160,   183,   941,   953,  1376,  1377,   184,  1379,
     955,   957,   761,   943,   237,   944,   946,  1384,   952,   954,
    1385,  1711,   965,   966,  1666,   971,   970,  1181,   976,  1677,
     979,  1679,   165,   973,   166,   167,   168,   169,   170,   171,
     980,   981,  1161,   988,   762,   763,   172,   173,   992,   174,
    1004,   175,   764,   231,  1007,  1008,  1009,  1011,  1012,  1015,
    1450,  1451,   242,  1322,  1016,  1017,  1042,   259,  1710,   260,
    1712,   302,  1037,   315,  1038,   320,  1043,   321,   165,  1549,
     166,   167,   168,   169,   170,   171,  1039,  1054,   765,  1063,
    1044,  1057,   172,   173,  1228,   174,  1064,   175,   238,  1066,
    1071,  1072,  1074,  1078,  1079,  1087,  1091,  1441,  1182,  1183,
    1184,  1185,  1186,  1187,  1188,  1088,  1090,  1102,  1104,  1763,
    1746,  1747,  1748,  1105,  1110,  1111,   766,  1112,  1113,  1527,
    1189,  1527,  1773,  1190,  1115,  1118,  1117,  1198,  1202,   176,
    1122,  1203,  1206,  1040,  1124,   177,  1127,  1209,  1129,  1130,
    1131,  1777,  1778,   239,  1132,  1780,  1133,   240,  1136,  1137,
    1211,  1138,  1781,  1782,  1139,  1140,  1141,  1142,  1214,  1212,
    1143,   241,  1822,  1213,   185,  -488,  1215,  1144,  1788,  1218,
    1145,   186,  1146,  1149,  1792,   176,  1793,  1794,  1633,  1165,
    1172,   177,  1173,  1236,  1242,  1219,  1244,  1259,  1243,  1637,
    1638,  1639,  1640,   561,  1556,  1260,  1261,  1293,  1262,   178,
     179,   525,   526,   527,   528,   529,   530,   531,   532,   533,
    1263,  1595,  1273,  1274,  1301,  1275,  1598,  1277,  1602,  1603,
    1825,  1606,  1278,  1313,  1279,  1048,  1280,  1326,  1281,  1282,
     243,  1283,  1300,  1307,  1327,  1321,   180,   181,   426,   427,
     428,   429,  1314,  1328,  1329,   178,   179,  1330,  1342,  1348,
     322,  1349,  1351,   182,  1354,  1358,   183,  1365,  1364,  1380,
    1368,   184,   165,  1382,   166,   167,   168,   169,   170,   171,
     245,  1383,  1369,  1386,  1388,  1664,   172,   173,  1232,   174,
    1396,   175,   180,   181,  1397,  1680,  1681,  1682,  1400,  1684,
    1686,  1404,  1058,  1401,  1697,  1408,  1412,  1414,  1420,   182,
     246,  1701,   183,  1419,   247,   248,  1424,   184,   250,   251,
    1426,  1428,   252,  1703,  1704,   253,  1429,  1705,  1430,  -328,
    1709,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1458,
    1459,   165,  1729,   166,   167,   168,   169,   170,   171,  1477,
    1493,  1470,  1433,  1439,  1520,   172,   173,  1443,   174,  1536,
     175,  1540,  1461,   254,  1541,  1462,  1467,  1543,   255,   561,
     561,   561,  1546,  1471,  1474,  1751,  1518,  1551,  1537,   176,
    1538,  1539,   323,  1548,  1554,   177,  1767,  1768,  1769,  1770,
    1771,  1562,  1604,  1563,  1597,  1607,  1629,  1795,  1634,  1641,
    1479,  1642,  1775,  1630,  1776,  1643,  1644,   165,  1645,   166,
     167,   168,   169,   170,   171,  1646,  1650,  1779,  1647,  1651,
    1652,   172,   173,  1410,   174,  1655,   175,  1783,  1663,  1665,
    1667,  1676,  1784,  1785,  1786,  1683,  1678,   185,  1695,  1696,
    1698,  1699,  1789,  1700,   186,  1790,  1791,  1702,   176,   178,
     179,  1708,  1722,  1723,   177,   165,  1713,   166,   167,   168,
     169,   170,   171,  1726,  1727,  1732,  1744,  1752,  1730,   172,
     173,  1415,   174,  1731,   175,  1762,  1179,   510,   511,   512,
     513,   514,  1774,   185,  1745,  1824,   180,   181,  1800,  1796,
     186,   515,   516,   517,   518,   519,   520,   521,   522,   523,
    1797,  1826,   524,   182,   850,  1801,   183,   324,  1180,  1798,
    1799,   184,  1803,  1804,   176,  1805,  1816,  1832,   178,   179,
     177,   165,  1845,   166,   167,   168,   169,   170,   171,  1833,
    1836,  1838,  1834,   719,  1835,   172,   173,  1417,   174,  1843,
     175,  1067,   603,  1248,   165,  1387,   166,   167,   168,   169,
     170,   171,  1716,  1353,  1200,   180,   181,  1802,   172,   173,
    1201,   174,   176,   175,  1238,   734,  1013,   884,   177,   758,
    1085,  1631,   182,  1061,  1735,   183,  1065,  1181,   430,  1319,
     184,  1062,  1737,  1457,   178,   179,   510,   511,   512,   513,
     514,  1255,  1390,  1478,  1217,  1119,  1421,  1431,  1437,  1495,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
       0,   524,  1178,     0,     0,     0,   325,     0,     0,     0,
       0,   180,   181,     0,     0,     0,     0,     0,   176,     0,
       0,     0,   178,   179,   177,     0,     0,     0,   182,     0,
       0,   183,     0,     0,     0,     0,   184,     0,     0,     0,
     906,   176,     0,     0,     0,     0,     0,   177,  1182,  1183,
    1184,  1185,  1186,  1187,  1188,     0,     0,     0,     0,   180,
     181,     0,     0,     0,     0,     0,     0,   185,     0,     0,
    1189,     0,     0,  1190,   186,     0,   182,     0,     0,   183,
       0,     0,     0,     0,   184,     0,     0,     0,   178,   179,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   510,
     511,   512,   513,   514,     0,     0,     0,     0,     0,     0,
       0,   178,   179,   515,   516,   517,   518,   519,   520,   521,
     522,   523,     0,     0,   524,   180,   181,     0,     0,     0,
       0,     0,     0,     0,     0,  -483,   185,   510,   511,   512,
     513,   514,   182,   186,     0,   183,     0,     0,   180,   181,
     184,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,     0,   524,     0,     0,   182,     0,     0,   183,     0,
       0,     0,     0,   184,   510,   511,   512,   513,   514,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,     0,   524,
       0,     0,   185,   510,   511,   512,   513,   514,     0,   186,
       0,     0,     0,     0,     0,     0,     0,   515,   516,   517,
     518,   519,   520,   521,   522,   523,     0,     0,   524,   867,
     868,   869,   870,   871,   872,   873,   874,     0,   875,   876,
     877,   878,   879,   880,   510,   511,   512,   513,   514,     0,
     185,     0,     0,     0,     0,     0,     0,   186,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,  1446,   524,
     510,   511,   512,   513,   514,     0,     0,     0,  1070,     0,
       0,     0,     0,     0,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     510,   511,   512,   513,   514,     0,   185,     0,     0,     0,
       0,     0,     0,   186,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   524,     0,     0,     0,   185,
     510,   511,   512,   513,   514,     0,   186,     0,     0,     0,
       0,     0,     0,     0,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   524,     0,     0,     0,     0,
       0,     0,     0,     0,   510,   511,   512,   513,   514,     0,
       0,     0,     0,     0,     0,     0,     0,  1075,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,     0,   524,
     510,   511,   512,   513,   514,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   524,   510,   511,   512,   513,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     515,   516,   517,   518,   519,   520,   521,   522,   523,     0,
       0,   524,   510,   511,   512,   513,   514,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,     0,   524,   510,   511,
     512,   513,   514,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   515,   516,   517,   518,   519,   520,   521,   522,
     523,     0,     0,   524,   510,   511,   512,   513,   514,     0,
    1331,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,     0,   524,
       0,     0,     0,     0,     0,   510,   511,   512,   513,   514,
       0,     0,     0,     0,     0,     0,     0,     0,  1332,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,     0,
     524,   510,   511,   512,   513,   514,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   515,   516,   517,   518,   519,
     520,   521,   522,   523,     0,  1333,   524,   510,   511,   512,
     513,   514,     0,     0,     0,     0,     0,     0,     0,   447,
       0,   515,   516,   517,   518,   519,   520,   521,   522,   523,
       0,     0,   524,     0,  1334,   510,   511,   512,   513,   514,
       0,     0,     0,     0,     0,     0,     0,  1608,     0,   515,
     516,   517,   518,   519,   520,   521,   522,   523,     0,     0,
     524,     0,   510,   511,   512,   513,   514,     0,     0,     0,
       0,  1609,  1610,     0,     0,  1350,   515,   516,   517,   518,
     519,   520,   521,   522,   523,     0,     0,   524,     0,     0,
       0,     0,  1611,     0,     0,     0,   448,   449,     0,     0,
       0,  1406,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1407,     0,  1479,     0,  1612,     0,   243,     0,     0,
       0,     0,     0,   478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   144,   145,
       0,  1460,  1613,  1481,   329,   330,   331,     0,   332,   333,
       0,   334,     0,     0,     0,   335,   146,   245,   336,     0,
       0,     0,   479,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,  1733,   243,     0,     0,     0,
     148,     0,   149,   150,     0,     0,     0,   246,     0,     0,
       0,   247,   248,     0,     0,   250,   251,     0,     0,   252,
       0,  1738,   253,     0,     0,     0,     0,     0,   243,     0,
       0,     0,     0,     0,   303,     0,   245,   480,   481,     0,
     482,   483,   484,   485,   486,   487,   488,  1739,     0,     0,
    1614,     0,     0,  1615,  1616,     0,     0,     0,     0,     0,
     254,  1617,     0,     0,     0,   255,   246,     0,   245,   151,
     247,   248,     0,  1740,   250,   251,     0,     0,   252,     0,
       0,   253,     0,     0,     0,     0,     0,     0,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   246,  1741,
       0,     0,   247,   248,     0,  1094,   250,   251,     0,     0,
     252,     0,  1618,   253,     0,   498,   499,     0,     0,   254,
       0,     0,     0,  1068,   255,     0,     0,     0,     0,     0,
     500,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   501,   502,   503,   504,     0,
       0,   254,     0,   152,  1393,     0,   255,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   510,   511,   512,
     513,   514,     0,     0,  1619,     0,     0,     0,     0,   447,
    1442,   515,   516,   517,   518,   519,   520,   521,   522,   523,
    1620,     0,   524,     0,     0,  1621,  1622,     0,  1623,  1624,
       0,  1625,     0,     0,     0,     0,  1444,     0,     0,     0,
       0,     0,   153,     0,   505,   506,   509,  1626,     0,     0,
       0,   510,   511,   512,   513,   514,   154,     0,     0,     0,
       0,     0,     0,     0,  1534,   515,   516,   517,   518,   519,
     520,   521,   522,   523,  1095,  1096,   524,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   448,   449,     0,     0,
       0,  1535,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     304,     0,     0,     0,     0,   305,   306,   307,     0,     0,
    -489,  -489,  -489,   243,     0,     0,     0,     0,   261,     0,
       0,     0,     0,   337,  -489,  -489,  -489,  -489,  -489,   520,
     521,   522,   523,   262,     0,   524,     0,     0,     0,   308,
       0,     0,     0,     0,     0,     0,   309,   263,     0,     0,
       0,     0,     0,   245,     0,     0,     0,     0,     0,     0,
     243,     0,   479,   867,   868,   869,   870,   871,   872,   873,
     874,     0,   875,   876,   877,   878,   879,   880,     0,     0,
       0,     0,   310,   246,     0,     0,     0,   247,   248,   264,
     265,   250,   251,  1394,     0,   252,     0,     0,   253,     0,
     245,     0,   266,     0,     0,   267,     0,   268,     0,     0,
       0,     0,     0,     0,  1097,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   243,     0,     0,
     246,     0,     0,     0,   247,   248,   254,  1166,   250,   251,
       0,   255,   252,  1565,     0,   253,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   269,     0,   270,     0,     0,
       0,     0,     0,     0,     0,     0,   271,   245,     0,   489,
     490,   491,   492,   493,   494,   495,   496,   497,     0,     0,
       0,     0,     0,   254,     0,     0,     0,     0,   255,     0,
       0,     0,     0,     0,     0,   498,   499,   246,     0,     0,
       0,   247,   248,     0,   272,   250,   251,     0,     0,   252,
     500,     0,   253,     0,     0,  1479,     0,     0,     0,     0,
       0,     0,   273,     0,     0,   501,   502,   503,   504,   274,
     275,     0,   276,   243,     0,     0,     0,   277,   278,     0,
     279,   280,     0,   281,     0,  1481,   282,   283,   284,   243,
     254,     0,     0,   244,     0,   255,     0,     0,  1566,     0,
       0,   285,   286,     0,     0,     0,   287,     0,   288,   289,
       0,   290,  1567,   245,  1082,     0,   291,     0,   341,     0,
     292,   293,     0,   294,   295,     0,   296,   297,   298,   245,
       0,     0,   299,     0,   505,   506,     0,     0,     0,     0,
       0,     0,     0,   246,     0,     0,     0,   247,   248,     0,
     249,   250,   251,     0,     0,   252,     0,     0,   253,   246,
       0,     0,     0,   247,   248,     0,     0,   250,   251,     0,
       0,   252,  1568,     4,   253,  1569,  1570,   743,     0,     0,
       0,     0,     0,  1571,     0,     0,     0,     0,     0,     0,
       0,     0,   390,   391,     0,     0,   254,   342,     5,     6,
       0,   255,     0,     0,     0,     0,     0,     0,     7,     0,
       0,     0,   254,     0,     0,     0,     0,   255,     0,   744,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   300,
       0,     0,     0,  1167,  1572,     0,     0,  1573,     0,     0,
    1574,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   316,  1168,     0,     0,     0,     0,     0,     0,
     745,     0,     8,  1575,     0,  1576,     0,  1577,  1578,  1579,
    1580,  1581,  1582,     0,     0,     0,  1169,     0,  1583,     0,
       0,  1584,     0,     0,  1585,     0,     0,     0,     0,     0,
       0,     0,   746,     0,     0,     0,  1586,     0,     9,   747,
     748,    10,     0,    11,  1587,     0,     0,     0,     0,     0,
      12,   749,    13,     0,     0,     0,   317,    14,    15,    16,
       0,     0,     0,     0,    17,    18,    19,     0,   750,   751,
     752,   753,     0,   754,   755,     0,     0,     0,     0,  1588,
       0,     0,     0,   318,   510,   511,   512,   513,   514,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   515,   516,
     517,   518,   519,   520,   521,   522,   523,     0,     0,   524,
     510,   511,   512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   515,   516,   517,   518,   519,   520,
     521,   522,   523,     0,     0,   524,   867,   868,   869,   870,
     871,   872,   873,   874,     0,   875,   876,   877,   878,   879,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   599,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   256,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   343
};

static const yytype_int16 yycheck[] =
{
      17,   186,   165,   275,   276,    85,   304,   217,   593,   991,
     155,   156,   186,    15,   112,   403,   114,   405,   116,   407,
     408,   991,   120,   753,   248,   123,   124,     7,   893,  1054,
    1055,  1056,  1057,    15,     7,   154,     7,    19,     7,     7,
      30,     7,     6,   136,   268,    45,    15,     7,   122,   273,
      19,    15,    16,    17,    18,    51,    19,    19,    15,    15,
      29,   323,    19,    19,   288,    18,    19,    18,    19,    86,
      18,    19,    29,   297,  1449,   299,     6,    22,   162,    15,
      36,   305,    45,    19,   308,    15,    16,    17,    18,    19,
      27,    28,    31,     4,    36,   246,  1193,  1079,    36,    35,
      36,    37,    38,    45,     6,    19,   330,    45,   332,   986,
       0,    42,  1551,    15,    16,    17,    18,    19,    28,   127,
     145,    51,     8,     9,    10,    11,    12,   265,    28,   181,
     652,    45,   255,   127,   348,   349,    22,    23,    24,    25,
      26,    27,    28,    29,    30,     3,   408,    33,   286,    51,
      15,    16,    17,    18,    19,   149,   179,   180,   175,   137,
    1449,   683,    15,    16,    17,    18,    19,   381,   185,  1449,
     195,     3,   252,    15,   254,    17,    18,    19,   323,   330,
       8,     9,    10,    11,    12,   278,   127,   267,     3,    15,
     120,    17,    18,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    42,   127,    33,   147,    19,     8,     9,
      10,    11,    12,    15,    16,    17,    18,    19,   120,    18,
      19,   199,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   283,   377,    33,    15,    16,    17,    18,    18,    19,
     403,   315,   405,    15,   407,   408,    15,    19,   209,    42,
      19,    19,    20,   184,   216,   216,   217,   380,  1240,   267,
     379,  1636,   381,   382,    19,   384,   385,  1446,   387,   388,
    1240,   201,   202,   203,   204,   205,   206,   207,   863,    15,
      16,    17,    18,   162,    15,    15,   247,    15,    19,    19,
      15,    19,   590,   223,    19,  1392,   226,   139,  1175,   201,
     202,   203,   204,   205,   206,   207,  1745,    35,    36,    37,
      38,   123,    15,   274,    15,  1340,    19,  1342,    19,    36,
    1345,   223,  1347,  1348,   226,   264,   267,   268,    45,    15,
     353,   327,  1314,    19,    35,    36,    37,    38,   422,  1438,
     129,   551,  1521,   253,   267,   184,   307,  1636,    76,    35,
      36,    37,    38,   253,   626,   187,  1636,   365,    15,  1089,
     272,   208,    19,   587,   342,    50,   389,   356,    69,    19,
     282,   365,   165,   166,   167,   336,   144,  1242,    35,    36,
      37,    38,    67,   195,   139,   184,   175,   156,    15,   406,
     614,   615,    19,   354,    81,   412,   243,  1496,   622,   162,
     624,   179,   180,   420,   421,   422,   423,   424,    35,    36,
      37,    38,  1394,   402,   686,   409,   688,  1516,   642,   436,
     162,   421,   424,   647,  1394,   649,   156,   651,    19,   653,
     420,    68,   656,   657,   658,   707,   418,   661,   117,   419,
    1465,   665,   365,   423,   668,  1470,   419,  1472,   187,   418,
    1475,   419,   423,   419,   418,   424,  1635,   681,   422,   419,
     540,   418,   418,   369,  1446,    19,    20,   424,    19,   422,
     376,   422,    86,   418,   422,   699,   700,   701,   139,   421,
     141,   753,   418,   421,   421,   421,   417,   224,   418,   188,
     164,    45,   422,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   144,   780,     8,
       9,    10,    11,    12,    19,  1245,   418,   138,   255,   140,
     422,   158,   539,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   419,   419,    33,   552,   423,   423,  1520,  1521,
      22,    20,     8,     9,    10,    11,    12,   168,    15,   421,
    1520,    33,    19,   418,     3,   572,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   418,   378,    33,    35,    36,
      37,    38,   258,   259,    81,   353,   418,    56,   417,   419,
     392,   393,   599,   423,    15,    64,    65,    66,    19,   419,
     551,   419,   418,   423,   322,   423,   557,   742,    20,   298,
     206,   373,   374,   564,    35,    36,    37,    38,    67,   348,
     419,   389,    19,    20,   423,     3,   418,   889,     3,  1644,
     139,  1646,   141,   423,   417,   324,   133,   134,   135,     3,
     369,   816,   817,   117,   595,   256,   257,   418,    45,   260,
     261,   602,    86,    15,   605,   266,   418,    19,   822,   418,
      20,  1039,   771,  1635,   773,   139,   954,   141,    19,    20,
     621,     3,   146,    35,    36,    37,    38,   769,   371,   275,
     772,   632,   774,   634,   776,   777,   637,   161,     3,   640,
     641,    20,   418,   422,    45,   909,   417,   418,   418,   269,
     418,   348,   417,   418,    39,    40,    41,   921,   922,  1284,
     306,    86,    29,    30,   421,   929,    33,   931,    19,   315,
     671,     7,     8,     9,    10,   418,   988,   418,     3,    58,
      59,   205,   419,    19,  1022,   423,   423,  1025,   426,    43,
    1028,   126,   418,    30,   695,     3,   697,     3,     8,     9,
      10,    11,    12,   286,   287,   706,   278,   138,    62,   296,
     297,   896,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   418,     3,    33,     8,     9,    10,    11,    12,    45,
     423,     3,   157,   426,   306,   307,  1801,   168,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   172,     3,    33,
     181,   418,   809,    69,   811,   190,   191,   420,     3,   184,
     423,   422,   130,     3,   118,   133,   418,   413,   414,   415,
     416,   172,   173,  1838,   253,   913,   418,  1089,   779,     8,
       9,    10,    11,    12,  1096,   418,   602,    22,   259,   605,
     173,    19,    20,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   138,   139,    33,     8,     9,    10,    11,    12,
     126,   127,   247,   418,    19,    86,    87,     3,   253,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   211,   418,
      33,   396,   397,    19,   188,   266,  1039,   418,     8,     9,
      10,    11,    12,    79,   982,   418,    51,   259,   422,   423,
      45,     3,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    19,    20,    33,    13,    15,    15,    16,    17,    18,
      19,    20,    19,    20,    69,    63,   383,   417,    27,    28,
      29,    30,    34,    32,   423,   886,    44,  1029,  1152,  1031,
    1154,    43,    60,    61,    46,   181,  1160,    55,   149,   150,
     151,   152,   153,  1167,   170,    57,   142,    19,   144,   145,
      19,   418,  1176,   914,   915,   120,   917,   423,    70,   350,
     351,   352,   417,   354,    18,    19,    20,  1191,    80,   139,
     116,   126,   127,  1245,    86,   421,   937,   938,   254,   421,
     941,   136,   943,   944,   327,   946,   329,   418,   331,   332,
     323,   952,   335,    60,    61,  1293,   421,   193,   194,   195,
     196,    18,    19,    20,   116,    19,   118,   119,    69,  1658,
     971,   120,  1157,   117,   126,   976,   417,   126,   149,   150,
     151,   152,   153,   417,  1041,   422,   423,   417,  1045,  1046,
    1047,   422,  1049,   323,  1051,   421,   201,   202,   203,   204,
     205,   206,   207,  1060,   422,   423,   418,   422,   423,  1066,
     162,   163,     8,     9,    10,    11,    12,   421,   223,   336,
     337,   226,   174,   123,   284,  1289,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   422,   423,    33,   258,   259,
      81,   190,   191,   149,   150,   197,   149,   150,   200,    13,
     255,    15,    16,    17,    18,    19,    20,   147,   148,   254,
    1328,  1329,    20,    27,    28,    69,    30,    85,    32,  1758,
    1759,  1760,  1761,   416,   417,   167,    76,    76,   227,   228,
     229,   230,   231,   232,    79,   270,   277,   187,   282,    87,
     296,   300,   278,   305,   310,   244,   303,    87,   247,   318,
     421,   316,   417,   252,     8,     9,    10,    11,    12,   377,
     116,    86,    73,   423,  1426,   117,   417,    78,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   421,  1185,    33,
     421,   421,  1189,  1190,   129,   130,   421,   323,  1195,   423,
     417,   323,    86,   417,    86,   421,    76,   142,   143,    81,
     145,  1803,  1804,  1805,   340,    79,   120,    85,   417,   417,
     417,   122,   126,    76,  1816,   417,    19,  1168,  1225,   355,
    1227,     8,     9,    10,    11,    12,  1177,     3,   417,   279,
    1832,  1833,  1834,  1835,     3,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   423,     3,    33,  1198,   384,   385,
       3,     3,     3,   164,     3,     3,    19,     3,     3,     3,
       3,     3,     3,   182,   182,    15,  1480,   422,    27,    30,
     423,    28,    19,    33,  1449,    19,   190,   191,    14,  1493,
      15,   423,     7,   210,  1484,     3,     3,  1501,    51,  1503,
     417,  1361,   417,   417,   137,   418,   346,    19,    76,    76,
    1435,   421,  1437,   417,  1311,  1312,  1313,   417,   235,  1260,
     417,   308,   417,   227,   228,   417,   243,   175,   368,   418,
     370,   248,   249,   250,   417,   375,   425,   377,  1335,    31,
     244,   381,   382,   247,   184,   417,  1287,  1288,   252,  1290,
     417,   417,    86,    76,   255,    76,    76,  1298,    76,   117,
    1301,  1613,   417,   417,  1568,   184,   417,   120,    69,  1573,
      19,  1575,    13,   417,    15,    16,    17,    18,    19,    20,
     417,   417,   422,   275,   118,   119,    27,    28,   417,    30,
       3,    32,   126,    95,     3,    19,    15,    19,    19,    19,
    1397,  1398,   104,  1400,     3,    20,   419,   109,  1612,   111,
    1614,   113,    15,   115,    15,   117,   253,   119,    13,  1479,
      15,    16,    17,    18,    19,    20,    15,   423,   162,    15,
      28,   423,    27,    28,    29,    30,    18,    32,   339,   418,
      20,   417,   417,   417,   421,   417,   132,  1388,   201,   202,
     203,   204,   205,   206,   207,    28,   423,   417,   417,  1663,
    1650,  1651,  1652,   417,   417,   417,   200,   417,   417,  1634,
     223,  1636,  1676,   226,   417,    19,   417,    69,     3,   120,
     417,     3,    15,   419,   417,   126,   417,     3,   417,   417,
     417,  1695,  1696,   394,   417,  1699,   417,   398,   417,   417,
       3,   417,  1706,  1707,   417,   417,   417,   417,   184,     3,
     417,   412,  1764,     3,   418,   419,   184,   417,  1722,    28,
     417,   425,   417,   417,  1728,   120,  1730,  1731,  1525,   417,
     417,   126,   417,   423,   417,    28,   182,   417,   419,  1536,
    1537,  1538,  1539,  1484,  1485,   423,   417,   323,   417,   190,
     191,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     417,  1502,   417,   417,   386,   417,  1507,   417,  1509,  1510,
    1774,  1512,   417,    22,   417,   419,   417,     3,   417,   417,
      46,   417,   417,   417,     3,   417,   227,   228,   229,   230,
     231,   232,   418,    15,    15,   190,   191,    28,   423,   423,
      66,    15,   422,   244,    15,   421,   247,    69,   338,   421,
     334,   252,    13,   421,    15,    16,    17,    18,    19,    20,
      86,   421,   333,   421,    69,  1566,    27,    28,    29,    30,
     417,    32,   227,   228,    22,  1576,  1577,  1578,   423,  1580,
    1581,    28,   419,   417,  1585,    29,    29,     7,   184,   244,
     116,  1592,   247,   422,   120,   121,    19,   252,   124,   125,
     265,   417,   128,  1604,  1605,   131,   193,  1608,   328,   422,
    1611,   356,   357,   358,   359,   360,   361,   362,   363,     3,
       3,    13,  1623,    15,    16,    17,    18,    19,    20,    15,
     262,   418,   421,   421,   225,    27,    28,   419,    30,   418,
      32,   417,   419,   169,    29,   419,   419,    29,   174,  1650,
    1651,  1652,     7,   419,   419,  1656,   419,   421,   418,   120,
     418,   418,   188,   417,   259,   126,  1667,  1668,  1669,  1670,
    1671,   421,   282,   417,   417,   417,   417,  1734,     7,   419,
     138,   419,  1683,   422,  1685,   419,   423,    13,   419,    15,
      16,    17,    18,    19,    20,   418,   260,  1698,   419,   260,
     260,    27,    28,    29,    30,   147,    32,  1708,   323,   421,
     372,   318,  1713,  1714,  1715,   282,   390,   418,   388,   358,
     380,   356,  1723,   417,   425,  1726,  1727,   417,   120,   190,
     191,    76,   318,   380,   126,    13,   372,    15,    16,    17,
      18,    19,    20,    76,    76,   417,   422,    20,   405,    27,
      28,    29,    30,   407,    32,   422,    19,     8,     9,    10,
      11,    12,   391,   418,   417,   371,   227,   228,   419,   417,
     425,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     417,   371,    33,   244,   543,   423,   247,   313,    51,   417,
     417,   252,   417,   417,   120,   417,   417,   417,   190,   191,
     126,    13,   419,    15,    16,    17,    18,    19,    20,   417,
     366,   423,   417,   350,   417,    27,    28,    29,    30,   417,
      32,   845,   251,  1090,    13,  1303,    15,    16,    17,    18,
      19,    20,  1616,  1242,  1003,   227,   228,  1745,    27,    28,
    1006,    30,   120,    32,  1078,   370,   748,   574,   126,   377,
     894,  1520,   244,   816,  1634,   247,   822,   120,   185,  1193,
     252,   817,  1636,  1400,   190,   191,     8,     9,    10,    11,
      12,  1095,  1312,  1421,  1041,   936,  1357,  1373,  1383,  1432,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,   990,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,   227,   228,    -1,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,   190,   191,   126,    -1,    -1,    -1,   244,    -1,
      -1,   247,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      19,   120,    -1,    -1,    -1,    -1,    -1,   126,   201,   202,
     203,   204,   205,   206,   207,    -1,    -1,    -1,    -1,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,    -1,
     223,    -1,    -1,   226,   425,    -1,   244,    -1,    -1,   247,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   190,   191,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,   227,   228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,     8,     9,    10,
      11,    12,   244,   425,    -1,   247,    -1,    -1,   227,   228,
     252,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,    -1,    -1,   252,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,   418,     8,     9,    10,    11,    12,    -1,   425,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,   218,
     219,   220,   221,   222,     8,     9,    10,    11,    12,    -1,
     418,    -1,    -1,    -1,    -1,    -1,    -1,   425,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   421,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,   419,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    11,    12,    -1,   418,    -1,    -1,    -1,
      -1,    -1,    -1,   425,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,   418,
       8,     9,    10,    11,    12,    -1,   425,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,     8,     9,    10,    11,    12,    -1,
     419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   419,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   419,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,   419,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    66,    67,    -1,    -1,   419,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    82,    83,    -1,    -1,
      -1,   419,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   419,    -1,   138,    -1,   140,    -1,    46,    -1,    -1,
      -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,   145,
      -1,   419,   167,   168,    73,    74,    75,    -1,    77,    78,
      -1,    80,    -1,    -1,    -1,    84,   162,    86,    87,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,   419,    46,    -1,    -1,    -1,
     186,    -1,   188,   189,    -1,    -1,    -1,   116,    -1,    -1,
      -1,   120,   121,    -1,    -1,   124,   125,    -1,    -1,   128,
      -1,   419,   131,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    86,   233,   234,    -1,
     236,   237,   238,   239,   240,   241,   242,   419,    -1,    -1,
     255,    -1,    -1,   258,   259,    -1,    -1,    -1,    -1,    -1,
     169,   266,    -1,    -1,    -1,   174,   116,    -1,    86,   255,
     120,   121,    -1,   419,   124,   125,    -1,    -1,   128,    -1,
      -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   116,   419,
      -1,    -1,   120,   121,    -1,   123,   124,   125,    -1,    -1,
     128,    -1,   317,   131,    -1,   311,   312,    -1,    -1,   169,
      -1,    -1,    -1,   417,   174,    -1,    -1,    -1,    -1,    -1,
     326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   341,   342,   343,   344,    -1,
      -1,   169,    -1,   339,   417,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,   379,    -1,    -1,    -1,    -1,     5,
     417,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     395,    -1,    33,    -1,    -1,   400,   401,    -1,   403,   404,
      -1,   406,    -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,
      -1,    -1,   398,    -1,   410,   411,     3,   422,    -1,    -1,
      -1,     8,     9,    10,    11,    12,   412,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   262,   263,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    -1,    -1,
      -1,   417,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     340,    -1,    -1,    -1,    -1,   345,   346,   347,    -1,    -1,
       8,     9,    10,    46,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,   422,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    66,    -1,    33,    -1,    -1,    -1,   379,
      -1,    -1,    -1,    -1,    -1,    -1,   386,    80,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,   178,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,   218,   219,   220,   221,   222,    -1,    -1,
      -1,    -1,   422,   116,    -1,    -1,    -1,   120,   121,   122,
     123,   124,   125,   224,    -1,   128,    -1,    -1,   131,    -1,
      86,    -1,   135,    -1,    -1,   138,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
     116,    -1,    -1,    -1,   120,   121,   169,   123,   124,   125,
      -1,   174,   128,    66,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   188,    -1,   190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   199,    86,    -1,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,   311,   312,   116,    -1,    -1,
      -1,   120,   121,    -1,   237,   124,   125,    -1,    -1,   128,
     326,    -1,   131,    -1,    -1,   138,    -1,    -1,    -1,    -1,
      -1,    -1,   255,    -1,    -1,   341,   342,   343,   344,   262,
     263,    -1,   265,    46,    -1,    -1,    -1,   270,   271,    -1,
     273,   274,    -1,   276,    -1,   168,   279,   280,   281,    46,
     169,    -1,    -1,    66,    -1,   174,    -1,    -1,   181,    -1,
      -1,   294,   295,    -1,    -1,    -1,   299,    -1,   301,   302,
      -1,   304,   195,    86,   419,    -1,   309,    -1,    75,    -1,
     313,   314,    -1,   316,   317,    -1,   319,   320,   321,    86,
      -1,    -1,   325,    -1,   410,   411,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   116,    -1,    -1,    -1,   120,   121,    -1,
     123,   124,   125,    -1,    -1,   128,    -1,    -1,   131,   116,
      -1,    -1,    -1,   120,   121,    -1,    -1,   124,   125,    -1,
      -1,   128,   255,    46,   131,   258,   259,     3,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,    19,    -1,    -1,   169,   154,    71,    72,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,   379,   317,    -1,    -1,   320,    -1,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   331,   399,    -1,    -1,    -1,    -1,    -1,    -1,
      86,    -1,   135,   346,    -1,   348,    -1,   350,   351,   352,
     353,   354,   355,    -1,    -1,    -1,   422,    -1,   361,    -1,
      -1,   364,    -1,    -1,   367,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   118,    -1,    -1,    -1,   379,    -1,   171,   125,
     126,   174,    -1,   176,   387,    -1,    -1,    -1,    -1,    -1,
     183,   137,   185,    -1,    -1,    -1,   395,   190,   191,   192,
      -1,    -1,    -1,    -1,   197,   198,   199,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,   422,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,   218,   219,   220,   221,
     222,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   428,   429,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     454,   455,   456,   457,   458,   459,   512,   513,   514,   515,
     517,   518,   519,   522,   525,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   620,   659,   660,
     661,   662,   663,   664,   665,   666,   681,   682,   692,   694,
       0,     3,    34,    43,    46,    57,    70,    80,    86,   116,
     118,   119,   126,   162,   163,   174,   197,   200,   417,   430,
     443,   449,   452,   453,   462,   465,   468,   470,   473,   475,
     476,   478,   479,   486,   496,   497,   554,   556,   566,   604,
     607,   621,   626,   627,   628,   668,   669,   670,   673,   683,
     684,   693,   695,   696,   697,    19,    20,    45,   552,    20,
      56,    64,    65,    66,   460,     3,   552,   552,   172,   173,
     552,   552,     3,   162,   144,   145,   162,   177,   186,   188,
     189,   255,   339,   398,   412,   162,   162,    79,   142,   144,
     145,   193,   194,   195,   196,    13,    15,    16,    17,    18,
      19,    20,    27,    28,    30,    32,   120,   126,   190,   191,
     227,   228,   244,   247,   252,   418,   425,   571,   583,   588,
     591,   592,   593,   595,   597,    36,    45,   421,   541,   552,
      19,    19,    20,    44,    55,   440,   445,    68,   144,   158,
      43,    62,   118,   188,   450,   451,    50,    67,    81,    19,
     117,    19,    86,   164,   144,   440,   597,    19,    19,   139,
     480,   480,   421,    73,    78,   122,   164,   255,   339,   394,
     398,   412,   480,    46,    66,    86,   116,   120,   121,   123,
     124,   125,   128,   131,   169,   174,   422,   481,   499,   480,
     480,    51,    66,    80,   122,   123,   135,   138,   140,   188,
     190,   199,   237,   255,   262,   263,   265,   270,   271,   273,
     274,   276,   279,   280,   281,   294,   295,   299,   301,   302,
     304,   309,   313,   314,   316,   317,   319,   320,   321,   325,
     422,   481,   480,    84,   340,   345,   346,   347,   379,   386,
     422,   481,   629,   630,   631,   480,   331,   395,   422,   481,
     480,   480,    66,   188,   313,   422,   481,   685,   688,    73,
      74,    75,    77,    78,    80,    84,    87,   422,   464,   467,
     481,    75,   154,   422,   466,   481,    36,    45,   421,   500,
     460,     3,     3,   460,    67,   461,    20,   442,   442,   552,
     552,     3,    36,    45,   421,   503,    86,   527,    19,    20,
      45,   553,     3,   187,   523,     3,     3,   520,   526,   269,
      19,   123,   195,   378,   392,   393,   516,   145,   195,   516,
      18,    19,   434,   436,   436,     3,     3,     3,     3,     3,
       3,     3,     3,    15,    19,    29,   418,   424,   587,   589,
     595,    30,   418,   253,    28,   253,    15,   424,   590,   597,
     418,   418,   418,   418,   418,   418,   229,   230,   231,   232,
     576,   597,    15,    16,    17,    19,   418,   571,   572,   575,
     577,   578,   579,   581,   583,   584,   585,     5,    82,    83,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   139,   178,
     233,   234,   236,   237,   238,   239,   240,   241,   242,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   311,   312,
     326,   341,   342,   343,   344,   410,   411,   596,   698,     3,
       8,     9,    10,    11,    12,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    33,    46,    47,    48,    49,    50,
      51,    52,    53,    54,   447,   448,    15,   542,   442,    22,
      63,   444,    45,   421,   446,    15,    19,    35,    36,    37,
      38,    69,   418,   431,   433,   500,   431,    20,    58,    59,
     417,   431,   432,   432,   181,   170,   474,    15,    17,    18,
      19,   139,   418,   469,   555,    19,   471,   503,   417,   567,
     139,    19,   421,   421,   477,   421,   500,   323,    19,   485,
     117,   431,   433,   498,    45,    69,   126,   127,   136,   254,
     482,   563,    69,   482,   440,    69,   440,   503,   417,   417,
     421,   421,   181,   283,   323,    81,   417,    20,   284,   440,
     433,    69,    85,   188,   298,   324,   167,   433,   417,   431,
     434,   622,   184,   434,    76,   272,   282,    76,   270,   277,
     286,   287,    87,   282,   296,   297,   296,   300,   433,   303,
     305,   310,    86,    87,   122,   315,    87,   318,   316,   433,
     265,   286,   433,   417,   421,   377,   469,   433,   116,   431,
     433,   117,   417,   421,   421,    86,   396,   397,   417,   421,
     421,   323,   436,    86,   417,   206,   275,   306,   315,   413,
     414,   415,   416,   421,   691,    86,   433,    76,   433,    79,
      81,    85,   431,   417,   417,   417,    76,   442,   417,   417,
      79,   129,   130,   142,   143,   145,   501,   502,     3,   461,
       3,   431,     3,     3,     3,     3,     3,   129,   175,   504,
     505,     3,    19,     3,   553,     3,     3,     3,    86,   157,
     172,   184,   524,     3,    45,    86,   118,   125,   126,   137,
     154,   155,   156,   157,   159,   160,   436,   521,   563,     3,
      19,    86,   118,   119,   126,   162,   200,   516,   516,   516,
     667,    45,   516,    45,   516,     3,   516,   516,     3,    30,
     420,   438,   182,   182,     7,   589,   589,   597,   589,   589,
      14,    15,   597,   601,   602,    27,    28,   253,    28,   590,
     590,    30,   597,   597,   597,   597,   597,    19,    15,   423,
     419,   423,    29,   574,   576,   597,     7,   423,   426,    27,
      28,   421,   423,   426,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   210,   235,
     243,   248,   249,   250,   422,   423,     3,     3,   597,   440,
     447,   417,   432,   597,   431,    60,    61,    60,    61,    39,
      40,    41,   431,   493,   494,   597,   417,   208,   209,   210,
     211,   212,   213,   214,   215,   217,   218,   219,   220,   221,
     222,   557,   558,   559,   561,   565,    42,   165,   166,   167,
     417,   472,   417,   418,   564,    19,   162,   422,   433,   469,
     487,   490,   491,    36,   431,   484,    19,   561,   562,   137,
     597,   484,   484,   606,    76,    76,   433,    76,   322,   433,
     417,    51,   327,   417,   417,   431,   258,   259,   433,   308,
     433,   175,   434,   417,   417,    31,   435,    42,   184,   417,
     431,   184,   431,    76,    76,   431,    76,   136,   278,   431,
     431,   433,    76,   417,   117,   417,   433,   417,   433,   278,
     306,   307,   433,   485,   433,   417,   417,   433,   433,   433,
     417,   184,   433,   417,   433,   433,    69,   431,   632,    19,
     417,   417,   672,   433,   485,    20,   434,   434,   275,   686,
     687,   690,   417,   431,   431,   433,   433,   433,   431,   434,
     436,   437,   422,   423,     3,   422,   423,     3,    19,    15,
     436,    19,    19,   562,   437,    19,     3,    20,   441,   441,
       3,    19,   116,   278,   323,   340,   355,   384,   385,   516,
     441,   516,   441,   441,   441,   431,   434,    15,    15,    15,
     419,   423,   419,   253,    28,   423,   423,   423,   419,   423,
     419,   423,   597,   597,   423,     7,   423,   423,   419,    18,
     418,   572,   579,    15,    18,   584,   418,   448,   417,   422,
     419,    20,   417,   491,   417,   419,    19,   216,   417,   421,
     431,   434,   419,   558,   560,   565,   436,   417,    28,   489,
     423,   132,   483,   433,   123,   262,   263,   422,   481,   605,
     431,   431,   417,   431,   417,   417,   433,   421,   433,   623,
     417,   417,   417,   417,   433,   417,   433,   417,    19,   622,
     431,   431,   417,   431,   417,   431,   431,   417,   431,   417,
     417,   417,   417,   417,   431,   469,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   431,   417,
     431,   123,   187,   279,   346,   368,   370,   375,   377,   381,
     382,   422,   633,   640,   643,   417,   123,   379,   399,   422,
     481,   671,   417,   417,   435,   434,   255,   380,   686,    19,
      51,   120,   201,   202,   203,   204,   205,   206,   207,   223,
     226,   255,   422,   593,   594,   598,   603,   689,    69,   463,
     502,   505,     3,     3,   469,   469,    15,   469,   441,     3,
     441,     3,     3,     3,   184,   184,   589,   601,    28,    28,
     597,   597,   597,   597,   597,   423,   419,   423,    29,   574,
     597,   574,    29,   574,   574,   597,   423,   597,   559,   568,
     569,   603,   417,   419,   182,    20,   437,   488,   490,    81,
     133,   134,   135,   608,   614,   608,   615,   434,   619,   417,
     423,   417,   417,   417,   173,   211,   327,   329,   331,   332,
     335,   624,   625,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   652,   658,   433,   348,   349,   381,
     348,   433,   634,   323,   436,   636,   637,   635,   383,   433,
     417,   386,   653,   674,   680,   433,   431,   417,   435,   433,
     431,    22,   418,    22,   418,   597,   597,   597,   433,   596,
     698,   417,   597,   599,   600,   431,     3,     3,    15,    15,
      28,   419,   419,   419,   419,   423,   597,   597,   419,   423,
       7,   419,   423,   419,   423,     7,   419,   423,   423,    15,
     419,   422,   603,   560,    15,   437,   491,   492,   421,   613,
      31,   264,   616,   431,   338,    69,   246,   330,   334,   333,
     336,   337,   422,   423,   491,   654,   431,   431,   433,   431,
     421,   469,   421,   421,   431,   431,   421,   492,    69,   597,
     602,   597,   593,   417,   224,   421,   417,    22,    22,    33,
     423,   417,   527,   527,    28,   597,   419,   419,    29,   574,
      29,   574,    29,   574,     7,    29,   574,    29,   574,   422,
     184,   613,   612,   609,    19,   440,   265,   617,   417,   193,
     328,   625,   655,   421,   657,   645,   638,   645,   641,   421,
     679,   431,   417,   419,   417,   698,   421,   570,   603,   586,
     597,   597,   126,   190,   191,   247,   253,   600,     3,     3,
     419,   419,   419,   419,   423,     7,   419,   419,   419,   423,
     418,   419,     7,   419,   419,     7,   419,    15,   609,   138,
     140,   168,   256,   257,   260,   261,   266,   422,   506,   508,
     509,   610,   434,   262,   618,   653,   656,   422,   436,   646,
     647,   187,   348,   369,   422,   639,   422,   181,   266,   350,
     351,   352,   354,   422,   506,   642,   678,   675,   419,   568,
     225,     6,    15,    16,    17,   418,   422,   571,   573,   575,
     577,   578,   580,   582,   417,   417,   418,   418,   418,   418,
     417,    29,   574,    29,   574,   574,     7,   574,   417,   440,
     433,   421,   258,   259,   259,   432,   431,   127,   147,   267,
     268,   611,   421,   417,   433,    66,   181,   195,   255,   258,
     259,   266,   317,   320,   323,   346,   348,   350,   351,   352,
     353,   354,   355,   361,   364,   367,   379,   387,   422,   506,
     644,   369,   376,   648,   433,   431,   433,   417,   431,   127,
     267,   365,   431,   431,   282,   156,   431,   417,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   379,
     395,   400,   401,   403,   404,   406,   422,   506,   676,   417,
     422,   570,   568,   597,     7,   420,   423,   597,   597,   597,
     597,   419,   419,   419,   423,   419,   418,   419,   507,   508,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   510,   323,   431,   421,   433,   372,   179,   180,
     353,   389,   495,   127,   267,   365,   318,   433,   390,   433,
     431,   431,   431,   282,   431,   156,   431,   356,   357,   358,
     359,   360,   361,   362,   363,   388,   358,   431,   380,   356,
     417,   431,   417,   431,   431,   431,   323,   408,    76,   431,
     433,   434,   433,   372,   353,   389,   495,   127,   149,   365,
     409,   677,   318,   380,   356,   402,    76,    76,   371,   431,
     405,   407,   417,   419,   418,   573,   568,   580,   419,   419,
     419,   419,   574,   574,   422,   417,   432,   432,   432,   149,
     150,   431,    20,   439,   439,   147,   148,   511,   139,   141,
     139,   141,   422,   433,   649,   373,   374,   431,   431,   431,
     431,   431,   259,   433,   391,   431,   431,   433,   433,   431,
     433,   433,   433,   431,   431,   431,   431,   259,   433,   431,
     431,   431,   433,   433,   433,   597,   417,   417,   417,   417,
     419,   423,   507,   417,   417,   417,   149,   150,   151,   152,
     153,   149,   150,   151,   152,   153,   417,   439,   439,   439,
     439,   422,   434,   651,   371,   433,   371,   574,   510,   510,
     510,   510,   417,   417,   417,   417,   366,   650,   423,   510,
     510,   510,   510,   417,   574,   419
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   427,   428,   428,   429,   429,   430,   431,   431,   431,
     432,   432,   432,   433,   433,   433,   433,   433,   433,   434,
     434,   435,   435,   436,   437,   437,   438,   438,   439,   440,
     440,   441,   441,   442,   442,   443,   444,   444,   445,   445,
     445,   446,   446,   447,   447,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   449,   449,   450,   450,   450,   450,
     451,   451,   451,   451,   451,   451,   452,   453,   453,   453,
     453,   454,   455,   456,   457,   458,   459,   460,   460,   461,
     461,   461,   462,   463,   463,   464,   464,   464,   464,   464,
     464,   465,   466,   466,   467,   467,   468,   468,   469,   469,
     469,   469,   469,   470,   471,   471,   472,   472,   472,   472,
     473,   474,   474,   475,   476,   477,   477,   478,   478,   479,
     479,   480,   480,   480,   480,   481,   481,   481,   481,   481,
     481,   481,   481,   481,   481,   481,   481,   481,   481,   481,
     482,   482,   482,   482,   483,   483,   483,   483,   483,   484,
     484,   485,   486,   486,   487,   488,   488,   488,   489,   489,
     490,   491,   491,   492,   493,   494,   495,   495,   496,   497,
     497,   497,   497,   498,   499,   500,   500,   500,   501,   501,
     502,   502,   502,   502,   502,   502,   503,   503,   503,   504,
     504,   505,   505,   506,   506,   507,   507,   508,   508,   509,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   512,
     513,   514,   515,   516,   516,   517,   518,   519,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   520,
     520,   521,   521,   521,   522,   523,   523,   523,   523,   524,
     524,   524,   525,   526,   526,   526,   526,   526,   526,   526,
     526,   527,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   541,   541,   542,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   552,   552,   553,   553,   553,   555,   554,   556,   557,
     557,   557,   557,   557,   557,   557,   557,   557,   557,   557,
     557,   557,   557,   557,   558,   559,   559,   560,   560,   561,
     562,   562,   563,   564,   564,   565,   567,   566,   568,   568,
     569,   569,   570,   570,   571,   572,   572,   572,   572,   572,
     572,   573,   573,   573,   573,   573,   574,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   576,   576,   576,
     576,   577,   577,   577,   578,   578,   578,   578,   578,   578,
     578,   578,   579,   579,   579,   579,   579,   580,   580,   580,
     580,   580,   581,   581,   582,   582,   583,   584,   584,   584,
     584,   585,   585,   586,   586,   586,   587,   587,   588,   588,
     589,   589,   589,   589,   589,   589,   590,   590,   590,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   592,
     592,   592,   592,   593,   594,   595,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   597,
     597,   597,   597,   597,   597,   597,   598,   598,   598,   598,
     598,   598,   599,   600,   600,   600,   601,   601,   602,   602,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   604,   605,   605,   605,
     605,   606,   606,   607,   608,   609,   610,   610,   610,   610,
     610,   610,   610,   610,   611,   611,   611,   611,   611,   611,
     612,   612,   613,   613,   614,   615,   616,   616,   616,   617,
     617,   618,   618,   619,   620,   621,   622,   622,   622,   623,
     623,   624,   624,   625,   625,   625,   625,   625,   625,   625,
     625,   625,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   626,   626,   626,   626,   626,   626,
     626,   626,   626,   626,   627,   628,   628,   629,   629,   629,
     629,   629,   629,   629,   629,   629,   630,   631,   632,   632,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   634,
     633,   635,   633,   633,   633,   633,   636,   636,   637,   638,
     638,   639,   639,   639,   640,   640,   641,   641,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   643,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   645,
     645,   646,   647,   648,   648,   648,   649,   649,   650,   650,
     651,   652,   653,   653,   655,   654,   656,   656,   657,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   668,   669,
     669,   669,   669,   669,   670,   671,   671,   671,   671,   671,
     672,   672,   673,   674,   675,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     677,   677,   677,   677,   678,   678,   679,   679,   680,   681,
     682,   683,   684,   684,   684,   684,   684,   685,   686,   686,
     686,   687,   687,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   689,   689,   690,   690,   691,   691,   692,   693,
     693,   693,   693,   693,   693,   693,   693,   693,   693,   693,
     693,   693,   693,   693,   693,   694,   694,   694,   694,   694,
     694,   694,   694,   694,   694,   694,   694,   694,   694,   694,
     694,   694,   694,   694,   694,   694,   694,   694,   694,   694,
     694,   694,   694,   694,   694,   694,   694,   694,   694,   694,
     694,   694,   694,   694,   694,   694,   694,   694,   694,   694,
     694,   694,   694,   694,   695,   695,   695,   695,   695,   695,
     695,   695,   695,   696,   696,   696,   696,   697,   697,   697,
     698,   698,   698,   698,   698,   698,   698,   698,   698,   698,
     698,   698,   698,   698,   698,   698,   698,   698,   698,   698,
     698,   698,   698,   698,   698,   698,   698,   698,   698,   698,
     698,   698,   698,   698,   698,   698,   698,   698,   698,   698,
     698,   698,   698,   698,   698,   698,   698,   698,   698,   698
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     5,     4,     2,     3,     3,     1,     2,     3,
       2,     4,     3,     2,     3,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     3,     4,     2,     2,     1,     0,
       2,     3,     1,     0,     1,     2,     0,     2,     0,     1,
       3,     0,     0,     2,     0,     3,     0,     3,     0,     3,
       3,     4,     6,     6,     6,     7,     6,     7,     5,     0,
       2,     3,     2,     3,     3,     2,     3,     2,     2,     3,
       3,     5,     4,     4,     2,     1,     2,     4,     2,     2,
       0,     3,     5,     0,     0,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     4,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     4,     6,
       6,     2,     3,     3,     5,     5,     4,     2,     3,     3,
       3,     1,     2,     4,     3,     3,     3,     2,     2,     2,
       2,     2,     1,     3,     0,     2,     0,     3,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     1,     2,     2,
       2,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 826 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 827 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 840 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4110 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 851 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 872 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 880 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 904 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4217 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 908 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 924 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 932 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 936 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 957 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 962 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 967 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 972 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 973 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 979 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 980 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4356 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 981 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4362 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 982 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 984 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 991 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 992 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4402 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1004 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1008 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1009 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1010 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1011 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1012 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1023 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1024 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1025 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1026 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1035 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1038 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1045 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1048 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1051 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1054 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1062 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4558 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1082 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1083 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1094 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1095 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1096 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1108 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1117 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1131 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1146 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4660 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1151 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4672 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1152 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4678 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1154 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1183 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1184 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1185 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1186 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1191 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1198 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1202 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1210 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4765 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1216 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1235 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1241 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1245 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1254 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1265 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4840 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1269 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1270 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1273 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1275 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1276 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1277 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1278 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); }
#line 4900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1279 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1280 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1281 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1293 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1294 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1295 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4977 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1318 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1319 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1327 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1336 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1341 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 5038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1342 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 5044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1356 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 5050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1370 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1371 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1377 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1387 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5097 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1405 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1407 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1416 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5127 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1417 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1418 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1419 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1420 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1421 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1428 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1429 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1434 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1438 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1480 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1481 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1483 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1484 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1486 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1487 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1488 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1492 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 5275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 5281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 5287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 5293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1496 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 5299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1497 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1498 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1500 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1501 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1508 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1511 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1514 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1517 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1521 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1525 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1528 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1532 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1535 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1546 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1553 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1558 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1563 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1568 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1572 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1580 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1589 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1597 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5503 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1601 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1608 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1610 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1616 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1619 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1626 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1637 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1645 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1646 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1647 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1653 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1656 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1659 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1660 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1661 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1662 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1663 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1664 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1665 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1670 "cf-parse.y" /* yacc.c:1646  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1675 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1684 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1691 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1698 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1706 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1708 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1710 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1712 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1714 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1716 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1718 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1720 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1723 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1726 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1732 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1733 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1734 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1738 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1739 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1746 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1748 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1750 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1752 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1754 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1756 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1760 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1764 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1770 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1771 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1772 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1776 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1777 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1786 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1787 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1796 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1800 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1801 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1802 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1805 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1806 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 5957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1808 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1809 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1813 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 5993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1814 "cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1847 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 6036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1848 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1863 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1872 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1880 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1901 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6109 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 6115 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1906 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1918 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1943 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1955 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1969 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1971 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1972 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1984 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1988 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1997 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1998 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2005 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2030 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2060 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2070 "cf-parse.y" /* yacc.c:1646  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2081 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2089 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2101 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2111 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2121 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2122 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2128 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2129 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2130 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2131 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2132 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2134 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2139 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2156 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2190 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 6745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2191 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2192 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 6763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2194 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 6769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2195 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 6775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 6781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 6787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2198 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 6793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2199 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 6799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2203 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2204 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2205 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2206 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2207 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2208 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2209 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2210 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2211 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2214 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2215 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2216 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2217 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 6895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2219 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2221 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 6925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 6931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 6937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2235 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 6979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2256 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2259 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2281 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 7063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2282 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 7069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2283 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 7075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2284 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 7081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 7087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2286 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 7093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2290 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2293 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2294 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2295 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2303 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2317 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2318 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2322 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2327 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2335 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2343 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2348 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7211 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2352 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2367 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2368 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2376 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2377 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2387 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2428 "cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2451 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2452 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2453 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2454 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    {}
#line 7395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2460 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2461 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2462 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2464 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2482 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7443 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2487 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7455 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2492 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2493 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2497 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7473 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7479 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2521 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2526 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
#line 7533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2559 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2560 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2565 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2569 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 7569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 7575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2571 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 7581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2572 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 7587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2573 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 7593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2574 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 7599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 7605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 7611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 7617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2592 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2596 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2597 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2598 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2599 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2602 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2603 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2604 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2605 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2606 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2607 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2608 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2619 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2620 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2622 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2623 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 7832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2624 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2625 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2626 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2628 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2630 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2643 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 7927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2645 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2646 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2647 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2648 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2649 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2679 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2680 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2681 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2683 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2704 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 8059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2713 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2715 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 8077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2716 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2718 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2719 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2720 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2721 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2722 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 8119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2723 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 8125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2735 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2749 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2750 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2751 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2755 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2756 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2766 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2767 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2769 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2770 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2771 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2772 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2773 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8247 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2800 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2801 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2802 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2807 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2808 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2809 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2810 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2811 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2813 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2814 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2815 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2816 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2824 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2825 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2826 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2829 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2830 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2831 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2832 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2833 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2834 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2835 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2846 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2856 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2857 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2866 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2903 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2921 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2930 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2938 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2941 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2946 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2953 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2956 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2960 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2961 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2962 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 2963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 2965 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 2966 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 2972 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 2981 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 2986 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 2987 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 2994 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3007 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3008 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3009 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3023 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3046 "cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3076 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3077 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3078 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3079 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3081 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3082 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3086 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3087 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 8847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3088 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 8853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3089 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 8859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3090 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 8865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3091 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 8871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3092 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 8877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3093 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3094 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 8889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3095 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 8895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3096 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 8901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3097 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 8907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3098 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 8913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3099 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 8919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3100 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 8925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3101 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3102 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 8937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3103 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 8943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 8949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 8955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3109 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 8967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3131 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3134 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 8979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3140 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3149 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3150 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3151 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 9006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3154 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3164 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3173 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3183 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 9055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3184 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3188 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3193 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3199 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3202 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3207 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3208 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3209 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3210 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3211 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3215 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 9135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3216 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3239 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 9153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3239 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 9159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 9189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 9195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 9201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 9207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 9213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 9219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 9225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 9231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 9237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 9243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 9249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 9255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 9261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 9267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 9273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 9279 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 9285 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 9291 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 9297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 943:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 9303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 9309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 9315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 9321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 9327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 9333 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 9339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 3243 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3243 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 9351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3244 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 9357 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3245 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 9363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 3246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 9369 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 9375 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 9381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 3249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 9387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 958:
#line 3250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 9393 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 959:
#line 3251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 9399 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 960:
#line 3252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 9405 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 961:
#line 3253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 9411 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 962:
#line 3254 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 9417 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 963:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 9423 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 964:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 9429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 965:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 9435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 966:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 9441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 967:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 9447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 968:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 9453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 9459 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 9463 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3257 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

